/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "core/cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "daemonize.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLOCKLIST
	#define IF_DST_BLOCKLIST(x) x
#else
	#define IF_DST_BLOCKLIST(x) warn("dst blocklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer than using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;
static struct rval_expr* rve_tmp = NULL;
static socket_attrs_t tmp_sa;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 240 "core/cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_FORWARD = 3,                    /* FORWARD  */
  YYSYMBOL_FORWARD_TCP = 4,                /* FORWARD_TCP  */
  YYSYMBOL_FORWARD_TLS = 5,                /* FORWARD_TLS  */
  YYSYMBOL_FORWARD_SCTP = 6,               /* FORWARD_SCTP  */
  YYSYMBOL_FORWARD_UDP = 7,                /* FORWARD_UDP  */
  YYSYMBOL_EXIT = 8,                       /* EXIT  */
  YYSYMBOL_DROP = 9,                       /* DROP  */
  YYSYMBOL_RETURN = 10,                    /* RETURN  */
  YYSYMBOL_RETURN_MODE = 11,               /* RETURN_MODE  */
  YYSYMBOL_BREAK = 12,                     /* BREAK  */
  YYSYMBOL_LOG_TOK = 13,                   /* LOG_TOK  */
  YYSYMBOL_ERROR = 14,                     /* ERROR  */
  YYSYMBOL_ROUTE = 15,                     /* ROUTE  */
  YYSYMBOL_ROUTE_REQUEST = 16,             /* ROUTE_REQUEST  */
  YYSYMBOL_ROUTE_FAILURE = 17,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 18,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_REPLY = 19,               /* ROUTE_REPLY  */
  YYSYMBOL_ROUTE_BRANCH = 20,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_SEND = 21,                /* ROUTE_SEND  */
  YYSYMBOL_ROUTE_EVENT = 22,               /* ROUTE_EVENT  */
  YYSYMBOL_EXEC = 23,                      /* EXEC  */
  YYSYMBOL_SET_HOST = 24,                  /* SET_HOST  */
  YYSYMBOL_SET_HOSTPORT = 25,              /* SET_HOSTPORT  */
  YYSYMBOL_SET_HOSTPORTTRANS = 26,         /* SET_HOSTPORTTRANS  */
  YYSYMBOL_PREFIX = 27,                    /* PREFIX  */
  YYSYMBOL_STRIP = 28,                     /* STRIP  */
  YYSYMBOL_STRIP_TAIL = 29,                /* STRIP_TAIL  */
  YYSYMBOL_SET_USERPHONE = 30,             /* SET_USERPHONE  */
  YYSYMBOL_APPEND_BRANCH = 31,             /* APPEND_BRANCH  */
  YYSYMBOL_REMOVE_BRANCH = 32,             /* REMOVE_BRANCH  */
  YYSYMBOL_CLEAR_BRANCHES = 33,            /* CLEAR_BRANCHES  */
  YYSYMBOL_SET_USER = 34,                  /* SET_USER  */
  YYSYMBOL_SET_USERPASS = 35,              /* SET_USERPASS  */
  YYSYMBOL_SET_PORT = 36,                  /* SET_PORT  */
  YYSYMBOL_SET_URI = 37,                   /* SET_URI  */
  YYSYMBOL_REVERT_URI = 38,                /* REVERT_URI  */
  YYSYMBOL_FORCE_RPORT = 39,               /* FORCE_RPORT  */
  YYSYMBOL_ADD_LOCAL_RPORT = 40,           /* ADD_LOCAL_RPORT  */
  YYSYMBOL_LOCAL_RPORT = 41,               /* LOCAL_RPORT  */
  YYSYMBOL_FORCE_TCP_ALIAS = 42,           /* FORCE_TCP_ALIAS  */
  YYSYMBOL_UDP_MTU = 43,                   /* UDP_MTU  */
  YYSYMBOL_UDP_MTU_TRY_PROTO = 44,         /* UDP_MTU_TRY_PROTO  */
  YYSYMBOL_UDP4_RAW = 45,                  /* UDP4_RAW  */
  YYSYMBOL_UDP4_RAW_MTU = 46,              /* UDP4_RAW_MTU  */
  YYSYMBOL_UDP4_RAW_TTL = 47,              /* UDP4_RAW_TTL  */
  YYSYMBOL_IF = 48,                        /* IF  */
  YYSYMBOL_ELSE = 49,                      /* ELSE  */
  YYSYMBOL_SET_ADV_ADDRESS = 50,           /* SET_ADV_ADDRESS  */
  YYSYMBOL_SET_ADV_PORT = 51,              /* SET_ADV_PORT  */
  YYSYMBOL_FORCE_SEND_SOCKET = 52,         /* FORCE_SEND_SOCKET  */
  YYSYMBOL_SET_FWD_NO_CONNECT = 53,        /* SET_FWD_NO_CONNECT  */
  YYSYMBOL_SET_RPL_NO_CONNECT = 54,        /* SET_RPL_NO_CONNECT  */
  YYSYMBOL_SET_FWD_CLOSE = 55,             /* SET_FWD_CLOSE  */
  YYSYMBOL_SET_RPL_CLOSE = 56,             /* SET_RPL_CLOSE  */
  YYSYMBOL_SWITCH = 57,                    /* SWITCH  */
  YYSYMBOL_CASE = 58,                      /* CASE  */
  YYSYMBOL_DEFAULT = 59,                   /* DEFAULT  */
  YYSYMBOL_WHILE = 60,                     /* WHILE  */
  YYSYMBOL_CFG_SELECT = 61,                /* CFG_SELECT  */
  YYSYMBOL_CFG_RESET = 62,                 /* CFG_RESET  */
  YYSYMBOL_URIHOST = 63,                   /* URIHOST  */
  YYSYMBOL_URIPORT = 64,                   /* URIPORT  */
  YYSYMBOL_MAX_LEN = 65,                   /* MAX_LEN  */
  YYSYMBOL_SETFLAG = 66,                   /* SETFLAG  */
  YYSYMBOL_RESETFLAG = 67,                 /* RESETFLAG  */
  YYSYMBOL_ISFLAGSET = 68,                 /* ISFLAGSET  */
  YYSYMBOL_SETAVPFLAG = 69,                /* SETAVPFLAG  */
  YYSYMBOL_RESETAVPFLAG = 70,              /* RESETAVPFLAG  */
  YYSYMBOL_ISAVPFLAGSET = 71,              /* ISAVPFLAGSET  */
  YYSYMBOL_METHOD = 72,                    /* METHOD  */
  YYSYMBOL_URI = 73,                       /* URI  */
  YYSYMBOL_FROM_URI = 74,                  /* FROM_URI  */
  YYSYMBOL_TO_URI = 75,                    /* TO_URI  */
  YYSYMBOL_SRCIP = 76,                     /* SRCIP  */
  YYSYMBOL_SRCPORT = 77,                   /* SRCPORT  */
  YYSYMBOL_DSTIP = 78,                     /* DSTIP  */
  YYSYMBOL_DSTPORT = 79,                   /* DSTPORT  */
  YYSYMBOL_TOIP = 80,                      /* TOIP  */
  YYSYMBOL_TOPORT = 81,                    /* TOPORT  */
  YYSYMBOL_SNDIP = 82,                     /* SNDIP  */
  YYSYMBOL_SNDPORT = 83,                   /* SNDPORT  */
  YYSYMBOL_SNDPROTO = 84,                  /* SNDPROTO  */
  YYSYMBOL_SNDAF = 85,                     /* SNDAF  */
  YYSYMBOL_PROTO = 86,                     /* PROTO  */
  YYSYMBOL_AF = 87,                        /* AF  */
  YYSYMBOL_MYSELF = 88,                    /* MYSELF  */
  YYSYMBOL_MSGLEN = 89,                    /* MSGLEN  */
  YYSYMBOL_UDP = 90,                       /* UDP  */
  YYSYMBOL_TCP = 91,                       /* TCP  */
  YYSYMBOL_TLS = 92,                       /* TLS  */
  YYSYMBOL_SCTP = 93,                      /* SCTP  */
  YYSYMBOL_WS = 94,                        /* WS  */
  YYSYMBOL_WSS = 95,                       /* WSS  */
  YYSYMBOL_DEBUG_V = 96,                   /* DEBUG_V  */
  YYSYMBOL_FORK = 97,                      /* FORK  */
  YYSYMBOL_FORK_DELAY = 98,                /* FORK_DELAY  */
  YYSYMBOL_MODINIT_DELAY = 99,             /* MODINIT_DELAY  */
  YYSYMBOL_LOGSTDERROR = 100,              /* LOGSTDERROR  */
  YYSYMBOL_LOGFACILITY = 101,              /* LOGFACILITY  */
  YYSYMBOL_LOGNAME = 102,                  /* LOGNAME  */
  YYSYMBOL_LOGCOLOR = 103,                 /* LOGCOLOR  */
  YYSYMBOL_LOGPREFIX = 104,                /* LOGPREFIX  */
  YYSYMBOL_LOGPREFIXMODE = 105,            /* LOGPREFIXMODE  */
  YYSYMBOL_LOGENGINETYPE = 106,            /* LOGENGINETYPE  */
  YYSYMBOL_LOGENGINEDATA = 107,            /* LOGENGINEDATA  */
  YYSYMBOL_XAVPVIAPARAMS = 108,            /* XAVPVIAPARAMS  */
  YYSYMBOL_XAVPVIAFIELDS = 109,            /* XAVPVIAFIELDS  */
  YYSYMBOL_LISTEN = 110,                   /* LISTEN  */
  YYSYMBOL_ADVERTISE = 111,                /* ADVERTISE  */
  YYSYMBOL_VIRTUAL = 112,                  /* VIRTUAL  */
  YYSYMBOL_STRNAME = 113,                  /* STRNAME  */
  YYSYMBOL_ALIAS = 114,                    /* ALIAS  */
  YYSYMBOL_SR_AUTO_ALIASES = 115,          /* SR_AUTO_ALIASES  */
  YYSYMBOL_DOMAIN = 116,                   /* DOMAIN  */
  YYSYMBOL_SR_AUTO_DOMAINS = 117,          /* SR_AUTO_DOMAINS  */
  YYSYMBOL_DNS = 118,                      /* DNS  */
  YYSYMBOL_REV_DNS = 119,                  /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 120,             /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 121,            /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_SRV_LB = 122,               /* DNS_SRV_LB  */
  YYSYMBOL_DNS_UDP_PREF = 123,             /* DNS_UDP_PREF  */
  YYSYMBOL_DNS_TCP_PREF = 124,             /* DNS_TCP_PREF  */
  YYSYMBOL_DNS_TLS_PREF = 125,             /* DNS_TLS_PREF  */
  YYSYMBOL_DNS_SCTP_PREF = 126,            /* DNS_SCTP_PREF  */
  YYSYMBOL_DNS_RETR_TIME = 127,            /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_SLOW_QUERY_MS = 128,        /* DNS_SLOW_QUERY_MS  */
  YYSYMBOL_DNS_RETR_NO = 129,              /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 130,           /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 131,           /* DNS_USE_SEARCH  */
  YYSYMBOL_DNS_SEARCH_FMATCH = 132,        /* DNS_SEARCH_FMATCH  */
  YYSYMBOL_DNS_NAPTR_IGNORE_RFC = 133,     /* DNS_NAPTR_IGNORE_RFC  */
  YYSYMBOL_DNS_CACHE_INIT = 134,           /* DNS_CACHE_INIT  */
  YYSYMBOL_DNS_USE_CACHE = 135,            /* DNS_USE_CACHE  */
  YYSYMBOL_DNS_USE_FAILOVER = 136,         /* DNS_USE_FAILOVER  */
  YYSYMBOL_DNS_CACHE_FLAGS = 137,          /* DNS_CACHE_FLAGS  */
  YYSYMBOL_DNS_CACHE_NEG_TTL = 138,        /* DNS_CACHE_NEG_TTL  */
  YYSYMBOL_DNS_CACHE_MIN_TTL = 139,        /* DNS_CACHE_MIN_TTL  */
  YYSYMBOL_DNS_CACHE_MAX_TTL = 140,        /* DNS_CACHE_MAX_TTL  */
  YYSYMBOL_DNS_CACHE_MEM = 141,            /* DNS_CACHE_MEM  */
  YYSYMBOL_DNS_CACHE_GC_INT = 142,         /* DNS_CACHE_GC_INT  */
  YYSYMBOL_DNS_CACHE_DEL_NONEXP = 143,     /* DNS_CACHE_DEL_NONEXP  */
  YYSYMBOL_DNS_CACHE_REC_PREF = 144,       /* DNS_CACHE_REC_PREF  */
  YYSYMBOL_AUTO_BIND_IPV6 = 145,           /* AUTO_BIND_IPV6  */
  YYSYMBOL_BIND_IPV6_LINK_LOCAL = 146,     /* BIND_IPV6_LINK_LOCAL  */
  YYSYMBOL_IPV6_HEX_STYLE = 147,           /* IPV6_HEX_STYLE  */
  YYSYMBOL_DST_BLST_INIT = 148,            /* DST_BLST_INIT  */
  YYSYMBOL_USE_DST_BLST = 149,             /* USE_DST_BLST  */
  YYSYMBOL_DST_BLST_MEM = 150,             /* DST_BLST_MEM  */
  YYSYMBOL_DST_BLST_TTL = 151,             /* DST_BLST_TTL  */
  YYSYMBOL_DST_BLST_GC_INT = 152,          /* DST_BLST_GC_INT  */
  YYSYMBOL_DST_BLST_UDP_IMASK = 153,       /* DST_BLST_UDP_IMASK  */
  YYSYMBOL_DST_BLST_TCP_IMASK = 154,       /* DST_BLST_TCP_IMASK  */
  YYSYMBOL_DST_BLST_TLS_IMASK = 155,       /* DST_BLST_TLS_IMASK  */
  YYSYMBOL_DST_BLST_SCTP_IMASK = 156,      /* DST_BLST_SCTP_IMASK  */
  YYSYMBOL_IP_FREE_BIND = 157,             /* IP_FREE_BIND  */
  YYSYMBOL_PORT = 158,                     /* PORT  */
  YYSYMBOL_STAT = 159,                     /* STAT  */
  YYSYMBOL_STATS_NAMESEP = 160,            /* STATS_NAMESEP  */
  YYSYMBOL_CHILDREN = 161,                 /* CHILDREN  */
  YYSYMBOL_SOCKET = 162,                   /* SOCKET  */
  YYSYMBOL_BIND = 163,                     /* BIND  */
  YYSYMBOL_WORKERS = 164,                  /* WORKERS  */
  YYSYMBOL_SOCKET_WORKERS = 165,           /* SOCKET_WORKERS  */
  YYSYMBOL_ASYNC_WORKERS = 166,            /* ASYNC_WORKERS  */
  YYSYMBOL_ASYNC_USLEEP = 167,             /* ASYNC_USLEEP  */
  YYSYMBOL_ASYNC_NONBLOCK = 168,           /* ASYNC_NONBLOCK  */
  YYSYMBOL_ASYNC_WORKERS_GROUP = 169,      /* ASYNC_WORKERS_GROUP  */
  YYSYMBOL_CHECK_VIA = 170,                /* CHECK_VIA  */
  YYSYMBOL_PHONE2TEL = 171,                /* PHONE2TEL  */
  YYSYMBOL_MEMLOG = 172,                   /* MEMLOG  */
  YYSYMBOL_MEMDBG = 173,                   /* MEMDBG  */
  YYSYMBOL_MEMSUM = 174,                   /* MEMSUM  */
  YYSYMBOL_MEMSAFETY = 175,                /* MEMSAFETY  */
  YYSYMBOL_MEMJOIN = 176,                  /* MEMJOIN  */
  YYSYMBOL_MEMSTATUSMODE = 177,            /* MEMSTATUSMODE  */
  YYSYMBOL_SIP_PARSER_LOG_ONELINE = 178,   /* SIP_PARSER_LOG_ONELINE  */
  YYSYMBOL_SIP_PARSER_LOG = 179,           /* SIP_PARSER_LOG  */
  YYSYMBOL_SIP_PARSER_MODE = 180,          /* SIP_PARSER_MODE  */
  YYSYMBOL_CORELOG = 181,                  /* CORELOG  */
  YYSYMBOL_SIP_WARNING = 182,              /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 183,         /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 184,            /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 185,        /* USER_AGENT_HEADER  */
  YYSYMBOL_REPLY_TO_VIA = 186,             /* REPLY_TO_VIA  */
  YYSYMBOL_LOADMODULE = 187,               /* LOADMODULE  */
  YYSYMBOL_LOADMODULEX = 188,              /* LOADMODULEX  */
  YYSYMBOL_LOADPATH = 189,                 /* LOADPATH  */
  YYSYMBOL_MODPARAM = 190,                 /* MODPARAM  */
  YYSYMBOL_MODPARAMX = 191,                /* MODPARAMX  */
  YYSYMBOL_CFGENGINE = 192,                /* CFGENGINE  */
  YYSYMBOL_MAXBUFFER = 193,                /* MAXBUFFER  */
  YYSYMBOL_SQL_BUFFER_SIZE = 194,          /* SQL_BUFFER_SIZE  */
  YYSYMBOL_MSG_RECV_MAX_SIZE = 195,        /* MSG_RECV_MAX_SIZE  */
  YYSYMBOL_TCP_MSG_READ_TIMEOUT = 196,     /* TCP_MSG_READ_TIMEOUT  */
  YYSYMBOL_TCP_MSG_DATA_TIMEOUT = 197,     /* TCP_MSG_DATA_TIMEOUT  */
  YYSYMBOL_TCP_ACCEPT_IPLIMIT = 198,       /* TCP_ACCEPT_IPLIMIT  */
  YYSYMBOL_TCP_CHECK_TIMER = 199,          /* TCP_CHECK_TIMER  */
  YYSYMBOL_USER = 200,                     /* USER  */
  YYSYMBOL_GROUP = 201,                    /* GROUP  */
  YYSYMBOL_CHROOT = 202,                   /* CHROOT  */
  YYSYMBOL_WDIR = 203,                     /* WDIR  */
  YYSYMBOL_RUNDIR = 204,                   /* RUNDIR  */
  YYSYMBOL_MHOMED = 205,                   /* MHOMED  */
  YYSYMBOL_DISABLE_TCP = 206,              /* DISABLE_TCP  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 207,       /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_ACCEPT_UNIQUE = 208,        /* TCP_ACCEPT_UNIQUE  */
  YYSYMBOL_TCP_CONNECTION_MATCH = 209,     /* TCP_CONNECTION_MATCH  */
  YYSYMBOL_TCP_CHILDREN = 210,             /* TCP_CHILDREN  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 211,      /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_SEND_TIMEOUT = 212,         /* TCP_SEND_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 213,         /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_POLL_METHOD = 214,          /* TCP_POLL_METHOD  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 215,      /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TLS_MAX_CONNECTIONS = 216,      /* TLS_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_CONNECT = 217,           /* TCP_NO_CONNECT  */
  YYSYMBOL_TCP_SOURCE_IPV4 = 218,          /* TCP_SOURCE_IPV4  */
  YYSYMBOL_TCP_SOURCE_IPV6 = 219,          /* TCP_SOURCE_IPV6  */
  YYSYMBOL_TCP_OPT_FD_CACHE = 220,         /* TCP_OPT_FD_CACHE  */
  YYSYMBOL_TCP_OPT_BUF_WRITE = 221,        /* TCP_OPT_BUF_WRITE  */
  YYSYMBOL_TCP_OPT_CONN_WQ_MAX = 222,      /* TCP_OPT_CONN_WQ_MAX  */
  YYSYMBOL_TCP_OPT_WQ_MAX = 223,           /* TCP_OPT_WQ_MAX  */
  YYSYMBOL_TCP_OPT_RD_BUF = 224,           /* TCP_OPT_RD_BUF  */
  YYSYMBOL_TCP_OPT_WQ_BLK = 225,           /* TCP_OPT_WQ_BLK  */
  YYSYMBOL_TCP_OPT_DEFER_ACCEPT = 226,     /* TCP_OPT_DEFER_ACCEPT  */
  YYSYMBOL_TCP_OPT_DELAYED_ACK = 227,      /* TCP_OPT_DELAYED_ACK  */
  YYSYMBOL_TCP_OPT_SYNCNT = 228,           /* TCP_OPT_SYNCNT  */
  YYSYMBOL_TCP_OPT_LINGER2 = 229,          /* TCP_OPT_LINGER2  */
  YYSYMBOL_TCP_OPT_KEEPALIVE = 230,        /* TCP_OPT_KEEPALIVE  */
  YYSYMBOL_TCP_OPT_KEEPIDLE = 231,         /* TCP_OPT_KEEPIDLE  */
  YYSYMBOL_TCP_OPT_KEEPINTVL = 232,        /* TCP_OPT_KEEPINTVL  */
  YYSYMBOL_TCP_OPT_KEEPCNT = 233,          /* TCP_OPT_KEEPCNT  */
  YYSYMBOL_TCP_OPT_CRLF_PING = 234,        /* TCP_OPT_CRLF_PING  */
  YYSYMBOL_TCP_OPT_ACCEPT_NO_CL = 235,     /* TCP_OPT_ACCEPT_NO_CL  */
  YYSYMBOL_TCP_OPT_ACCEPT_HEP3 = 236,      /* TCP_OPT_ACCEPT_HEP3  */
  YYSYMBOL_TCP_OPT_ACCEPT_HAPROXY = 237,   /* TCP_OPT_ACCEPT_HAPROXY  */
  YYSYMBOL_TCP_OPT_CLOSE_RST = 238,        /* TCP_OPT_CLOSE_RST  */
  YYSYMBOL_TCP_CLONE_RCVBUF = 239,         /* TCP_CLONE_RCVBUF  */
  YYSYMBOL_TCP_REUSE_PORT = 240,           /* TCP_REUSE_PORT  */
  YYSYMBOL_TCP_WAIT_DATA = 241,            /* TCP_WAIT_DATA  */
  YYSYMBOL_TCP_SCRIPT_MODE = 242,          /* TCP_SCRIPT_MODE  */
  YYSYMBOL_DISABLE_TLS = 243,              /* DISABLE_TLS  */
  YYSYMBOL_ENABLE_TLS = 244,               /* ENABLE_TLS  */
  YYSYMBOL_TLSLOG = 245,                   /* TLSLOG  */
  YYSYMBOL_TLS_PORT_NO = 246,              /* TLS_PORT_NO  */
  YYSYMBOL_TLS_METHOD = 247,               /* TLS_METHOD  */
  YYSYMBOL_TLS_HANDSHAKE_TIMEOUT = 248,    /* TLS_HANDSHAKE_TIMEOUT  */
  YYSYMBOL_TLS_SEND_TIMEOUT = 249,         /* TLS_SEND_TIMEOUT  */
  YYSYMBOL_SSLv23 = 250,                   /* SSLv23  */
  YYSYMBOL_SSLv2 = 251,                    /* SSLv2  */
  YYSYMBOL_SSLv3 = 252,                    /* SSLv3  */
  YYSYMBOL_TLSv1 = 253,                    /* TLSv1  */
  YYSYMBOL_TLS_VERIFY = 254,               /* TLS_VERIFY  */
  YYSYMBOL_TLS_REQUIRE_CERTIFICATE = 255,  /* TLS_REQUIRE_CERTIFICATE  */
  YYSYMBOL_TLS_CERTIFICATE = 256,          /* TLS_CERTIFICATE  */
  YYSYMBOL_TLS_PRIVATE_KEY = 257,          /* TLS_PRIVATE_KEY  */
  YYSYMBOL_TLS_CA_LIST = 258,              /* TLS_CA_LIST  */
  YYSYMBOL_DISABLE_SCTP = 259,             /* DISABLE_SCTP  */
  YYSYMBOL_ENABLE_SCTP = 260,              /* ENABLE_SCTP  */
  YYSYMBOL_SCTP_CHILDREN = 261,            /* SCTP_CHILDREN  */
  YYSYMBOL_ADVERTISED_ADDRESS = 262,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 263,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 264,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 265,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_SHM_MEM_SZ = 266,               /* SHM_MEM_SZ  */
  YYSYMBOL_SHM_FORCE_ALLOC = 267,          /* SHM_FORCE_ALLOC  */
  YYSYMBOL_MLOCK_PAGES = 268,              /* MLOCK_PAGES  */
  YYSYMBOL_REAL_TIME = 269,                /* REAL_TIME  */
  YYSYMBOL_RT_PRIO = 270,                  /* RT_PRIO  */
  YYSYMBOL_RT_POLICY = 271,                /* RT_POLICY  */
  YYSYMBOL_RT_TIMER1_PRIO = 272,           /* RT_TIMER1_PRIO  */
  YYSYMBOL_RT_TIMER1_POLICY = 273,         /* RT_TIMER1_POLICY  */
  YYSYMBOL_RT_TIMER2_PRIO = 274,           /* RT_TIMER2_PRIO  */
  YYSYMBOL_RT_TIMER2_POLICY = 275,         /* RT_TIMER2_POLICY  */
  YYSYMBOL_MCAST_LOOPBACK = 276,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 277,                /* MCAST_TTL  */
  YYSYMBOL_MCAST = 278,                    /* MCAST  */
  YYSYMBOL_TOS = 279,                      /* TOS  */
  YYSYMBOL_PMTU_DISCOVERY = 280,           /* PMTU_DISCOVERY  */
  YYSYMBOL_KILL_TIMEOUT = 281,             /* KILL_TIMEOUT  */
  YYSYMBOL_MAX_WLOOPS = 282,               /* MAX_WLOOPS  */
  YYSYMBOL_PVBUFSIZE = 283,                /* PVBUFSIZE  */
  YYSYMBOL_PVBUFSLOTS = 284,               /* PVBUFSLOTS  */
  YYSYMBOL_PVCACHELIMIT = 285,             /* PVCACHELIMIT  */
  YYSYMBOL_PVCACHEACTION = 286,            /* PVCACHEACTION  */
  YYSYMBOL_HTTP_REPLY_PARSE = 287,         /* HTTP_REPLY_PARSE  */
  YYSYMBOL_VERSION_TABLE_CFG = 288,        /* VERSION_TABLE_CFG  */
  YYSYMBOL_VERBOSE_STARTUP = 289,          /* VERBOSE_STARTUP  */
  YYSYMBOL_ROUTE_LOCKS_SIZE = 290,         /* ROUTE_LOCKS_SIZE  */
  YYSYMBOL_WAIT_WORKER1_MODE = 291,        /* WAIT_WORKER1_MODE  */
  YYSYMBOL_WAIT_WORKER1_TIME = 292,        /* WAIT_WORKER1_TIME  */
  YYSYMBOL_WAIT_WORKER1_USLEEP = 293,      /* WAIT_WORKER1_USLEEP  */
  YYSYMBOL_CFG_DESCRIPTION = 294,          /* CFG_DESCRIPTION  */
  YYSYMBOL_SERVER_ID = 295,                /* SERVER_ID  */
  YYSYMBOL_KEMI = 296,                     /* KEMI  */
  YYSYMBOL_ONSEND_ROUTE_CALLBACK = 297,    /* ONSEND_ROUTE_CALLBACK  */
  YYSYMBOL_REPLY_ROUTE_CALLBACK = 298,     /* REPLY_ROUTE_CALLBACK  */
  YYSYMBOL_EVENT_ROUTE_CALLBACK = 299,     /* EVENT_ROUTE_CALLBACK  */
  YYSYMBOL_RECEIVED_ROUTE_CALLBACK = 300,  /* RECEIVED_ROUTE_CALLBACK  */
  YYSYMBOL_RECEIVED_ROUTE_MODE = 301,      /* RECEIVED_ROUTE_MODE  */
  YYSYMBOL_PRE_ROUTING_CALLBACK = 302,     /* PRE_ROUTING_CALLBACK  */
  YYSYMBOL_MAX_RECURSIVE_LEVEL = 303,      /* MAX_RECURSIVE_LEVEL  */
  YYSYMBOL_MAX_BRANCHES_PARAM = 304,       /* MAX_BRANCHES_PARAM  */
  YYSYMBOL_LATENCY_CFG_LOG = 305,          /* LATENCY_CFG_LOG  */
  YYSYMBOL_LATENCY_LOG = 306,              /* LATENCY_LOG  */
  YYSYMBOL_LATENCY_LIMIT_DB = 307,         /* LATENCY_LIMIT_DB  */
  YYSYMBOL_LATENCY_LIMIT_ACTION = 308,     /* LATENCY_LIMIT_ACTION  */
  YYSYMBOL_LATENCY_LIMIT_CFG = 309,        /* LATENCY_LIMIT_CFG  */
  YYSYMBOL_RPC_EXEC_DELTA_CFG = 310,       /* RPC_EXEC_DELTA_CFG  */
  YYSYMBOL_MSG_TIME = 311,                 /* MSG_TIME  */
  YYSYMBOL_ONSEND_RT_REPLY = 312,          /* ONSEND_RT_REPLY  */
  YYSYMBOL_URI_HOST_EXTRA_CHARS = 313,     /* URI_HOST_EXTRA_CHARS  */
  YYSYMBOL_HDR_NAME_EXTRA_CHARS = 314,     /* HDR_NAME_EXTRA_CHARS  */
  YYSYMBOL_FLAGS_DECL = 315,               /* FLAGS_DECL  */
  YYSYMBOL_AVPFLAGS_DECL = 316,            /* AVPFLAGS_DECL  */
  YYSYMBOL_ATTR_MARK = 317,                /* ATTR_MARK  */
  YYSYMBOL_SELECT_MARK = 318,              /* SELECT_MARK  */
  YYSYMBOL_ATTR_FROM = 319,                /* ATTR_FROM  */
  YYSYMBOL_ATTR_TO = 320,                  /* ATTR_TO  */
  YYSYMBOL_ATTR_FROMURI = 321,             /* ATTR_FROMURI  */
  YYSYMBOL_ATTR_TOURI = 322,               /* ATTR_TOURI  */
  YYSYMBOL_ATTR_FROMUSER = 323,            /* ATTR_FROMUSER  */
  YYSYMBOL_ATTR_TOUSER = 324,              /* ATTR_TOUSER  */
  YYSYMBOL_ATTR_FROMDOMAIN = 325,          /* ATTR_FROMDOMAIN  */
  YYSYMBOL_ATTR_TODOMAIN = 326,            /* ATTR_TODOMAIN  */
  YYSYMBOL_ATTR_GLOBAL = 327,              /* ATTR_GLOBAL  */
  YYSYMBOL_ADDEQ = 328,                    /* ADDEQ  */
  YYSYMBOL_SUBST = 329,                    /* SUBST  */
  YYSYMBOL_SUBSTDEF = 330,                 /* SUBSTDEF  */
  YYSYMBOL_SUBSTDEFS = 331,                /* SUBSTDEFS  */
  YYSYMBOL_EQUAL = 332,                    /* EQUAL  */
  YYSYMBOL_LOG_OR = 333,                   /* LOG_OR  */
  YYSYMBOL_LOG_AND = 334,                  /* LOG_AND  */
  YYSYMBOL_BIN_OR = 335,                   /* BIN_OR  */
  YYSYMBOL_BIN_AND = 336,                  /* BIN_AND  */
  YYSYMBOL_BIN_XOR = 337,                  /* BIN_XOR  */
  YYSYMBOL_BIN_LSHIFT = 338,               /* BIN_LSHIFT  */
  YYSYMBOL_BIN_RSHIFT = 339,               /* BIN_RSHIFT  */
  YYSYMBOL_EQUAL_T = 340,                  /* EQUAL_T  */
  YYSYMBOL_DIFF = 341,                     /* DIFF  */
  YYSYMBOL_MATCH = 342,                    /* MATCH  */
  YYSYMBOL_INTEQ = 343,                    /* INTEQ  */
  YYSYMBOL_INTDIFF = 344,                  /* INTDIFF  */
  YYSYMBOL_STREQ = 345,                    /* STREQ  */
  YYSYMBOL_STRDIFF = 346,                  /* STRDIFF  */
  YYSYMBOL_GT = 347,                       /* GT  */
  YYSYMBOL_LT = 348,                       /* LT  */
  YYSYMBOL_GTE = 349,                      /* GTE  */
  YYSYMBOL_LTE = 350,                      /* LTE  */
  YYSYMBOL_PLUS = 351,                     /* PLUS  */
  YYSYMBOL_MINUS = 352,                    /* MINUS  */
  YYSYMBOL_STAR = 353,                     /* STAR  */
  YYSYMBOL_SLASH = 354,                    /* SLASH  */
  YYSYMBOL_MODULO = 355,                   /* MODULO  */
  YYSYMBOL_NOT = 356,                      /* NOT  */
  YYSYMBOL_UNARY = 357,                    /* UNARY  */
  YYSYMBOL_BIN_NOT = 358,                  /* BIN_NOT  */
  YYSYMBOL_DEFINED = 359,                  /* DEFINED  */
  YYSYMBOL_INTCAST = 360,                  /* INTCAST  */
  YYSYMBOL_STRCAST = 361,                  /* STRCAST  */
  YYSYMBOL_DOT = 362,                      /* DOT  */
  YYSYMBOL_STRLEN = 363,                   /* STRLEN  */
  YYSYMBOL_STREMPTY = 364,                 /* STREMPTY  */
  YYSYMBOL_SELVAL = 365,                   /* SELVAL  */
  YYSYMBOL_NUMBER = 366,                   /* NUMBER  */
  YYSYMBOL_ID = 367,                       /* ID  */
  YYSYMBOL_NUM_ID = 368,                   /* NUM_ID  */
  YYSYMBOL_STRING = 369,                   /* STRING  */
  YYSYMBOL_IPV6ADDR = 370,                 /* IPV6ADDR  */
  YYSYMBOL_PVAR = 371,                     /* PVAR  */
  YYSYMBOL_AVP_OR_PVAR = 372,              /* AVP_OR_PVAR  */
  YYSYMBOL_EVENT_RT_NAME = 373,            /* EVENT_RT_NAME  */
  YYSYMBOL_COMMA = 374,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 375,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 376,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 377,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 378,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 379,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 380,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 381,                   /* RBRACK  */
  YYSYMBOL_CR = 382,                       /* CR  */
  YYSYMBOL_COLON = 383,                    /* COLON  */
  YYSYMBOL_YYACCEPT = 384,                 /* $accept  */
  YYSYMBOL_cfg = 385,                      /* cfg  */
  YYSYMBOL_statements = 386,               /* statements  */
  YYSYMBOL_statement = 387,                /* statement  */
  YYSYMBOL_388_1 = 388,                    /* $@1  */
  YYSYMBOL_389_2 = 389,                    /* $@2  */
  YYSYMBOL_390_3 = 390,                    /* $@3  */
  YYSYMBOL_391_4 = 391,                    /* $@4  */
  YYSYMBOL_392_5 = 392,                    /* $@5  */
  YYSYMBOL_listen_id = 393,                /* listen_id  */
  YYSYMBOL_listen_id_lst = 394,            /* listen_id_lst  */
  YYSYMBOL_listen_id2 = 395,               /* listen_id2  */
  YYSYMBOL_proto = 396,                    /* proto  */
  YYSYMBOL_eqproto = 397,                  /* eqproto  */
  YYSYMBOL_port = 398,                     /* port  */
  YYSYMBOL_phostport = 399,                /* phostport  */
  YYSYMBOL_listen_phostport = 400,         /* listen_phostport  */
  YYSYMBOL_id_lst = 401,                   /* id_lst  */
  YYSYMBOL_intno = 402,                    /* intno  */
  YYSYMBOL_flags_decl = 403,               /* flags_decl  */
  YYSYMBOL_flag_list = 404,                /* flag_list  */
  YYSYMBOL_flag_spec = 405,                /* flag_spec  */
  YYSYMBOL_flag_name = 406,                /* flag_name  */
  YYSYMBOL_avpflags_decl = 407,            /* avpflags_decl  */
  YYSYMBOL_avpflag_list = 408,             /* avpflag_list  */
  YYSYMBOL_avpflag_spec = 409,             /* avpflag_spec  */
  YYSYMBOL_socket_lattr = 410,             /* socket_lattr  */
  YYSYMBOL_socket_lattrs = 411,            /* socket_lattrs  */
  YYSYMBOL_assign_stm = 412,               /* assign_stm  */
  YYSYMBOL_413_6 = 413,                    /* $@6  */
  YYSYMBOL_cfg_var_id = 414,               /* cfg_var_id  */
  YYSYMBOL_cfg_var_idn = 415,              /* cfg_var_idn  */
  YYSYMBOL_cfg_var = 416,                  /* cfg_var  */
  YYSYMBOL_module_stm = 417,               /* module_stm  */
  YYSYMBOL_ip = 418,                       /* ip  */
  YYSYMBOL_ipv4 = 419,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 420,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 421,                     /* ipv6  */
  YYSYMBOL_route_name = 422,               /* route_name  */
  YYSYMBOL_route_main = 423,               /* route_main  */
  YYSYMBOL_route_stm = 424,                /* route_stm  */
  YYSYMBOL_failure_route_main = 425,       /* failure_route_main  */
  YYSYMBOL_failure_route_stm = 426,        /* failure_route_stm  */
  YYSYMBOL_route_reply_main = 427,         /* route_reply_main  */
  YYSYMBOL_onreply_route_stm = 428,        /* onreply_route_stm  */
  YYSYMBOL_429_7 = 429,                    /* $@7  */
  YYSYMBOL_430_8 = 430,                    /* $@8  */
  YYSYMBOL_branch_route_main = 431,        /* branch_route_main  */
  YYSYMBOL_branch_route_stm = 432,         /* branch_route_stm  */
  YYSYMBOL_send_route_main = 433,          /* send_route_main  */
  YYSYMBOL_send_route_stm = 434,           /* send_route_stm  */
  YYSYMBOL_event_route_main = 435,         /* event_route_main  */
  YYSYMBOL_event_route_stm = 436,          /* event_route_stm  */
  YYSYMBOL_preprocess_stm = 437,           /* preprocess_stm  */
  YYSYMBOL_equalop = 438,                  /* equalop  */
  YYSYMBOL_cmpop = 439,                    /* cmpop  */
  YYSYMBOL_strop = 440,                    /* strop  */
  YYSYMBOL_rve_equalop = 441,              /* rve_equalop  */
  YYSYMBOL_rve_cmpop = 442,                /* rve_cmpop  */
  YYSYMBOL_uri_type = 443,                 /* uri_type  */
  YYSYMBOL_eint_op_onsend = 444,           /* eint_op_onsend  */
  YYSYMBOL_eint_op = 445,                  /* eint_op  */
  YYSYMBOL_eip_op_onsend = 446,            /* eip_op_onsend  */
  YYSYMBOL_eip_op = 447,                   /* eip_op  */
  YYSYMBOL_exp_elem = 448,                 /* exp_elem  */
  YYSYMBOL_ipnet = 449,                    /* ipnet  */
  YYSYMBOL_host = 450,                     /* host  */
  YYSYMBOL_host_if_id = 451,               /* host_if_id  */
  YYSYMBOL_host_or_if = 452,               /* host_or_if  */
  YYSYMBOL_fcmd = 453,                     /* fcmd  */
  YYSYMBOL_stm = 454,                      /* stm  */
  YYSYMBOL_actions = 455,                  /* actions  */
  YYSYMBOL_action = 456,                   /* action  */
  YYSYMBOL_if_cmd = 457,                   /* if_cmd  */
  YYSYMBOL_ct_rval = 458,                  /* ct_rval  */
  YYSYMBOL_single_case = 459,              /* single_case  */
  YYSYMBOL_case_stms = 460,                /* case_stms  */
  YYSYMBOL_switch_cmd = 461,               /* switch_cmd  */
  YYSYMBOL_while_cmd = 462,                /* while_cmd  */
  YYSYMBOL_select_param = 463,             /* select_param  */
  YYSYMBOL_select_params = 464,            /* select_params  */
  YYSYMBOL_select_id = 465,                /* select_id  */
  YYSYMBOL_466_9 = 466,                    /* $@9  */
  YYSYMBOL_attr_class_spec = 467,          /* attr_class_spec  */
  YYSYMBOL_attr_name_spec = 468,           /* attr_name_spec  */
  YYSYMBOL_attr_spec = 469,                /* attr_spec  */
  YYSYMBOL_attr_mark = 470,                /* attr_mark  */
  YYSYMBOL_attr_id = 471,                  /* attr_id  */
  YYSYMBOL_attr_id_num_idx = 472,          /* attr_id_num_idx  */
  YYSYMBOL_attr_id_no_idx = 473,           /* attr_id_no_idx  */
  YYSYMBOL_attr_id_ass = 474,              /* attr_id_ass  */
  YYSYMBOL_attr_id_any = 475,              /* attr_id_any  */
  YYSYMBOL_attr_id_any_str = 476,          /* attr_id_any_str  */
  YYSYMBOL_pvar = 477,                     /* pvar  */
  YYSYMBOL_avp_pvar = 478,                 /* avp_pvar  */
  YYSYMBOL_assign_op = 479,                /* assign_op  */
  YYSYMBOL_lval = 480,                     /* lval  */
  YYSYMBOL_rval = 481,                     /* rval  */
  YYSYMBOL_rve_un_op = 482,                /* rve_un_op  */
  YYSYMBOL_rval_expr = 483,                /* rval_expr  */
  YYSYMBOL_assign_action = 484,            /* assign_action  */
  YYSYMBOL_avpflag_oper = 485,             /* avpflag_oper  */
  YYSYMBOL_cmd = 486,                      /* cmd  */
  YYSYMBOL_487_10 = 487,                   /* $@10  */
  YYSYMBOL_func_params = 488,              /* func_params  */
  YYSYMBOL_func_param = 489,               /* func_param  */
  YYSYMBOL_ret_cmd = 490                   /* ret_cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  524
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12603

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  384
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  107
/* YYNRULES -- Number of rules.  */
#define YYNRULES  993
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1876

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   638


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   662,   662,   665,   666,   667,   670,   671,   672,   673,
     674,   675,   675,   676,   676,   677,   678,   678,   679,   679,
     680,   680,   681,   682,   685,   702,   711,   726,   727,   733,
     734,   738,   739,   740,   741,   742,   745,   746,   747,   748,
     749,   750,   751,   754,   755,   758,   759,   760,   761,   762,
     766,   767,   768,   769,   770,   774,   775,   778,   779,   782,
     783,   785,   786,   789,   792,   798,   799,   803,   804,   807,
     808,   811,   817,   823,   828,   833,   837,   838,   842,   843,
     848,   849,   850,   851,   852,   855,   856,   859,   860,   861,
     862,   863,   864,   865,   866,   867,   870,   871,   877,   878,
     879,   880,   881,   882,   883,   884,   885,   886,   887,   888,
     889,   890,   893,   894,   897,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   914,   916,   917,   918,   919,   920,   921,   922,   923,
     924,   925,   926,   927,   928,   929,   930,   931,   932,   933,
     934,   935,   936,   937,   938,   939,   940,   941,   942,   943,
     944,   945,   946,   947,   948,   949,   950,   951,   952,   953,
     954,   955,   963,   964,   965,   966,   967,   968,   971,   972,
     975,   976,   979,   980,   981,   982,   985,   986,   989,   990,
     993,   994,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1020,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,  1055,  1056,  1057,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,  1068,  1069,  1076,  1083,  1084,  1085,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1105,  1106,  1113,  1114,  1121,  1122,  1129,
    1130,  1137,  1138,  1145,  1146,  1153,  1154,  1164,  1165,  1179,
    1193,  1194,  1201,  1202,  1209,  1210,  1217,  1218,  1227,  1228,
    1237,  1238,  1245,  1246,  1253,  1254,  1261,  1262,  1269,  1270,
    1277,  1278,  1285,  1286,  1293,  1294,  1301,  1302,  1309,  1310,
    1317,  1318,  1325,  1326,  1333,  1334,  1341,  1342,  1349,  1350,
    1357,  1358,  1365,  1366,  1373,  1374,  1381,  1382,  1389,  1391,
    1398,  1399,  1410,  1411,  1418,  1419,  1426,  1427,  1434,  1435,
    1442,  1443,  1450,  1451,  1458,  1459,  1466,  1473,  1480,  1487,
    1494,  1501,  1502,  1509,  1510,  1517,  1518,  1525,  1526,  1533,
    1534,  1541,  1542,  1549,  1550,  1557,  1558,  1565,  1566,  1573,
    1574,  1575,  1576,  1579,  1580,  1583,  1584,  1585,  1586,  1587,
    1588,  1589,  1590,  1602,  1615,  1627,  1640,  1653,  1667,  1680,
    1694,  1707,  1721,  1734,  1748,  1750,  1761,  1762,  1773,  1774,
    1775,  1776,  1777,  1778,  1784,  1785,  1795,  1796,  1797,  1798,
    1799,  1800,  1807,  1808,  1815,  1816,  1817,  1818,  1819,  1820,
    1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,  1830,
    1831,  1832,  1839,  1840,  1847,  1848,  1855,  1862,  1863,  1864,
    1891,  1892,  1893,  1894,  1895,  1896,  1897,  1898,  1899,  1900,
    1901,  1902,  1903,  1904,  1905,  1906,  1907,  1908,  1909,  1910,
    1911,  1912,  1913,  1914,  1915,  1916,  1917,  1918,  1919,  1920,
    1921,  1922,  1931,  1932,  1941,  1942,  1951,  1952,  1961,  1962,
    1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,
    1981,  1982,  1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,
    1991,  1992,  1993,  1994,  1996,  1997,  1998,  1999,  2001,  2003,
    2004,  2005,  2008,  2009,  2012,  2013,  2014,  2017,  2018,  2021,
    2022,  2023,  2031,  2036,  2041,  2046,  2051,  2054,  2059,  2067,
    2073,  2079,  2085,  2086,  2092,  2098,  2104,  2105,  2115,  2116,
    2126,  2127,  2136,  2145,  2146,  2155,  2164,  2173,  2174,  2180,
    2181,  2187,  2191,  2192,  2195,  2224,  2239,  2240,  2244,  2255,
    2256,  2260,  2261,  2265,  2272,  2288,  2289,  2292,  2295,  2302,
    2318,  2322,  2323,  2328,  2328,  2335,  2336,  2338,  2337,  2360,
    2365,  2368,  2375,  2391,  2394,  2397,  2404,  2420,  2423,  2426,
    2443,  2446,  2447,  2448,  2449,  2450,  2451,  2473,  2474,  2475,
    2476,  2479,  2480,  2481,  2482,  2485,  2486,  2492,  2493,  2494,
    2495,  2496,  2497,  2498,  2501,  2502,  2503,  2504,  2511,  2512,
    2513,  2520,  2521,  2522,  2526,  2527,  2528,  2529,  2530,  2535,
    2536,  2539,  2540,  2541,  2547,  2549,  2551,  2552,  2554,  2556,
    2558,  2560,  2562,  2563,  2565,  2566,  2567,  2568,  2570,  2572,
    2574,  2576,  2578,  2580,  2581,  2617,  2619,  2621,  2623,  2626,
    2628,  2630,  2632,  2636,  2637,  2648,  2649,  2653,  2654,  2669,
    2684,  2685,  2688,  2689,  2690,  2702,  2703,  2718,  2733,  2735,
    2742,  2784,  2785,  2788,  2789,  2790,  2793,  2794,  2795,  2796,
    2797,  2798,  2799,  2800,  2803,  2811,  2821,  2838,  2845,  2852,
    2859,  2866,  2871,  2876,  2877,  2878,  2879,  2880,  2883,  2892,
    2899,  2924,  2940,  2941,  2946,  2965,  2974,  2986,  3001,  3002,
    3005,  3005,  3015,  3016,  3017,  3018,  3019,  3020,  3021,  3022,
    3023,  3026,  3029,  3030,  3033,  3040,  3043,  3050,  3056,  3057,
    3066,  3067,  3068,  3071,  3072,  3084,  3108,  3119,  3150,  3154,
    3164,  3178,  3190,  3191,  3193,  3194,  3195,  3209,  3210,  3211,
    3212,  3213,  3214,  3215,  3219,  3220,  3221,  3234,  3240,  3241,
    3242,  3243,  3244,  3245,  3246,  3247,  3248,  3249,  3250,  3251,
    3252,  3253,  3254,  3272,  3273,  3274,  3275,  3276,  3277,  3278,
    3286,  3287,  3288,  3289,  3290,  3291,  3292,  3293,  3294,  3295,
    3296,  3298,  3300,  3301,  3302,  3303,  3304,  3305,  3308,  3326,
    3327,  3328,  3331,  3332,  3333,  3334,  3335,  3336,  3337,  3338,
    3339,  3340,  3341,  3342,  3343,  3344,  3345,  3346,  3347,  3348,
    3349,  3350,  3351,  3352,  3353,  3354,  3355,  3356,  3357,  3358,
    3359,  3360,  3361,  3362,  3363,  3364,  3365,  3373,  3381,  3389,
    3397,  3405,  3413,  3421,  3429,  3437,  3438,  3440,  3448,  3456,
    3464,  3473,  3482,  3491,  3499,  3508,  3516,  3517,  3519,  3522,
    3523,  3524,  3525,  3532,  3539,  3540,  3546,  3553,  3554,  3560,
    3567,  3568,  3574,  3577,  3580,  3581,  3582,  3585,  3586,  3587,
    3596,  3605,  3606,  3607,  3608,  3609,  3610,  3611,  3612,  3613,
    3614,  3615,  3616,  3617,  3618,  3619,  3620,  3621,  3622,  3626,
    3630,  3631,  3632,  3633,  3634,  3635,  3636,  3637,  3638,  3639,
    3640,  3641,  3642,  3643,  3644,  3645,  3646,  3647,  3648,  3649,
    3650,  3651,  3652,  3653,  3654,  3655,  3656,  3657,  3665,  3673,
    3681,  3682,  3684,  3686,  3697,  3698,  3699,  3715,  3716,  3717,
    3721,  3724,  3725,  3728,  3731,  3734,  3737,  3740,  3743,  3746,
    3749,  3752,  3755,  3756,  3757,  3760,  3761,  3762,  3762,  3795,
    3797,  3799,  3800,  3803,  3820,  3824,  3828,  3832,  3837,  3841,
    3846,  3850,  3854,  3858
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "FORWARD",
  "FORWARD_TCP", "FORWARD_TLS", "FORWARD_SCTP", "FORWARD_UDP", "EXIT",
  "DROP", "RETURN", "RETURN_MODE", "BREAK", "LOG_TOK", "ERROR", "ROUTE",
  "ROUTE_REQUEST", "ROUTE_FAILURE", "ROUTE_ONREPLY", "ROUTE_REPLY",
  "ROUTE_BRANCH", "ROUTE_SEND", "ROUTE_EVENT", "EXEC", "SET_HOST",
  "SET_HOSTPORT", "SET_HOSTPORTTRANS", "PREFIX", "STRIP", "STRIP_TAIL",
  "SET_USERPHONE", "APPEND_BRANCH", "REMOVE_BRANCH", "CLEAR_BRANCHES",
  "SET_USER", "SET_USERPASS", "SET_PORT", "SET_URI", "REVERT_URI",
  "FORCE_RPORT", "ADD_LOCAL_RPORT", "LOCAL_RPORT", "FORCE_TCP_ALIAS",
  "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW", "UDP4_RAW_MTU",
  "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS", "SET_ADV_PORT",
  "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT", "SET_RPL_NO_CONNECT",
  "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE", "DEFAULT", "WHILE",
  "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT", "MAX_LEN", "SETFLAG",
  "RESETFLAG", "ISFLAGSET", "SETAVPFLAG", "RESETAVPFLAG", "ISAVPFLAGSET",
  "METHOD", "URI", "FROM_URI", "TO_URI", "SRCIP", "SRCPORT", "DSTIP",
  "DSTPORT", "TOIP", "TOPORT", "SNDIP", "SNDPORT", "SNDPROTO", "SNDAF",
  "PROTO", "AF", "MYSELF", "MSGLEN", "UDP", "TCP", "TLS", "SCTP", "WS",
  "WSS", "DEBUG_V", "FORK", "FORK_DELAY", "MODINIT_DELAY", "LOGSTDERROR",
  "LOGFACILITY", "LOGNAME", "LOGCOLOR", "LOGPREFIX", "LOGPREFIXMODE",
  "LOGENGINETYPE", "LOGENGINEDATA", "XAVPVIAPARAMS", "XAVPVIAFIELDS",
  "LISTEN", "ADVERTISE", "VIRTUAL", "STRNAME", "ALIAS", "SR_AUTO_ALIASES",
  "DOMAIN", "SR_AUTO_DOMAINS", "DNS", "REV_DNS", "DNS_TRY_IPV6",
  "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF", "DNS_TCP_PREF",
  "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME", "DNS_SLOW_QUERY_MS",
  "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH", "DNS_SEARCH_FMATCH",
  "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT", "DNS_USE_CACHE",
  "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS", "DNS_CACHE_NEG_TTL",
  "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL", "DNS_CACHE_MEM",
  "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP", "DNS_CACHE_REC_PREF",
  "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL", "IPV6_HEX_STYLE",
  "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM", "DST_BLST_TTL",
  "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK", "DST_BLST_TCP_IMASK",
  "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK", "IP_FREE_BIND", "PORT",
  "STAT", "STATS_NAMESEP", "CHILDREN", "SOCKET", "BIND", "WORKERS",
  "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK",
  "ASYNC_WORKERS_GROUP", "CHECK_VIA", "PHONE2TEL", "MEMLOG", "MEMDBG",
  "MEMSUM", "MEMSAFETY", "MEMJOIN", "MEMSTATUSMODE",
  "SIP_PARSER_LOG_ONELINE", "SIP_PARSER_LOG", "SIP_PARSER_MODE", "CORELOG",
  "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER",
  "REPLY_TO_VIA", "LOADMODULE", "LOADMODULEX", "LOADPATH", "MODPARAM",
  "MODPARAMX", "CFGENGINE", "MAXBUFFER", "SQL_BUFFER_SIZE",
  "MSG_RECV_MAX_SIZE", "TCP_MSG_READ_TIMEOUT", "TCP_MSG_DATA_TIMEOUT",
  "TCP_ACCEPT_IPLIMIT", "TCP_CHECK_TIMER", "USER", "GROUP", "CHROOT",
  "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP", "TCP_ACCEPT_ALIASES",
  "TCP_ACCEPT_UNIQUE", "TCP_CONNECTION_MATCH", "TCP_CHILDREN",
  "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS",
  "TCP_NO_CONNECT", "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6",
  "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX",
  "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK",
  "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT",
  "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE",
  "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING",
  "TCP_OPT_ACCEPT_NO_CL", "TCP_OPT_ACCEPT_HEP3", "TCP_OPT_ACCEPT_HAPROXY",
  "TCP_OPT_CLOSE_RST", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "TCP_WAIT_DATA", "TCP_SCRIPT_MODE", "DISABLE_TLS", "ENABLE_TLS",
  "TLSLOG", "TLS_PORT_NO", "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT",
  "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY",
  "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE", "TLS_PRIVATE_KEY",
  "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP", "SCTP_CHILDREN",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES", "REAL_TIME", "RT_PRIO",
  "RT_POLICY", "RT_TIMER1_PRIO", "RT_TIMER1_POLICY", "RT_TIMER2_PRIO",
  "RT_TIMER2_POLICY", "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS",
  "PMTU_DISCOVERY", "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE",
  "PVBUFSLOTS", "PVCACHELIMIT", "PVCACHEACTION", "HTTP_REPLY_PARSE",
  "VERSION_TABLE_CFG", "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE",
  "WAIT_WORKER1_MODE", "WAIT_WORKER1_TIME", "WAIT_WORKER1_USLEEP",
  "CFG_DESCRIPTION", "SERVER_ID", "KEMI", "ONSEND_ROUTE_CALLBACK",
  "REPLY_ROUTE_CALLBACK", "EVENT_ROUTE_CALLBACK",
  "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE", "PRE_ROUTING_CALLBACK",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "RPC_EXEC_DELTA_CFG", "MSG_TIME", "ONSEND_RT_REPLY",
  "URI_HOST_EXTRA_CHARS", "HDR_NAME_EXTRA_CHARS", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "SELVAL", "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR",
  "AVP_OR_PVAR", "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN",
  "LBRACE", "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "socket_lattr", "socket_lattrs", "assign_stm", "$@6",
  "cfg_var_id", "cfg_var_idn", "cfg_var", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "route_name", "route_main", "route_stm",
  "failure_route_main", "failure_route_stm", "route_reply_main",
  "onreply_route_stm", "$@7", "$@8", "branch_route_main",
  "branch_route_stm", "send_route_main", "send_route_stm",
  "event_route_main", "event_route_stm", "preprocess_stm", "equalop",
  "cmpop", "strop", "rve_equalop", "rve_cmpop", "uri_type",
  "eint_op_onsend", "eint_op", "eip_op_onsend", "eip_op", "exp_elem",
  "ipnet", "host", "host_if_id", "host_or_if", "fcmd", "stm", "actions",
  "action", "if_cmd", "ct_rval", "single_case", "case_stms", "switch_cmd",
  "while_cmd", "select_param", "select_params", "select_id", "$@9",
  "attr_class_spec", "attr_name_spec", "attr_spec", "attr_mark", "attr_id",
  "attr_id_num_idx", "attr_id_no_idx", "attr_id_ass", "attr_id_any",
  "attr_id_any_str", "pvar", "avp_pvar", "assign_op", "lval", "rval",
  "rve_un_op", "rval_expr", "assign_action", "avpflag_oper", "cmd", "$@10",
  "func_params", "func_param", "ret_cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638
};
#endif

#define YYPACT_NINF (-1300)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-978)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2396,  -289,  -258,    35,     8,  -247,  -238,  -223,  -168,  -137,
    -125,  -121, -1300,   -94,   -82,   -70,   -62,   -58,    -8,    -5,
       3,    16,    19,    37,    47,   149,   214,   442,   473,   482,
     491,   495,   538,   582,    25,    28,    33,    41,    43,    45,
      46,    49,   344,   726,   749,   762,   817,   914,   915,   925,
     965,   972,   987,   988,   989,   990,   996,  1012,  1013,  1026,
    1035,  1047,  1048,  1049,  1050,  1062,  1063,  1064,  1071,  1072,
    1073,   590,   620,   624,   628, -1300,   629,   632,   667,   673,
     694,   702,   705,   758,   799,   821,   891,   920,   928,   932,
     941,   954,   962,   966,   971,   975,   978,   980,    82,   123,
     162,    27,    39,   229,   983,   991,   994,   995,  1003,  1014,
    1019,  1022,  1027,  1034,  1038,  1039,  1041,  1051,  1065,  1074,
    1076,  1089,  1091,  1101,  1108,  1114,  1115,  1116,  1125,  1131,
    1136,  1144,  1158,  1081,  1082,  1083,  1086,  1162,  1163,  1165,
    1167,  1170,  1173,  1175,  1177,  1178,  1179,  1180,  1182,  1187,
    1192,  1194,  1195,  1213,  1214,  1215,  1261,  1265,  1266,  1352,
    1354,  1355,  1404,  1428,  1429,  1430,  1457,  1458,  1459,  1460,
    1466,  1468,  1470,  1481,  1482,  1493,  1498,  1499,  1500,  1501,
    1502,  1503,  1504,  1513,  1523,  1525,  1527,  1087,  1528,  1529,
    1531,  1540,  1541,  1545,  1546,  1547,  1555,  1564,  1569,  1570,
    1571,  1572,    -3,  1573,  1574,  1575,  1584,  1594,  1596,  1598,
    1599,  1600,  1602,  1611,  1612,  1616,   122,   235,    38,   134,
     139, -1300, -1300, -1300,   340,  1434, -1300,   289,   337,   955,
    1059,  1011, -1300, -1300, -1300,  -283, -1300, -1300,   608, -1300,
   -1300, -1300,   189, -1300,  -148, -1300,   270,   322,   330,   964,
      24,   355,   371,   212,   551,   657,   686,   734,    76,   145,
     740,   207,   755,   221,   227,   228,   232,    52,    95,   760,
     602,   763,   766,   768, -1300,   733, -1300,   742, -1300,   754,
   -1300,  -297, -1300,  -297, -1300,  -297, -1300,  -297, -1300,   764,
   -1300,   781, -1300,   796, -1300,   802, -1300,   810, -1300,   839,
   -1300,   845, -1300,   859, -1300,   889, -1300,   901, -1300,   902,
   -1300,   906, -1300,   909, -1300,   916, -1300,   952, -1300,  1056,
   -1300,  1096, -1300,  1152, -1300,  1319, -1300,  1583, -1300,  1581,
   -1300,  1592, -1300,  1601, -1300,  1606, -1300,  1607, -1300,  1608,
   -1300,  1609, -1300,  1610, -1300,  1621, -1300,  1631,   373,   769,
     241,   770,  1645,   775,   776,   777,   778,   246,   779,   780,
     492,   526,   535,   547,   615,   643,   644,   654,   655,   701,
     782,   784,   268,   271,   785, -1300, -1300,  1630, -1300, -1300,
    1632, -1300,   272, -1300, -1300,  1633, -1300,  1634, -1300,   274,
   -1300,   786,   788,   789,   790,   791,   792,   793,   238,   250,
     254,   255,   258,   798,   803,   806,   807,   808,   809,   719,
     723,   739,   259,   811,   812,   814,   815,    88,   816,   823,
   -1300,  1639, -1300,  1648, -1300,  1649, -1300,  1653,   824,   827,
     833,   834,   835,   836,   841,   842,   844,   846,   847,   848,
     849,   850,   852,   741,   743,   853,   855,   856,   858,  1186,
     860,   861,   862,   863,   278,   280,   282,   864,   865,   866,
      29,   867,   868,   870,   872,   873,   874,   875,   876,   879,
     882,   883,   884,   887,   890,   892,   263,   351, -1300,  1654,
     893,   895,   896,   897,   899,   905,   908,   284,   911,   922,
     923,   926,   927,   929,  1090,   745,  1655,  1663,   761,   767,
     930,   933,   934,   935,   936,   939,   290,   292, -1300, -1300,
   -1300, -1300,  1042,  1595, -1300, -1300, -1300,  1043, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300,  -289, -1300,    72,     9,  1660,
   -1300,    91,  1665, -1300,    98,  1666, -1300,    99,  1667, -1300,
      23,  1668, -1300,     0,  1680, -1300, -1300, -1300, -1300, -1300,
   -1300,  1677, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300,  1681, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300,  1687, -1300, -1300, -1300, -1300,  1427,  1698, -1300,
    1689,  1690,  1032,   141, -1300, -1300, -1300, -1300, -1300,  -215,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300,  1692, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300,  -308,  -218, -1300, -1300,  1700,  1702, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300,  1687, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300,  1753,  1754,  1758,  1759,  1760, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300,  -178,  1761,  -178, -1300,  -148, -1300, 12228, -1300,
    -148, 12228, -1300,  -148, 12228, -1300,  -148, 12228, -1300,  1755,
   -1300, -1300, -1300,  1797,  1749, 12228,    22, -1300,  1768,  1763,
    1762,  1751,   325,  1756, -1300,  1427, -1300,  1770,   333,   341,
    1359,  1771, -1300,  1772, -1300,  1774,  1775,   293,   295,   296,
     297,   298, -1300, -1300, -1300,  1764,    48,    51,   103,   105,
     106, 10996, 11083, 11459, -1300,   121,   125,   127,  1769,   129,
     133,   135,   138,   140,   151,   153,   156,  1793,   165,   170,
     173,   174,  1794,  1795,  1796,  1798,  1800, 11546,   176,   179,
     182,  1801,  1802,  1803,  1805,  6083, 11546,   183,   195,   196,
     198,   202, -1300, -1300, -1300, -1300,   208, -1300, -1300, -1300,
      55,  3522, -1300, -1300, -1300, -1300,  1432, -1300, -1300, -1300,
   -1300, -1300,  1842,  1808,   209, -1300,  1809,  1806,  3593,  1812,
    3664,  1813,  3817,  1815,   240,  1773,  4041, -1300,  1817,  1836,
    1427, -1300, -1300, -1300, -1300, -1300, -1300,  1816,   -22,  2088,
   -1300, -1300, -1300, -1300, -1300,  1869,  1880,  1881,  1882,  1883,
   -1300, -1300,  1353,  1840,  1841,  1867,  1868, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300,  1865, -1300,    57,
   -1300,    69, -1300,    75, -1300,    87, -1300,   154,  1007, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
     820, -1300,   820, -1300,   997, -1300, -1300,  1681, -1300, -1300,
    6461,  6550,  6639,  1870,  1871,  1872, -1300,  5438, 12159, -1300,
    1015, -1300,   984, -1300,  1023, -1300, -1300, -1300,  1432, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300,  7017,  3649,  5527,  3649,
    5905,  3649, -1300,   265, -1300,   299, -1300,  7106,  1875, -1300,
     300, -1300,   305, -1300,   306, -1300,   308, -1300,   940, -1300,
     942, -1300,  1874, -1300,   211,  1877, -1300,   310, -1300,   311,
   -1300,   312, -1300,   313,  1878,  1879,  1888,   223,   986,  7195,
   11633, -1300,   200, -1300,   943, -1300,   662,  1889,  1890,  1891,
    1893, -1300,  1433, 11633, -1300,   317, -1300,   320, -1300,  -135,
   -1300,  -123, -1300,   406, -1300,  1894, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300,  1884, -1300,  1892, -1300, 11546, -1300, -1300,    11, -1300,
    1873, -1300,  1896, -1300,  1897, -1300,  1898, -1300,  1951,  1964,
       0, -1300, 12228,  1904, -1300,  -273, -1300,  1908,  1912, -1300,
    1427,   948,   321,   748,   950, -1300, -1300, -1300, -1300,   851,
    -204, 12228,  1903,  -149, -1300,   -92, -1300,   -44,  1010,  1905,
     -30,   -21,   626,  1068,  1906,   670,   722,   830,  1122,  1907,
     937,  1017,  1053,  1130,  1909,  1067,  1084,  1085,  1139, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300,  7573,  4965,  5343, -1300,
    1730,  1913, -1300, -1300, -1300, -1300, -1300, -1300,  7662,  7751,
    8129,  1910, -1300,  1952,  1955,  1980,  1981,  1766,  1938,  1936,
    4112, -1300,  8218, -1300, -1300, -1300, -1300, -1300,  8307,  8685,
   -1300,  2761,  1937, -1300, -1300,  8774,  8863,  9241,  9330, 11546,
   11546, 11546, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300,  9419,  9797,  9886,  9975, 10353, 10442, 10531,
   -1300, -1300,  1940,  1914,  1942,  1943,  1946,  1945,    70,  2131,
    1948,  1949,  1950,  1953,  1957,  1959,  1960,  1961,  1962,  1965,
    1966,  1967,  1969, -1300,  1970, -1300,  1971, -1300,  1972,  1973,
    1974,  1975,  1976,  1977,  1978,  1979, -1300, -1300, -1300,  1982,
    1983, -1300,  2007,  2008, 12228,  2273, -1300,  2009,  2010,  2011,
    2012,  2013,  2017,  2021,  2014, -1300, -1300, -1300, -1300,   120,
   -1300,  2015,  2018,  2019,  2020,  2030,  2032,  2033,  2060,  2062,
    2068, 11546,  1989,  2064,  3649,  1093, -1300,  1432, -1300,  2072,
   -1300, 12228, 12228, 12228, 12228,  1988,  2024,  2115,  4194,  2086,
   -1300,  2228,   -10,  2066, -1300, -1300, -1300, -1300, -1300,  2067,
    2069, -1300, -1300,  2075,  2077,  2078,  2080,  2081,  4265, -1300,
     -37, -1300,  2092, -1300,  2093, -1300,   130,   152,  2094, -1300,
   -1300,   -23, -1300,  2095, -1300,  2096, -1300,  2097, -1300, -1300,
     -19, -1300,  2121, -1300,  2122, -1300,  2123, -1300, -1300,    -2,
   -1300,  2124, -1300,  2125, -1300,  2142, -1300, -1300,    18, -1300,
    2143, -1300,  2189, -1300,  2193, -1300, -1300,  1885,  1856, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,  1856, -1300,
   -1300,  1856, -1300, -1300, -1300,  2180, -1300,  2284,  2271,  2397,
    2272,  2747,  2314,  3425, -1300, -1300, -1300, -1300, -1300, -1300,
    1956,  1856, -1300,  1856, -1300,   843, -1300,  2027,  1687,  1814,
    2295, -1300,  -170,  1856,  -280, -1300,  3671, -1300,  4095, -1300,
    2926, -1300,  2996,  3443,  3595,  2079, -1300,   -38, -1300,   -38,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300,  1856, -1300,   843,
   -1300,  2324, -1300, -1300,  2325, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300,  4336, 12088, -1300, -1300, -1300,
   -1300, -1300,   659,  1427, -1300,  2316,  5994,  2313, -1300, -1300,
     146, -1300, 11712, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300,  3649,  1112, -1300, -1300, -1300,  -178, -1300, -1300,   266,
    4489,  4713,  4784,  4866, -1300, -1300,  -306, -1300,  2332, -1300,
   -1300,  2344,  2348,  -273,  1427, -1300, -1300, -1300, -1300, -1300,
   -1300,  2339,  2340,  2341,  2342, -1300, -1300, -1300, -1300,  2343,
    2345,  2346,  2347,  2352,  2353,  2377,  2378,  2379,  2380,  2381,
    2382,  2383,  2384,  2385,  2393,  2394,  2401,  2403,  2404,  2405,
     885,  1913, -1300, -1300, -1300, -1300, -1300, 11546,   104,  2391,
    2406,  2407, -1300, -1300, -1300, -1300,  2337, -1300,  2409, 10909,
    2419,  3649, 12228, -1300, -1300,  2428,  2906, 11546, -1300,  2430,
    2431,  2432, -1300, -1300, -1300, -1300, -1300, -1300, -1300,  2612,
   -1300, -1300,  2426, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,  2429,  2437,
   -1300,  3578, -1300,  1687, -1300, -1300, -1300, -1300,  -273, 12228,
    2436,  2438,  2850,  2921, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300,  -273, -1300, -1300, 11546, -1300,  2992, 12228, 12228, -1300,
    3145, -1300,  2977,  3369,  3440, -1300
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   528,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   215,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   527,    22,    23,     0,     0,     4,     0,     0,     0,
       0,     0,     8,     9,     6,     0,   525,    10,     0,    15,
       7,   526,     0,   585,     0,   586,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   120,     0,   122,     0,   124,     0,
     126,     0,   128,     0,   130,     0,   132,     0,   134,     0,
     136,     0,   138,     0,   140,     0,   142,     0,   144,     0,
     146,     0,   148,     0,   150,     0,   152,     0,   154,     0,
     156,     0,   160,     0,   158,     0,   162,     0,   164,     0,
     166,     0,   168,     0,   170,     0,   174,     0,   172,     0,
     176,     0,   178,     0,   180,     0,   182,     0,   184,     0,
     186,     0,   188,     0,   190,     0,   192,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   542,   539,     0,   546,   543,
       0,   548,     0,   547,   553,     0,   557,     0,   559,     0,
     558,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     306,     0,   308,     0,   310,     0,   312,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   452,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    60,    66,
      65,    59,    61,    63,    68,    71,    67,    69,   602,   601,
     604,   603,   606,   605,     1,     5,     3,     0,     0,     0,
      12,     0,     0,    14,     0,     0,    17,     0,     0,    19,
       0,     0,    21,     0,     0,   583,   480,   479,   568,   569,
     570,     0,   514,   513,   516,   515,   512,   511,   518,    31,
      32,    33,    34,    35,   517,   520,     0,    57,   519,   522,
     521,   524,   523,    88,    87,    90,    89,    92,    91,    94,
      93,    96,    95,    98,    97,   100,    99,   102,   101,   104,
     103,   106,   105,   108,   107,   110,   109,   112,   111,   114,
     113,   404,   684,   682,   683,    25,   565,     0,     0,    30,
      50,     0,    55,   392,    24,   562,   566,   563,   685,    26,
     406,   405,   410,   409,   408,   407,   412,   411,   116,   115,
     118,   117,   119,   121,   123,   125,   127,   129,   131,   133,
     135,   137,   139,   141,   143,   145,   147,   149,   151,   153,
     155,   159,   157,   161,   163,   165,   167,   169,   173,   171,
     175,   177,   179,   181,   183,   185,   187,   189,   191,   194,
     193,   196,   195,   214,   213,   212,   211,     0,   218,   217,
     220,   219,   222,   221,   224,   223,   226,   225,   228,   227,
     230,   229,   232,   231,   234,   233,   236,   235,   238,   237,
     240,   239,   242,   241,   244,   243,   246,   245,   248,   247,
     250,   249,   252,   251,   381,   380,   383,   382,   385,   384,
     391,   390,     0,     0,   550,   549,     0,     0,   561,   560,
     198,   197,   200,   199,   202,   201,   204,   203,   206,   205,
     208,   207,   210,   209,   257,   256,   255,   260,   259,   258,
     263,   262,   261,   266,   265,   264,   269,   268,   267,   271,
     270,   273,   272,   275,   274,   277,   276,   279,   278,   281,
     280,   283,   282,   285,   284,   287,   286,   290,   288,   289,
     292,   291,   294,   293,   296,   295,   298,     0,   297,   300,
     299,   302,   301,   304,   303,   305,   307,   309,   311,   314,
     313,   316,   315,   318,   317,   320,   319,   322,   321,   324,
     323,   326,   325,   328,   327,   330,   329,   332,   331,   334,
     333,   336,   335,   338,   337,   340,   339,   342,   341,   344,
     343,   346,   345,   348,   347,   350,   349,   352,   351,   354,
     353,   359,   355,   356,   357,   358,   371,   370,   373,   372,
     361,   360,   363,   362,   365,   364,   367,   366,   369,   368,
     375,   374,   377,   376,   379,   378,   414,   413,   416,   415,
     418,   417,   420,   419,   422,   421,   424,   423,   426,   425,
     428,   427,   430,   429,   432,   431,   434,   433,   436,   435,
     438,   437,   440,   439,   442,   441,   444,   443,   447,   445,
     446,   450,   448,   449,   451,   454,   453,   456,   455,   458,
     457,   460,   459,   462,   461,   464,   463,   466,   465,   254,
     253,   468,   467,   470,   469,   472,   471,   474,   473,   476,
     475,   478,   477,     0,     0,     0,     0,     0,   492,   491,
     493,   494,   498,   497,   496,   495,   500,   499,   502,   501,
     504,   503,   506,   505,   508,   507,   510,   509,   387,   386,
     389,   388,     0,     0,     0,   575,     0,   576,     0,   580,
       0,     0,   593,     0,     0,   597,     0,     0,   600,     0,
     530,   531,   529,     0,     0,     0,     0,    58,     0,    27,
       0,     0,     0,     0,    56,     0,   393,     0,     0,     0,
       0,     0,   540,     0,   544,     0,     0,     0,     0,     0,
       0,     0,    62,    64,    70,     0,     0,     0,     0,     0,
       0,   989,   986,   990,   993,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   942,   944,   946,   949,     0,     0,     0,     0,
       0,   963,   965,   967,   969,     0,     0,     0,     0,     0,
       0,     0,   819,   820,   821,   744,     0,   756,   757,   702,
       0,     0,   694,   697,   698,   699,     0,   748,   749,   759,
     760,   761,     0,     0,     0,   690,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   589,     0,     0,
       0,    29,   567,    54,    44,    43,    51,    52,   400,   394,
     689,   684,   687,   688,   686,     0,     0,     0,     0,     0,
      84,    86,     0,     0,     0,     0,     0,   482,   481,   484,
     483,   486,   485,   488,   487,   490,   489,     0,   832,     0,
     854,     0,   865,     0,   876,     0,   843,     0,     0,   628,
     629,   630,   641,   634,   642,   635,   640,   632,   639,   631,
       0,   633,     0,   636,     0,   637,   730,   776,   774,   775,
       0,     0,     0,     0,     0,     0,   763,     0,     0,   762,
       0,   638,     0,   643,     0,   769,   768,   767,     0,   750,
     752,   751,   764,   765,   766,   777,     0,   988,     0,   985,
       0,   992,   880,     0,   897,     0,   901,     0,     0,   905,
       0,   924,     0,   927,     0,   908,     0,   914,     0,   911,
       0,   917,     0,   920,     0,     0,   933,     0,   936,     0,
     930,     0,   939,     0,     0,     0,     0,     0,     0,     0,
       0,   955,     0,   958,     0,   961,     0,     0,     0,     0,
       0,   722,     0,     0,   972,     0,   975,     0,   884,     0,
     887,     0,   890,     0,   979,     0,   703,   696,   695,   573,
     693,   732,   733,   734,   735,   736,   737,   738,   739,   740,
     741,     0,   742,   745,   758,     0,   701,   895,     0,   700,
       0,   578,     0,   591,     0,   595,     0,   536,   532,   533,
       0,   584,     0,     0,    28,     0,   401,     0,     0,   395,
       0,     0,     0,     0,     0,   216,    85,   541,   545,     0,
       0,     0,     0,     0,   677,     0,   822,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   647,
     607,   608,   616,   609,   610,   615,     0,     0,     0,   672,
       0,     0,   817,   798,   801,   779,   802,   780,     0,     0,
       0,     0,   987,   750,   751,   765,   766,     0,     0,     0,
       0,   651,     0,   656,   611,   612,   613,   614,     0,     0,
     668,     0,   745,   800,   778,     0,     0,     0,     0,     0,
       0,     0,   617,   618,   623,   619,   620,   621,   622,   624,
     625,   626,   627,     0,     0,     0,     0,     0,     0,     0,
     984,   991,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   916,     0,   919,     0,   922,     0,     0,
       0,     0,     0,     0,     0,     0,   941,   943,   945,     0,
       0,   948,     0,     0,     0,   704,   691,     0,     0,     0,
       0,     0,    45,     0,     0,   962,   964,   966,   968,     0,
     724,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   980,     0,     0,   818,     0,   755,     0,   753,     0,
     754,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      53,   402,   396,     0,    83,    82,    78,    77,    76,    75,
       0,    81,    80,     0,     0,     0,     0,     0,     0,   833,
       0,   831,     0,   824,     0,   825,     0,     0,     0,   823,
     855,     0,   853,     0,   846,     0,   847,     0,   845,   866,
       0,   864,     0,   857,     0,   858,     0,   856,   877,     0,
     875,     0,   868,     0,   869,     0,   867,   844,     0,   842,
       0,   835,     0,   836,     0,   834,   646,     0,   644,   662,
      36,    37,    38,    39,    40,    41,    42,   660,   661,   659,
     657,   658,   671,   669,   670,   725,   729,   731,     0,     0,
       0,     0,     0,     0,   773,   795,   772,   771,   770,   650,
       0,   648,   655,   653,   654,   652,   667,     0,    57,     0,
     675,   663,   665,   664,     0,   813,   794,   812,   793,   808,
     786,   809,   787,   788,   789,   790,   803,   781,   804,   782,
     805,   783,   806,   784,   807,   785,   811,   792,   810,   791,
     881,     0,   878,   898,     0,   902,   900,   899,   903,   906,
     904,   925,   923,   928,   926,   909,   907,   915,   913,   912,
     910,   921,   918,   934,   932,   937,   935,   931,   929,   940,
     938,   950,   947,   952,   951,     0,     0,   954,   953,   957,
     956,   960,     0,     0,   959,     0,     0,     0,   721,   719,
       0,   973,     0,   976,   974,   882,   883,   885,   886,   888,
     889,   983,     0,   982,   743,   747,     0,   894,   745,     0,
       0,     0,     0,     0,   534,   535,     0,   588,     0,   403,
     397,     0,     0,     0,     0,   551,   552,   554,   556,   555,
     574,     0,     0,     0,     0,   681,   679,   680,   678,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   814,   796,   815,   797,   816,     0,     0,     0,
       0,     0,   692,   705,    49,    46,    47,   723,     0,     0,
       0,   706,   712,   720,   718,    57,     0,     0,   978,     0,
       0,     0,   579,   592,   596,   599,   537,   538,   564,   398,
      79,    73,    74,   829,   830,   827,   828,   826,   851,   852,
     849,   850,   848,   862,   863,   860,   861,   859,   873,   874,
     871,   872,   870,   840,   841,   838,   839,   837,     0,     0,
     728,     0,   676,   674,   673,   746,   879,   896,     0,   715,
       0,     0,     0,     0,   970,   971,   981,   893,   892,   891,
     399,     0,   727,   726,     0,    48,     0,   716,   710,   717,
       0,    72,     0,     0,     0,   799
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1300, -1300, -1300,  2595, -1300, -1300, -1300, -1300, -1300,  -458,
    1724,  1832,  -245,  1494, -1299, -1300, -1300,   724,  -250, -1300,
    1864, -1300,  -216, -1300,  1902, -1300,  1739, -1300, -1300, -1300,
   -1300,  1567, -1300, -1300, -1126,  2452,  2261,  2453,  -750, -1300,
   -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300, -1300,
   -1300, -1300, -1300, -1300, -1144, -1300, -1011, -1300, -1300,  1511,
   -1300, -1300, -1300,  1512, -1300, -1300,   342,    20, -1300,  -442,
   -1246,  -910,  -345, -1300,  1092,  1191, -1300, -1300, -1300,  1124,
   -1300, -1300, -1300, -1300,  1401, -1156,  -583,  -963, -1300,  -890,
   -1300, -1300, -1300,  -682,  -920, -1300, -1300, -1300, -1300,  -685,
    -937, -1300, -1300, -1300, -1300,  1099, -1300
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   224,   225,   226,   227,   228,   229,   230,   231,   609,
     990,   610,   611,  1587,  1106,  1474,   612,   613,  1179,   232,
     511,   512,   513,   233,   516,   517,  1121,  1122,   234,   352,
     235,   983,   236,   237,   614,   615,   616,   617,   551,   529,
     530,   532,   533,   238,   239,   985,  1098,   535,   536,   538,
     539,   541,   542,   240,  1355,  1389,  1356,  1418,  1419,  1180,
    1181,  1182,  1183,  1184,  1185,  1621,  1328,   618,   619,  1186,
    1465,  1071,  1072,  1073,  1790,  1699,  1700,  1074,  1075,  1596,
    1597,  1187,  1361,  1281,  1282,  1283,  1188,  1189,  1190,  1191,
    1079,  1192,  1499,  1193,  1194,  1285,  1082,  1195,  1196,  1377,
    1083,  1084,  1085,  1265,  1712,  1713,  1086
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     568,   515,   867,   574,   564,  1077,  1510,  1480,  1077,   245,
     967,  1077,  1495,  1327,  1077,  1332,  1357,  1337,  1358,  1342,
    1360,  1347,  1077,  1097,   978,   565,   274,  1741,   384,   276,
     866,   635,  1392,   636,   278,   637,   243,   638,  1388,   518,
     386,  1750,   280,   241,   282,  1755,   284,   286,  1081,  1138,
     288,  1081,  1140,   601,  1081,   566,  1266,  1081,  1322,   980,
    1806,  1088,  1760,  1807,  1090,  1081,  1001,  1092,  1002,   567,
    1329,  1264,   566,   965,   242,  1096,  1334,   583,  1078,   543,
    1104,  1078,  1765,   375,  1078,   246,   567,  1078,  1339,   789,
    1306,  1307,   969,  1105,   247,  1078,   620,   544,   670,   972,
     975,  1715,  1730,  1731,  1142,  1842,  1144,  1146,  1077,   248,
     693,   695,   697,   699,   701,   703,   705,   707,   709,   711,
    1323,  1695,  1202,   508,   378,  1077,  1204,  1077,  1206,  1077,
    1209,  1745,  1330,  1077,  1211,   520,  1213,   998,  1335,  1215,
     522,  1217,   559,   560,   561,   562,   585,   999,   566,   989,
    1340,  1081,  1219,  1747,  1221,  1344,  1003,  1223,  1004,   772,
     774,   776,   567,   381,   249,  1525,  1226,  1526,  1081,  1382,
    1081,  1228,  1081,  1391,  1230,  1232,  1081,  1241,  1696,  1697,
    1243,  1078,  1536,  1245,  1254,   559,   560,   561,   562,   509,
     546,   510,  1537,   830,   832,   250,  1256,  1258,  1078,  1260,
    1078,  1467,  1078,  1262,  1696,  1697,  1078,   251,   589,  1264,
    1287,   252,  1444,   573,  1373,  1077,  1015,  1345,   548,   549,
    1087,   550,   593,  1089,  1459,  1530,  1091,  1531,   595,   597,
     388,  1485,   509,   599,   510,  1373,   514,  1373,   253,   744,
    1378,  1297,   673,  1487,   509,   939,   510,   686,   943,   945,
     254,   747,   995,   996,   997,   750,   753,  1376,  1081,   756,
     777,  1378,   255,  1378,   898,  1620,  1422,  1800,  1380,   716,
     256,   552,   718,   724,   257,   728,  1373,  1077,  1376,   854,
    1376,   856,  1532,   858,  1533,   919,  1080,  1374,  1078,  1080,
    1077,   958,  1080,   960,  1127,  1080,  1129,  1131,  1133,  1135,
    1425,  1431,  1378,  1080,   527,   528,  1433,  1435,  1374,  1437,
    1374,  1448,  1450,  1452,  1454,  1415,  1416,  1417,  1481,  1376,
    1081,  1483,  1516,   554,   258,  1498,  1103,   259,  1065,  1742,
    1534,   556,  1535,  1081,  1110,   260,  1197,  1199,  1201,  1077,
     524,  1718,  1113,  1751,  1541,   290,  1542,  1756,   261,  1374,
    1078,   262,   901,  1543,   531,  1544,   569,   275,  1077,   494,
     277,  1308,  1240,  1078,  1761,   279,   981,   982,  1500,   263,
    1252,  1253,   571,   281,   669,   283,   566,   285,   287,   264,
    1496,   289,  1081,  1068,  1766,  1076,  -582,  -572,  1076,  1080,
     567,  1076,  1508,  1785,  1076,   602,   603,   604,   605,   606,
    -587,  1081,  1076,  -598,   385,   563,  1080,   519,  1080,   608,
    1080,  1528,  1078,  -581,  1080,   244,   387,  1077,   602,   603,
     604,   605,   606,   787,  1324,  1139,  1325,   606,  1141,   607,
    1267,  1078,   608,  1326,  1811,   787,  1324,   608,  1331,   606,
    1783,   787,  1324,   584,  1336,   606,  1656,  -977,   563,   608,
    -571,   376,   966,   787,  1324,   608,  1341,   606,   606,   377,
    1081,   602,   603,   604,   605,   606,  1360,   608,   608,  -577,
    1843,   970,   607,  1360,   606,   608,  -590,  -594,   973,   976,
    1143,   265,  1145,  1147,   608,  1363,  1365,  1367,  1076,   509,
    1078,   510,   379,   692,   382,  1375,  1080,  1746,  1203,  1698,
     380,  1077,  1205,   521,  1207,  1076,  1210,  1076,   523,  1076,
    1212,  1394,  1214,  1076,   586,  1216,  1375,  1218,  1375,  1748,
     787,  1324,  1429,  1346,   606,  1793,  1070,   694,  1220,  1070,
    1222,   383,  1070,  1224,   608,  1070,   696,  1108,  1077,  1077,
    1077,  1077,  1227,  1070,  1081,  1077,   266,  1229,   698,  1865,
    1231,  1233,   575,  1242,  1685,   547,  1244,  1375,  1080,  1246,
    1255,   389,  1871,   566,   566,  1077,   602,   603,   604,   605,
     606,  1080,  1257,  1259,  1078,  1261,   590,   567,   567,  1263,
     608,  1081,  1081,  1081,  1081,  -977,  1288,  1445,  1081,  1460,
     594,  1720,  1721,  1722,  1723,  1076,   596,   598,   390,  1461,
    1494,   600,   509,   624,   510,   745,  1298,   746,  1081,  1299,
     674,  1078,  1078,  1078,  1078,   687,   700,   748,  1078,   749,
    1080,   751,   754,   752,   755,   757,   778,   758,   779,  1070,
     899,  1423,   900,   509,  1424,   510,   553,   717,  1078,  1080,
     719,   725,   989,   729,   702,   704,  1070,   855,  1070,   857,
    1070,   859,  1844,   920,  1070,   706,   708,  1076,   577,   959,
    1784,   961,  1128,  1471,  1130,  1132,  1134,  1136,  1426,  1432,
    1076,  1578,  1588,  1591,  1434,  1436,   291,  1438,  1104,  1449,
    1451,  1453,  1455,  1599,  1601,  1603,  1482,   579,   555,  1484,
    1517,  1105,   559,   560,   561,   562,   557,  1611,  1080,  1111,
     603,   604,   710,  1613,  1615,  1497,  1623,  1111,   603,   604,
    1626,  1628,  1630,  1632,  1633,  1634,  1635,   902,   903,  1076,
     771,   570,  1077,  1077,   773,   566,  1270,   292,  1637,  1639,
    1641,  1643,  1645,  1647,  1649,   581,  1070,   572,  1076,   567,
     775,   587,   829,  1270,   831,  1270,   938,  1270,   515,  1518,
     294,  1270,   559,   560,   561,   562,   591,  1077,  1077,  1077,
    1077,   622,   942,   296,   626,  1081,  1081,   628,   944,   630,
     671,   675,  1489,   509,   267,   510,   678,   680,   682,   684,
     688,   690,  1080,   712,  1468,   714,   720,   730,  1472,   732,
     734,   736,   738,   740,   742,  1078,  1078,  1076,  1070,   759,
    1081,  1081,  1081,  1081,   761,   268,  1711,   763,   765,   767,
     769,  1070,   780,   782,   269,   784,   786,   791,   298,  1080,
    1080,  1080,  1080,   270,   793,   799,  1080,   271,   801,  1077,
    1078,  1078,  1078,  1078,   803,   805,   807,   809,   559,   560,
     561,   562,   811,   813,   566,   815,  1080,   817,   819,   821,
     823,   825,  1513,   827,   833,  1519,   835,   837,   567,   839,
    1070,   846,   848,   850,   852,   860,   862,   864,   868,   870,
     272,   872,  1081,   874,   876,   878,   880,   882,   566,  1070,
     884,  1076,  1853,   886,   888,   890,  1077,   566,   892,  1077,
    1077,   894,   567,   896,   905,  1466,   907,   909,   911,   566,
     913,   567,  1078,  1077,  1077,  1077,   915,  1077,  1466,   917,
    1077,  1077,   921,   567,   273,   300,   302,   576,  1076,  1076,
    1076,  1076,   348,   923,   925,  1076,   304,   927,   929,  1081,
     931,   946,  1081,  1081,   948,   950,   952,   954,  1070,  1866,
     956,  1439,  1870,  1441,  1469,  1076,  1081,  1081,  1081,  1514,
    1081,  1521,   349,  1081,  1081,   563,   350,  1873,  1874,  1078,
     351,   353,  1078,  1078,   354,   558,   306,   566,   602,   603,
     604,   605,   606,   308,  1446,   534,  1078,  1078,  1078,   607,
    1078,   567,   608,  1078,  1078,  1383,   545,  1462,   310,   312,
     314,   316,   621,  1463,   625,   566,   566,   318,  1359,   355,
    1545,  1473,  1546,  1080,  1080,   356,   566,   566,  1349,   567,
     567,  1791,  1104,   320,   322,   563,  1381,  1796,  1112,  1114,
     567,   567,  1070,   578,  1390,  1105,   357,   324,   602,   603,
     604,   605,   606,   540,   358,  1270,   326,   359,  1080,  1080,
    1080,  1080,   608,  1486,  1550,  1488,  1551,  1490,   328,   330,
     332,   334,   580,   566,   559,   560,   561,   562,   293,  1070,
    1070,  1070,  1070,   336,   338,   340,  1070,   567,  1520,  1524,
    1527,   566,   342,   344,   346,   566,   559,   560,   561,   562,
     537,   295,   420,   422,   424,   567,  1070,   426,   478,   567,
     360,   566,  1841,   566,   297,   566,  1552,   566,  1553,   632,
     582,   563,  1076,  1076,  1791,   567,   588,   567,   633,   567,
    1080,   567,  1711,   566,   602,   603,   604,   605,   606,   566,
     634,   592,   559,   560,   561,   562,   623,   567,   608,   627,
     639,   361,   629,   567,   631,   672,   676,  1076,  1076,  1076,
    1076,   679,   681,   683,   685,   689,   691,   640,   713,   299,
     715,   721,   731,   362,   733,   735,   737,   739,   741,   743,
    1350,  1351,   641,  1270,   760,  1353,  1354,  1080,   642,   762,
    1080,  1080,   764,   766,   768,   770,   643,   781,   783,  1872,
     785,   787,   792,  1270,  1080,  1080,  1080,   841,  1080,   794,
     800,  1080,  1080,   802,  1413,  1414,  1415,  1416,  1417,   804,
     806,   808,   810,   566,  1554,   644,  1555,   812,   814,  1076,
     816,   645,   818,   820,   822,   824,   826,   567,   828,   834,
    1523,   836,   838,   363,   840,   646,   847,   849,   851,   853,
     861,   863,   865,   869,   871,  1786,   873,   566,   875,   877,
     879,   881,   883,  1070,  1070,   885,   301,   303,   887,   889,
     891,   567,   364,   893,  1838,   647,   895,   305,   897,   906,
     365,   908,   910,   912,   366,   914,  1076,   648,   649,  1076,
    1076,   916,   650,   367,   918,   651,  1812,   922,  1070,  1070,
    1070,  1070,   652,  1076,  1076,  1076,   368,  1076,   924,   926,
    1076,  1076,   928,   930,   369,   932,   947,   307,   370,   949,
     951,   953,   955,   371,   309,   957,  1440,   372,  1442,  1470,
     373,  1559,   374,  1560,  1515,   391,  1522,   563,   653,   311,
     313,   315,   317,   392,  1350,  1351,   393,   394,   319,  1353,
    1354,  1384,  1385,  1386,  1387,   395,   994,  1350,  1351,   563,
    1270,  1466,  1353,  1354,   321,   323,   396,  1350,  1351,  1352,
    1070,   397,  1353,  1354,   398,  1350,  1351,  1352,   325,   399,
    1353,  1354,  1536,  1350,  1351,  1352,   400,   327,  1353,  1354,
     401,   402,  1537,   403,  1779,  1270,  1270,  1270,  1270,   329,
     331,   333,   335,   404,  1538,   563,  1539,   933,   934,   935,
     936,  1561,   937,  1562,   337,   339,   341,   405,   602,   603,
     604,   605,   606,   343,   345,   347,   406,  1070,   407,   607,
    1070,  1070,   608,   421,   423,   425,   962,   964,   427,   479,
    1536,   408,   654,   409,  1070,  1070,  1070,  1563,  1070,  1564,
    1537,  1070,  1070,   410,    -2,   525,   842,   843,   844,   845,
     411,  1568,  1547,  1569,  1548,     2,   412,   413,   414,   -11,
     -11,   -13,     3,     4,   -16,   -18,   -20,   415,  1570,  1572,
    1571,  1573,   655,   416,  1115,  1116,  1117,  1716,   417,  1717,
    1115,  1116,  1117,     5,  1536,     6,   418,     7,     8,     9,
      10,    11,  1536,  1333,  1537,  1338,  1797,  1343,  1798,  1348,
     419,  1536,  1537,    12,   428,   429,  1556,   430,  1557,   431,
    1799,  1537,   432,  1801,  1565,   433,  1566,   434,  1270,   435,
     436,   437,   438,  1574,   439,  1575,  1118,  1119,   656,   440,
    1839,  1270,  1118,  1119,   441,  1270,   442,   443,  1270,  1270,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,   444,   445,   446,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,   447,    73,    74,    75,   448,   449,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   450,   657,   451,   452,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,  1120,   201,
     202,  1592,  1315,  1622,  1120,   203,   453,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,  1271,  1272,  1273,  1274,  1275,  1276,  1277,  1278,  1279,
     454,   455,   456,   218,   219,   220,  1395,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,  1417,   457,
     458,   459,   460,   602,   603,   604,   605,   606,   461,  1280,
     462,   221,   463,  1149,  1150,  1151,  1152,   608,  1154,   222,
    1156,  1479,  1158,   464,   465,  1264,   223,  -677,  -677,  -677,
    -677,  -677,  -677,  -677,  -677,   466,  -677,  -677,  -677,  -677,
     467,   468,   469,   470,   471,   472,   473,  -677,  -677,  -677,
    -677,  -677,  -677,  -677,  -677,   474,  -677,  -677,  -677,  -677,
    -677,  -677,  -677,  -677,  -677,   475,  -677,   476,  -677,   477,
     480,   481,  -677,   482,  -677,  -677,  -677,  -677,  -677,  -677,
    -677,  -677,   483,   484,  -677,  -677,  -677,   485,   486,   487,
    -677,  -677,  -677,  -677,  -677,  -677,  1264,   488,  -645,  -645,
    -645,  -645,  -645,  -645,  -645,  -645,   489,  -645,  -645,  -645,
    -645,   490,   491,   492,   493,   495,   496,   497,  -645,  -645,
    -645,  -645,  -645,  -645,  -645,  -645,   498,  -645,  -645,  -645,
    -645,  -645,  -645,  -645,  -645,  -645,   499,  -645,   500,  -645,
     501,   502,   503,  -645,   504,  -645,  -645,  -645,  -645,  -645,
    -645,  -645,  -645,   505,   506,  -645,  -645,  -645,   507,   658,
     659,  -645,  -645,  -645,  -645,  -645,  -645,  1359,   660,  -649,
    -649,  -649,  -649,  -649,  -649,  -649,  -649,   661,  -649,  -649,
    -649,  -649,   662,   663,   664,   665,   666,   677,   963,  -649,
    -649,  -649,  -649,  -649,  -649,  -649,  -649,   667,  -649,  -649,
    -649,  -649,  -649,  -649,  -649,  -649,  -649,   668,  -649,   722,
    -649,   723,   726,   727,  -649,   795,  -649,  -649,  -649,  -649,
    -649,  -649,  -649,  -649,   796,   797,  -649,  -649,  -649,   798,
     904,   940,  -649,  -649,  -649,  -649,  -649,  -649,  1359,   941,
    -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,   968,  -666,
    -666,  -666,  -666,   971,   974,   977,   984,   987,   979,   988,
    -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,   986,  -666,
    -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,   606,  -666,
    1000,  -666,   992,   993,  1005,  -666,  1006,  -666,  -666,  -666,
    -666,  -666,  -666,  -666,  -666,  1007,  1008,  -666,  -666,  -666,
    1009,  1010,  1011,  -666,  -666,  -666,  -666,  -666,  -666,  1395,
    1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,  1404,  1405,
    1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,  1417,   602,   603,   604,   605,   606,  1013,  1093,  1094,
    1095,  -677,  1102,   607,  1099,  1300,   608,  1100,  1101,  1109,
    1123,  1124,  1605,  1125,  1126,  1137,  1208,  -677,  -677,  -677,
    -677,  -677,  -677,  -677,  -677,  -677,  -677,  -677,  -677,  -677,
    -677,  -677,  -677,  -677,  -677,  -677,  -677,  -677,  -677,  -677,
    1225,  1234,  1235,  1236,  1284,  1237,  -677,  1238,  1247,  1248,
    1249,  -677,  1250,  1286,  1289,  -677,  -677,  1290,  -677,  -677,
    -677,  -977,  -677,  1292,  1294,  1302,  1296,  -677,  1303,  1305,
    1309,  1310,  -645,  1409,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,  1417,  1311,  1312,  1313,  1314,  1317,  1318,  -645,  -645,
    -645,  -645,  -645,  -645,  -645,  -645,  -645,  -645,  -645,  -645,
    -645,  -645,  -645,  -645,  -645,  -645,  -645,  -645,  -645,  -645,
    -645,  1319,  1320,  1321,  1430,  1505,  1492,  1368,  1369,  1370,
    1443,  1501,  -645,  1447,  1456,  1457,  -645,  -645,  1506,  -645,
    -645,  -645,  -977,  -645,  1458,  1475,  1476,  1477,  -645,  1478,
    1509,  1491,  1493,  -649,  1502,  1503,  1504,  1511,  1512,  1529,
    1595,  1540,  1549,  1558,  -748,  1567,  1604,  -749,  1651,  -649,
    -649,  -649,  -649,  -649,  -649,  -649,  -649,  -649,  -649,  -649,
    -649,  -649,  -649,  -649,  -649,  -649,  -649,  -649,  -649,  -649,
    -649,  -649,  -760,  -761,  1606,  1607,  1650,  1624,  1652,  1653,
    1654,  1655,  1686,  -649,  1658,  1659,  1660,  -649,  -649,  1661,
    -649,  -649,  -649,  1662,  -649,  1663,  1664,  1665,  1666,  -649,
    1729,  1667,  1668,  1669,  -666,  1670,  1671,  1672,  1673,  1674,
    1675,  1676,  1677,  1678,  1679,  1680,  1280,  1724,  1681,  1682,
    -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,
    -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,  -666,
    -666,  -666,  -666,  1683,  1684,  1687,  1688,  1689,  1690,  1691,
    1694,  1701,  1702,  1725,  -666,  1703,  1704,     1,  -666,  -666,
    1692,  -666,  -666,  -666,  1693,  -666,  1705,     2,  1706,  1707,
    -666,   -11,   -11,   -13,     3,     4,   -16,   -18,   -20,  1402,
    1403,  1404,  1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,
    1413,  1414,  1415,  1416,  1417,     5,  1708,     6,  1709,     7,
       8,     9,    10,    11,  1710,  1715,  1719,  1726,  1728,  1732,
    1733,  1735,  1734,  1736,  1737,    12,  1738,  1739,  1743,  1744,
    1749,  1752,  1753,  1754,  1395,  1396,  1397,  1398,  1399,  1400,
    1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,  1409,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,  1417,  1757,  1758,  1759,
    1762,  1763,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,  1657,  1764,  1767,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,  1768,    73,    74,    75,  1769,
    1770,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,  1771,  1772,  1774,  1778,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
    1776,   201,   202,  1780,  1781,  1787,  1792,   203,  1808,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,  1809,  1810,  1813,  1814,  1815,  1816,  1817,
    1848,  1818,  1819,  1820,  1860,   218,   219,   220,  1821,  1822,
    1395,  1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,  1404,
    1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,  1417,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1830,  1831,  1616,   221,  1016,  1017,  1018,  1019,  1020,  1832,
    1833,   222,  1845,  1773,  1025,  1026,  1027,  1834,   223,  1835,
    1836,  1837,  1846,  1847,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,  1849,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1852,  1045,  1854,  1046,  1857,  1858,  1859,  1861,
    1862,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1863,  1867,
     526,  1868,  1057,  1058,  1304,  1107,  1012,  1059,  1060,  1061,
    1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1617,
    1165,  1869,  1590,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,  1316,  1024,  1025,  1026,  1027,  1014,  1507,   788,   991,
     790,  1593,  1594,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1851,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1794,  1045,  1714,  1046,  1840,  1856,     0,  1047,     0,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  -709,  -709,
    1056,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,
    1063,  1064,  1268,     0,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,     0,  1024,  1025,  1026,  1027,     0,     0,     0,
       0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,  1047,
       0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  -711,
    -711,  1056,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,
    1062,  1063,  1064,  1268,     0,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,     0,     0,
       0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,
    1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,
    -713,  -713,  1056,  1057,  1058,     0,     0,     0,  1059,  1060,
    1061,  1062,  1063,  1064,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,  1166,
    1395,  1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,  1404,
    1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,  1417,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1167,     0,     0,     0,  1168,     0,  1169,
    1170,  1171,  1172,  1775,  1173,  1174,  1175,  1618,  1619,     0,
    1176,   606,  1067,  1068,     0,     0,     0,     0,  1239,  1178,
       0,   608,     0,     0,     0,     0,  1268,     0,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,
    1027,     0,     0,     0,     0,     0,     0,  1065,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,
       0,     0,     0,  1047,     0,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,  -707,  -707,  1056,  1057,  1058,     0,     0,
       0,  1059,  1060,  1061,  1062,  1063,  1064,  1066,     0,     0,
       0,  1067,  1068,     0,     0,  1069,     0,     0,     0,  -709,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,  1395,
    1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,  1404,  1405,
    1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,  1417,  1398,  1399,  1400,  1401,  1402,  1403,  1404,  1405,
    1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,  1417,  1855,     0,     0,     0,     0,     0,  1066,     0,
       0,     0,  1067,  1068,     0,     0,  1069,     0,     0,     0,
    -711,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
    1395,  1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,  1404,
    1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,
    1415,  1416,  1417,  1399,  1400,  1401,  1402,  1403,  1404,  1405,
    1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,
    1416,  1417,     0,  1875,     0,     0,     0,     0,     0,  1066,
       0,     0,     0,  1067,  1068,     0,     0,  1069,     0,     0,
    1268,  -713,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
       0,  1024,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,  1047,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,  -714,  -714,  1056,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1268,     0,  1016,  1017,  1018,  1019,  1020,  1021,  1022,
    1023,     0,  1024,  1025,  1026,  1027,     0,     0,     0,     0,
       0,     0,  1065,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,     0,  1045,     0,  1046,     0,     0,     0,  1047,     0,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,  -708,  -708,
    1056,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,
    1063,  1064,  1066,     0,     0,     0,  1067,  1068,     0,     0,
    1069,     0,     0,  1268,  -707,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,     0,     0,
       0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,
    1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,
       0,     0,  1056,  1057,  1058,     0,     0,     0,  1059,  1060,
    1061,  1062,  1063,  1064,  1268,     0,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,  1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,     0,     0,  1056,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1268,     0,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,
       0,     0,     0,     0,     0,     0,  1065,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,
       0,     0,  1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,     0,     0,  1056,  1057,  1058,     0,     0,     0,
    1059,  1060,  1061,  1062,  1063,  1064,  1066,     0,     0,     0,
    1067,  1068,     0,     0,  1069,     0,     0,     0,  -714,     0,
       0,     0,     0,     0,     0,     0,     0,  1065,  1395,  1396,
    1397,  1398,  1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,
    1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
    1417,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,  1417,  1777,
       0,     0,     0,     0,     0,     0,     0,  1066,     0,     0,
       0,  1067,  1068,     0,     0,  1069,     0,     0,  1268,  -708,
    1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,     0,  1024,
    1025,  1026,  1027,     0,     0,     0,     0,     0,     0,  1065,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,
       0,  1046,     0,     0,     0,  1047,     0,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,  1055,     0,     0,  1056,  1057,  1058,
       0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1066,
       0,     0,     0,  1067,  1068,     0,     0,  1069,     0,     0,
       0,  1269,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,  1395,  1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,
    1404,  1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,  1413,
    1414,  1415,  1416,  1417,  1401,  1402,  1403,  1404,  1405,  1406,
    1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
    1417,     0,  1864,     0,     0,     0,     0,     0,     0,     0,
    1066,     0,     0,     0,  1067,  1068,     0,     0,  1069,     0,
       0,     0,  1291,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,  1395,  1396,  1397,  1398,  1399,  1400,  1401,  1402,
    1403,  1404,  1405,  1406,  1407,  1408,  1409,  1410,  1411,  1412,
    1413,  1414,  1415,  1416,  1417,  1396,  1397,  1398,  1399,  1400,
    1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,  1409,  1410,
    1411,  1412,  1413,  1414,  1415,  1416,  1417,     0,     0,     0,
       0,  1066,     0,     0,     0,  1067,  1068,     0,     0,  1069,
       0,     0,  1268,  1293,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,     0,  1024,  1025,  1026,  1027,     0,     0,     0,
       0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,  1047,
       0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,     0,
       0,  1056,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,
    1062,  1063,  1064,  1268,     0,  1016,  1017,  1018,  1019,  1020,
    1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,     0,     0,
       0,     0,     0,     0,  1065,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,
    1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1055,
       0,     0,  1056,  1057,  1058,     0,     0,     0,  1059,  1060,
    1061,  1062,  1063,  1064,  1066,     0,     0,     0,  1067,  1068,
       0,     0,  1069,     0,     0,  1268,  1295,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,
       0,     0,     0,     0,     0,     0,     0,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,
       0,     0,  1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,     0,     0,  1056,  1057,  1058,     0,     0,     0,
    1059,  1060,  1061,  1062,  1063,  1064,  1268,     0,  1016,  1017,
    1018,  1019,  1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,
    1027,     0,     0,     0,     0,     0,     0,     0,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,
       0,     0,     0,  1047,     0,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,  1055,     0,     0,  1056,  1057,  1058,     0,     0,
       0,  1059,  1060,  1061,  1062,  1063,  1064,  1268,     0,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,     0,  1024,  1025,
    1026,  1027,     0,     0,     0,     0,     0,     0,  1065,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,
    1046,     0,     0,     0,  1047,     0,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,  1055,     0,     0,  1056,  1057,  1058,     0,
       0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1066,     0,
       0,     0,  1067,  1068,     0,     0,  1069,     0,     0,     0,
    1301,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
    1397,  1398,  1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,
    1407,  1408,  1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,
    1417,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1066,
       0,     0,     0,  1067,  1068,     0,     0,  1069,     0,     0,
    1268,  1608,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
       0,  1024,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,  1065,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,  1047,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,     0,     0,  1056,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1066,     0,     0,     0,  1067,  1068,     0,     0,  1069,
       0,     0,     0,  1727,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1066,     0,     0,     0,  1067,  1068,     0,     0,
    1069,     0,     0,     0,  1740,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1066,     0,     0,     0,  1067,  1068,     0,
       0,  1069,     0,     0,  1268,  1782,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,  1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,     0,     0,  1056,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1268,     0,  1016,  1017,  1018,
    1019,  1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,
       0,     0,     0,     0,     0,     0,  1065,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,
       0,     0,  1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,     0,     0,  1056,  1057,  1058,     0,     0,     0,
    1059,  1060,  1061,  1062,  1063,  1064,  1066,     0,     0,     0,
    1067,  1068,     0,     0,  1069,     0,     0,  1268,  1802,  1016,
    1017,  1018,  1019,  1020,  1021,  1022,  1023,     0,  1024,  1025,
    1026,  1027,     0,     0,     0,     0,     0,     0,     0,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,
    1046,     0,     0,     0,  1047,     0,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,  1055,     0,     0,  1056,  1057,  1058,     0,
       0,     0,  1059,  1060,  1061,  1062,  1063,  1064,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1579,     0,  1016,  1017,
    1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,  1026,
    1027,     0,     0,     0,     0,     0,     0,     0,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,
       0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,     0,
    1065,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,
    1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,  1162,  1163,  1164,  1165,  1580,  1581,  1582,  1583,  1584,
    1585,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1066,     0,     0,     0,  1067,  1068,     0,     0,  1069,     0,
       0,     0,  1803,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1066,     0,     0,     0,  1067,  1068,     0,     0,  1069,
       0,     0,     0,  1804,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1066,     0,     0,     0,  1067,  1068,     0,
       0,  1069,     0,     0,     0,  1805,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,  1166,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1167,  1586,     0,
       0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,  1174,
    1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,     0,
       0,     0,  1239,  1178,  1589,     0,  1016,  1017,  1018,  1019,
    1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,     0,     0,     0,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,  1580,  1581,  1582,  1583,  1584,  1585,  1371,
       0,  1016,  1017,  1018,  1019,  1020,     0,     0,     0,     0,
       0,  1025,  1026,  1027,     0,     0,     0,     0,     0,     0,
       0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,
    1045,     0,  1046,     0,     0,     0,     0,     0,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,     0,     0,     0,  1057,
    1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1371,     0,
    1016,  1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,
    1025,  1026,  1027,     0,     0,     0,     0,     0,     0,     0,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,
       0,  1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,
       0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,
    1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,  1160,  1161,  1162,  1163,  1164,  1165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,  1166,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1167,  1586,     0,     0,  1168,
       0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,
    1066,     0,  1176,     0,  1067,  1068,     0,     0,     0,     0,
    1239,  1178,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,  1166,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1167,     0,     0,     0,  1168,     0,  1169,  1170,  1171,  1172,
       0,  1173,  1174,  1175,   567,  1066,     0,  1176,     0,  1067,
    1068,     0,     0,     0,  1372,  1239,  1178,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,  1166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1167,
       0,     0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,
    1173,  1174,  1175,   567,  1066,     0,  1176,     0,  1067,  1068,
       0,     0,     0,  1420,  1239,  1178,  1371,     0,  1016,  1017,
    1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,  1026,
    1027,     0,     0,     0,     0,     0,     0,     0,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,
       0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,     0,
       0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,
    1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,  1162,  1163,  1164,  1165,  1788,     0,  1016,  1017,  1018,
    1019,  1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,
       0,     0,     0,     0,     0,     0,     0,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,
       0,     0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,     0,     0,     0,  1057,  1058,     0,     0,     0,
    1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,
    1162,  1163,  1164,  1165,  1251,     0,  1016,  1017,  1018,  1019,
    1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,     0,     0,     0,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,  1166,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1167,     0,     0,
       0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,  1174,
    1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,     0,
       0,  1421,  1239,  1178,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,  1166,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1167,     0,  1789,     0,
    1168,     0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,
     567,  1066,     0,  1176,     0,  1067,  1068,     0,     0,     0,
       0,  1239,  1178,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,  1166,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1167,     0,     0,     0,  1168,
       0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,
    1066,     0,  1176,     0,  1067,  1068,     0,     0,     0,     0,
    1239,  1178,  1362,     0,  1016,  1017,  1018,  1019,  1020,     0,
       0,     0,     0,     0,  1025,  1026,  1027,     0,     0,     0,
       0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,     0,
       0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,     0,
       0,     0,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,
    1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,
    1165,  1364,     0,  1016,  1017,  1018,  1019,  1020,     0,     0,
       0,     0,     0,  1025,  1026,  1027,     0,     0,     0,     0,
       0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,     0,  1045,     0,  1046,     0,     0,     0,     0,     0,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,     0,     0,
       0,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,
    1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,
    1366,     0,  1016,  1017,  1018,  1019,  1020,     0,     0,     0,
       0,     0,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,     0,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,     0,     0,     0,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,  1166,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1167,     0,     0,     0,  1168,     0,  1169,
    1170,  1171,  1172,     0,  1173,  1174,  1175,   567,  1066,     0,
    1176,     0,  1067,  1068,     0,     0,     0,     0,  1239,  1178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1065,  1166,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1167,     0,     0,     0,  1168,     0,  1169,  1170,
    1171,  1172,     0,  1173,  1174,  1175,   567,  1066,     0,  1176,
       0,  1067,  1068,     0,     0,     0,     0,  1239,  1178,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,  1166,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1167,     0,     0,     0,  1168,     0,  1169,  1170,  1171,
    1172,     0,  1173,  1174,  1175,   567,  1066,     0,  1176,     0,
    1067,  1068,     0,     0,     0,     0,  1239,  1178,  1393,     0,
    1016,  1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,
    1025,  1026,  1027,     0,     0,     0,     0,     0,     0,     0,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,
       0,  1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,
       0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,
    1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,  1160,  1161,  1162,  1163,  1164,  1165,  1427,     0,  1016,
    1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,
    1026,  1027,     0,     0,     0,     0,     0,     0,     0,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,
    1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,
       0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,
    1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1371,     0,  1016,  1017,
    1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,  1026,
    1027,     0,     0,     0,     0,     0,     0,     0,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,
       0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,     0,
       0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,
    1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,  1162,  1163,  1164,  1165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,  1166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1167,
       0,     0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,
    1173,  1174,  1175,   567,  1066,     0,  1176,     0,  1067,  1068,
       0,     0,     0,     0,  1239,  1178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,  1166,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1167,     0,
       0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,
    1174,  1175,   567,  1428,     0,  1176,     0,  1067,  1068,     0,
       0,     0,     0,  1239,  1178,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,  1166,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1167,     0,     0,
       0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,  1174,
    1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,     0,
       0,     0,  1239,  1178,  1576,     0,  1016,  1017,  1018,  1019,
    1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,     0,     0,     0,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,  1598,     0,  1016,  1017,  1018,  1019,  1020,
       0,     0,     0,     0,     0,  1025,  1026,  1027,     0,     0,
       0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,
       0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
       0,     0,     0,  1057,  1058,     0,     0,     0,  1059,  1060,
    1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,
    1164,  1165,  1600,     0,  1016,  1017,  1018,  1019,  1020,     0,
       0,     0,     0,     0,  1025,  1026,  1027,     0,     0,     0,
       0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,     0,
       0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,     0,
       0,     0,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,
    1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,
    1165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,  1166,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1167,     0,     0,     0,  1168,
       0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,
    1577,     0,  1176,     0,  1067,  1068,     0,     0,     0,     0,
    1239,  1178,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
    1166,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1167,     0,     0,     0,  1168,     0,
    1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,  1066,
       0,  1176,     0,  1067,  1068,     0,     0,     0,     0,  1239,
    1178,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,  1166,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1167,     0,     0,     0,  1168,     0,  1169,
    1170,  1171,  1172,     0,  1173,  1174,  1175,   567,  1066,     0,
    1176,     0,  1067,  1068,     0,     0,     0,     0,  1239,  1178,
    1602,     0,  1016,  1017,  1018,  1019,  1020,     0,     0,     0,
       0,     0,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,     0,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,     0,     0,     0,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1609,
       0,  1016,  1017,  1018,  1019,  1020,     0,     0,     0,     0,
       0,  1025,  1026,  1027,     0,     0,     0,     0,     0,     0,
       0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,
    1045,     0,  1046,     0,     0,     0,     0,     0,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,     0,     0,     0,  1057,
    1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1162,  1163,  1610,  1165,  1612,     0,
    1016,  1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,
    1025,  1026,  1027,     0,     0,     0,     0,     0,     0,     0,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,
       0,  1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,
       0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,
    1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,  1160,  1161,  1162,  1163,  1164,  1165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,  1166,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1167,     0,     0,     0,  1168,     0,  1169,  1170,  1171,
    1172,     0,  1173,  1174,  1175,   567,  1066,     0,  1176,     0,
    1067,  1068,     0,     0,     0,     0,  1239,  1178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,  1166,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1167,     0,     0,     0,  1168,     0,  1169,  1170,  1171,  1172,
       0,  1173,  1174,  1175,   567,  1066,     0,  1176,     0,  1067,
    1068,     0,     0,     0,     0,  1239,  1178,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,  1166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1167,
       0,     0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,
    1173,  1174,  1175,   567,  1066,     0,  1176,     0,  1067,  1068,
       0,     0,     0,     0,  1239,  1178,  1614,     0,  1016,  1017,
    1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,  1026,
    1027,     0,     0,     0,     0,     0,     0,     0,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,
       0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,     0,
       0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,
    1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,  1162,  1163,  1164,  1165,  1625,     0,  1016,  1017,  1018,
    1019,  1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,
       0,     0,     0,     0,     0,     0,     0,  1028,  1029,  1030,
    1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,
       0,     0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,     0,     0,     0,  1057,  1058,     0,     0,     0,
    1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,
    1162,  1163,  1164,  1165,  1627,     0,  1016,  1017,  1018,  1019,
    1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,     0,     0,     0,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,  1166,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1167,     0,     0,
       0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,  1174,
    1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,     0,
       0,     0,  1239,  1178,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,  1166,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1167,     0,     0,     0,
    1168,     0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,
     567,  1066,     0,  1176,     0,  1067,  1068,     0,     0,     0,
       0,  1239,  1178,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,  1166,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1167,     0,     0,     0,  1168,
       0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,
    1066,     0,  1176,     0,  1067,  1068,     0,     0,     0,     0,
    1239,  1178,  1629,     0,  1016,  1017,  1018,  1019,  1020,     0,
       0,     0,     0,     0,  1025,  1026,  1027,     0,     0,     0,
       0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,     0,
       0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,     0,
       0,     0,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,
    1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,
    1165,  1631,     0,  1016,  1017,  1018,  1019,  1020,     0,     0,
       0,     0,     0,  1025,  1026,  1027,     0,     0,     0,     0,
       0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,     0,  1045,     0,  1046,     0,     0,     0,     0,     0,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,     0,     0,
       0,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,
    1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,
    1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,
    1636,     0,  1016,  1017,  1018,  1019,  1020,     0,     0,     0,
       0,     0,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,     0,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,     0,     0,     0,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,  1166,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1167,     0,     0,     0,  1168,     0,  1169,
    1170,  1171,  1172,     0,  1173,  1174,  1175,   567,  1066,     0,
    1176,     0,  1067,  1068,     0,     0,     0,     0,  1239,  1178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1065,  1166,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1167,     0,     0,     0,  1168,     0,  1169,  1170,
    1171,  1172,     0,  1173,  1174,  1175,   567,  1066,     0,  1176,
       0,  1067,  1068,     0,     0,     0,     0,  1239,  1178,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,  1166,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1167,     0,     0,     0,  1168,     0,  1169,  1170,  1171,
    1172,     0,  1173,  1174,  1175,   567,  1066,     0,  1176,     0,
    1067,  1068,     0,     0,     0,     0,  1239,  1178,  1638,     0,
    1016,  1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,
    1025,  1026,  1027,     0,     0,     0,     0,     0,     0,     0,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,
    1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,
       0,  1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,
       0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,
    1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,
    1159,  1160,  1161,  1162,  1163,  1164,  1165,  1640,     0,  1016,
    1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,
    1026,  1027,     0,     0,     0,     0,     0,     0,     0,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,
    1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,
       0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,
    1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1642,     0,  1016,  1017,
    1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,  1026,
    1027,     0,     0,     0,     0,     0,     0,     0,  1028,  1029,
    1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,  1046,
       0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,     0,
       0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,
    1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,  1162,  1163,  1164,  1165,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1065,  1166,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1167,
       0,     0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,
    1173,  1174,  1175,   567,  1066,     0,  1176,     0,  1067,  1068,
       0,     0,     0,     0,  1239,  1178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,  1166,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1167,     0,
       0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,
    1174,  1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,
       0,     0,     0,  1239,  1178,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1065,  1166,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1167,     0,     0,
       0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,  1174,
    1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,     0,
       0,     0,  1239,  1178,  1644,     0,  1016,  1017,  1018,  1019,
    1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,     0,     0,     0,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,  1646,     0,  1016,  1017,  1018,  1019,  1020,
       0,     0,     0,     0,     0,  1025,  1026,  1027,     0,     0,
       0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,
       0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
       0,     0,     0,  1057,  1058,     0,     0,     0,  1059,  1060,
    1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,
    1164,  1165,  1648,     0,  1016,  1017,  1018,  1019,  1020,     0,
       0,     0,     0,     0,  1025,  1026,  1027,     0,     0,     0,
       0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,  1033,
    1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,     0,
       0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,     0,
       0,     0,  1057,  1058,     0,     0,     0,  1059,  1060,  1061,
    1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,
    1165,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,  1166,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1167,     0,     0,     0,  1168,
       0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,
    1066,     0,  1176,     0,  1067,  1068,     0,     0,     0,     0,
    1239,  1178,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
    1166,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1167,     0,     0,     0,  1168,     0,
    1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,  1066,
       0,  1176,     0,  1067,  1068,     0,     0,     0,     0,  1239,
    1178,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1065,  1166,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1167,     0,     0,     0,  1168,     0,  1169,
    1170,  1171,  1172,     0,  1173,  1174,  1175,   567,  1066,     0,
    1176,     0,  1067,  1068,     0,     0,     0,     0,  1239,  1178,
    1850,     0,  1016,  1017,  1018,  1019,  1020,     0,     0,     0,
       0,     0,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,     0,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,     0,     0,     0,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1016,
    1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,
    1026,  1027,     0,     0,     0,     0,     0,     0,     0,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,
    1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,
       0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,
    1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1016,  1017,  1018,  1019,
    1020,     0,     0,     0,     0,     0,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,     0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,     0,     0,     0,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,
    1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,
    1163,  1164,  1165,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,  1166,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1167,     0,     0,     0,  1168,     0,  1169,  1170,  1171,
    1172,     0,  1173,  1174,  1175,   567,  1066,     0,  1176,     0,
    1067,  1068,     0,     0,     0,     0,  1239,  1178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,  1166,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1167,     0,
       0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,
    1174,  1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,
       0,     0,     0,  1177,  1178,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,  1166,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1167,     0,     0,     0,  1168,
       0,  1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,   567,
    1066,     0,  1176,     0,  1067,  1068,     0,     0,     0,     0,
    1198,  1178,  1016,  1017,  1018,  1019,  1020,     0,     0,     0,
       0,     0,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,     0,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,     0,     0,     0,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,
    1157,  1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1016,
    1017,  1018,  1019,  1020,     0,     0,     0,     0,     0,  1025,
    1026,  1027,     0,     0,     0,     0,     0,     0,     0,  1028,
    1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,  1045,     0,
    1046,     0,     0,     0,     0,     0,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,     0,     0,     0,  1057,  1058,     0,
       0,     0,  1059,  1060,  1061,  1062,  1063,  1064,  1148,  1149,
    1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1016,  1017,  1018,  1019,
    1020,  1021,  1022,  1023,     0,  1024,  1025,  1026,  1027,     0,
       0,     0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,
    1032,  1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,
       0,  1047,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
    1055,     0,     0,  1056,  1057,  1058,     0,     0,     0,  1059,
    1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1016,  1017,  1018,  1019,  1020,
       0,     0,     0,     0,     0,  1025,  1026,  1027,     0,     0,
       0,     0,     0,     0,     0,  1028,  1029,  1030,  1031,  1032,
    1033,  1034,  1035,     0,  1036,  1037,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,     0,  1045,     0,  1046,     0,     0,     0,
       0,     0,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
       0,     0,     0,  1057,  1058,     0,  1065,  1166,  1059,  1060,
    1061,  1062,  1063,  1064,  1148,  1149,  1150,  1151,  1152,  1153,
    1154,  1155,  1156,  1157,  1158,  1159,  1160,  1161,  1162,  1163,
    1164,  1165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1167,     0,     0,     0,  1168,     0,  1169,  1170,  1171,
    1172,     0,  1173,  1174,  1175,   567,  1066,     0,  1176,     0,
    1067,  1068,     0,     0,     0,     0,  1200,  1178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1065,  1166,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1167,     0,
       0,     0,  1168,     0,  1169,  1170,  1171,  1172,     0,  1173,
    1174,  1175,   567,  1066,     0,  1176,     0,  1067,  1068,     0,
       0,     0,     0,  1239,  1178,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1065,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1395,  1396,  1397,  1398,
    1399,  1400,  1401,  1402,  1403,  1404,  1405,  1406,  1407,  1408,
    1409,  1410,  1411,  1412,  1413,  1414,  1415,  1416,  1417,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1066,     0,     0,     0,  1067,  1068,     0,     0,  1069,     0,
       0,  1464,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1065,
    1166,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1167,     0,     0,     0,  1168,     0,
    1169,  1170,  1171,  1172,     0,  1173,  1174,  1175,  1795,  1066,
       0,  1176,     0,  1067,  1068,     0,     0,     0,     0,  1239,
    1178,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,     0,
    1024,  1025,  1026,  1027,     0,     0,     0,     0,     0,     0,
       0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,
    1045,     0,  1046,     0,     0,     0,  1047,     0,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,  1055,     0,     0,  1056,  1057,
    1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,
    1379,     0,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,
       0,  1024,  1025,  1026,  1027,     0,     0,     0,     0,     0,
       0,     0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
       0,  1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
       0,  1045,     0,  1046,     0,     0,     0,  1047,     0,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,  1055,     0,     0,  1056,
    1057,  1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,
    1064,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,     0,
    1024,  1025,  1026,  1027,     0,     0,     0,     0,     0,     0,
       0,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,     0,
    1036,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,     0,
    1045,     0,  1046,     0,     0,     0,  1047,     0,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,  1055,     0,     0,  1056,  1057,
    1058,     0,     0,     0,  1059,  1060,  1061,  1062,  1063,  1064,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1066,     0,     0,     0,  1067,
    1068,     0,     0,  1069,     0,     0,  1464,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1065,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1066,     0,     0,     0,
    1067,  1068,     0,     0,  1069,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1065,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1066,     0,     0,     0,  1067,
    1068,     0,     0,  1069
};

static const yytype_int16 yycheck[] =
{
     250,   217,   460,   253,   249,   968,  1305,  1253,   971,     1,
       1,   974,     1,  1139,   977,  1141,  1160,  1143,  1162,  1145,
    1164,  1147,   985,     1,     1,     1,     1,    64,     1,     1,
       1,   281,  1188,   283,     1,   285,     1,   287,  1182,     1,
       1,    64,     1,   332,     1,    64,     1,     1,   968,     1,
       1,   971,     1,     1,   974,   352,     1,   977,     1,    59,
     366,   971,    64,   369,   974,   985,   374,   977,   376,   366,
       1,     1,   352,     1,   332,   985,     1,     1,   968,   362,
     353,   971,    64,     1,   974,   332,   366,   977,     1,     1,
     112,   113,     1,   366,   332,   985,     1,   380,   348,     1,
       1,   381,   112,   113,     1,     1,     1,     1,  1071,   332,
     360,   361,   362,   363,   364,   365,   366,   367,   368,   369,
      63,     1,     1,     1,     1,  1088,     1,  1090,     1,  1092,
       1,     1,    63,  1096,     1,     1,     1,   352,    63,     1,
       1,     1,    90,    91,    92,    93,     1,   362,   352,   607,
      63,  1071,     1,     1,     1,     1,   374,     1,   376,   409,
     410,   411,   366,     1,   332,   369,     1,   371,  1088,  1180,
    1090,     1,  1092,  1184,     1,     1,  1096,     1,    58,    59,
       1,  1071,   352,     1,     1,    90,    91,    92,    93,   367,
       1,   369,   362,   443,   444,   332,     1,     1,  1088,     1,
    1090,     1,  1092,     1,    58,    59,  1096,   332,     1,     1,
       1,   332,     1,     1,  1177,  1178,   966,    63,   366,   367,
     970,   369,     1,   973,     1,   374,   976,   376,     1,     1,
       1,   366,   367,     1,   369,  1198,     1,  1200,   332,     1,
    1177,     1,     1,   366,   367,   495,   369,     1,   498,   499,
     332,     1,   111,   112,   113,     1,     1,  1177,  1178,     1,
       1,  1198,   332,  1200,     1,  1391,     1,     1,  1178,     1,
     332,     1,     1,     1,   332,     1,  1239,  1240,  1198,     1,
    1200,     1,   374,     1,   376,     1,   968,  1177,  1178,   971,
    1253,     1,   974,     1,     1,   977,     1,     1,     1,     1,
       1,     1,  1239,   985,    15,    16,     1,     1,  1198,     1,
    1200,     1,     1,     1,     1,   353,   354,   355,     1,  1239,
    1240,     1,     1,     1,   332,  1288,     1,   332,   317,   366,
     374,     1,   376,  1253,     1,   332,  1021,  1022,  1023,  1302,
       0,  1497,     1,   366,   374,     1,   376,   366,   332,  1239,
    1240,   332,     1,   374,    17,   376,     1,   332,  1321,   362,
     332,   383,  1047,  1253,   366,   332,   366,   367,  1288,   332,
    1055,  1056,     1,   332,     1,   332,   352,   332,   332,   332,
     369,   332,  1302,   372,   366,   968,   378,   378,   971,  1071,
     366,   974,  1302,  1692,   977,   366,   367,   368,   369,   370,
     378,  1321,   985,   380,   377,   353,  1088,   369,  1090,   380,
    1092,  1321,  1302,   378,  1096,   380,   377,  1380,   366,   367,
     368,   369,   370,   366,   367,   377,   369,   370,   377,   377,
     375,  1321,   380,   376,  1733,   366,   367,   380,   369,   370,
    1686,   366,   367,   367,   369,   370,   376,   377,   353,   380,
     378,   369,   380,   366,   367,   380,   369,   370,   370,   377,
    1380,   366,   367,   368,   369,   370,  1610,   380,   380,   378,
     366,   380,   377,  1617,   370,   380,   378,   378,   380,   380,
     377,   332,   377,   377,   380,  1170,  1171,  1172,  1071,   367,
    1380,   369,   369,     1,   332,  1177,  1178,   367,   377,   379,
     377,  1464,   377,   369,   377,  1088,   377,  1090,   369,  1092,
     377,  1196,   377,  1096,   369,   377,  1198,   377,  1200,   367,
     366,   367,  1207,   369,   370,   379,   968,     1,   377,   971,
     377,   369,   974,   377,   380,   977,     1,   995,  1501,  1502,
    1503,  1504,   377,   985,  1464,  1508,   332,   377,     1,  1848,
     377,   377,     1,   377,  1464,   366,   377,  1239,  1240,   377,
     377,   332,  1861,   352,   352,  1528,   366,   367,   368,   369,
     370,  1253,   377,   377,  1464,   377,   369,   366,   366,   377,
     380,  1501,  1502,  1503,  1504,   377,   377,   376,  1508,   366,
     369,  1501,  1502,  1503,  1504,  1178,   369,   369,   369,   376,
    1285,   369,   367,     1,   369,   367,   366,   369,  1528,   369,
     369,  1501,  1502,  1503,  1504,   369,     1,   367,  1508,   369,
    1302,   367,   367,   369,   369,   367,   367,   369,   369,  1071,
     367,   366,   369,   367,   369,   369,   366,   369,  1528,  1321,
     369,   369,  1100,   369,     1,     1,  1088,   369,  1090,   369,
    1092,   369,  1778,   369,  1096,     1,     1,  1240,     1,   369,
       1,   369,   369,     1,   369,   369,   369,   369,   369,   369,
    1253,  1356,  1357,  1358,   369,   369,   332,   369,   353,   369,
     369,   369,   369,  1368,  1369,  1370,   369,     1,   366,   369,
     369,   366,    90,    91,    92,    93,   366,  1382,  1380,   366,
     367,   368,     1,  1388,  1389,  1288,  1391,   366,   367,   368,
    1395,  1396,  1397,  1398,  1399,  1400,  1401,   366,   367,  1302,
       1,   366,  1685,  1686,     1,   352,  1071,     1,  1413,  1414,
    1415,  1416,  1417,  1418,  1419,     1,  1178,   366,  1321,   366,
       1,     1,     1,  1088,     1,  1090,     1,  1092,   964,     1,
       1,  1096,    90,    91,    92,    93,     1,  1720,  1721,  1722,
    1723,     1,     1,     1,     1,  1685,  1686,     1,     1,     1,
       1,     1,   366,   367,   332,   369,     1,     1,     1,     1,
       1,     1,  1464,     1,  1242,     1,     1,     1,  1246,     1,
       1,     1,     1,     1,     1,  1685,  1686,  1380,  1240,     1,
    1720,  1721,  1722,  1723,     1,   332,  1491,     1,     1,     1,
       1,  1253,     1,     1,   332,     1,     1,     1,     1,  1501,
    1502,  1503,  1504,   332,     1,     1,  1508,   332,     1,  1792,
    1720,  1721,  1722,  1723,     1,     1,     1,     1,    90,    91,
      92,    93,     1,     1,   352,     1,  1528,     1,     1,     1,
       1,     1,  1310,     1,     1,  1313,     1,     1,   366,     1,
    1302,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     332,     1,  1792,     1,     1,     1,     1,     1,   352,  1321,
       1,  1464,  1792,     1,     1,     1,  1849,   352,     1,  1852,
    1853,     1,   366,     1,     1,  1240,     1,     1,     1,   352,
       1,   366,  1792,  1866,  1867,  1868,     1,  1870,  1253,     1,
    1873,  1874,     1,   366,   332,     1,     1,   366,  1501,  1502,
    1503,  1504,   332,     1,     1,  1508,     1,     1,     1,  1849,
       1,     1,  1852,  1853,     1,     1,     1,     1,  1380,  1849,
       1,     1,  1852,     1,     1,  1528,  1866,  1867,  1868,     1,
    1870,     1,   332,  1873,  1874,   353,   332,  1867,  1868,  1849,
     332,   332,  1852,  1853,   332,     1,     1,   352,   366,   367,
     368,   369,   370,     1,  1224,    20,  1866,  1867,  1868,   377,
    1870,   366,   380,  1873,  1874,     1,   378,     1,     1,     1,
       1,     1,   268,  1238,   270,   352,   352,     1,     1,   332,
     374,  1246,   376,  1685,  1686,   332,   352,   352,     1,   366,
     366,  1696,   353,     1,     1,   353,     1,  1702,   998,   999,
     366,   366,  1464,   366,     1,   366,   332,     1,   366,   367,
     368,   369,   370,    22,   332,  1380,     1,   332,  1720,  1721,
    1722,  1723,   380,  1259,   374,  1261,   376,  1263,     1,     1,
       1,     1,   366,   352,    90,    91,    92,    93,   332,  1501,
    1502,  1503,  1504,     1,     1,     1,  1508,   366,  1313,  1319,
    1320,   352,     1,     1,     1,   352,    90,    91,    92,    93,
      21,   332,     1,     1,     1,   366,  1528,     1,     1,   366,
     332,   352,  1777,   352,   332,   352,   374,   352,   376,   366,
     366,   353,  1685,  1686,  1789,   366,   366,   366,   366,   366,
    1792,   366,  1797,   352,   366,   367,   368,   369,   370,   352,
     366,   366,    90,    91,    92,    93,   366,   366,   380,   366,
     366,   332,   366,   366,   366,   366,   366,  1720,  1721,  1722,
    1723,   366,   366,   366,   366,   366,   366,   366,   366,   332,
     366,   366,   366,   332,   366,   366,   366,   366,   366,   366,
     340,   341,   366,  1508,   366,   345,   346,  1849,   366,   366,
    1852,  1853,   366,   366,   366,   366,   366,   366,   366,  1864,
     366,   366,   366,  1528,  1866,  1867,  1868,     1,  1870,   366,
     366,  1873,  1874,   366,   351,   352,   353,   354,   355,   366,
     366,   366,   366,   352,   374,   366,   376,   366,   366,  1792,
     366,   366,   366,   366,   366,   366,   366,   366,   366,   366,
     369,   366,   366,   332,   366,   366,   366,   366,   366,   366,
     366,   366,   366,   366,   366,  1693,   366,   352,   366,   366,
     366,   366,   366,  1685,  1686,   366,   332,   332,   366,   366,
     366,   366,   332,   366,   369,   366,   366,   332,   366,   366,
     332,   366,   366,   366,   332,   366,  1849,   366,   366,  1852,
    1853,   366,   366,   332,   366,   366,  1734,   366,  1720,  1721,
    1722,  1723,   366,  1866,  1867,  1868,   332,  1870,   366,   366,
    1873,  1874,   366,   366,   332,   366,   366,   332,   332,   366,
     366,   366,   366,   332,   332,   366,   366,   332,   366,   366,
     332,   374,   332,   376,   366,   332,   366,   353,   366,   332,
     332,   332,   332,   332,   340,   341,   332,   332,   332,   345,
     346,   347,   348,   349,   350,   332,   612,   340,   341,   353,
    1685,  1686,   345,   346,   332,   332,   332,   340,   341,   342,
    1792,   332,   345,   346,   332,   340,   341,   342,   332,   332,
     345,   346,   352,   340,   341,   342,   332,   332,   345,   346,
     332,   332,   362,   332,  1624,  1720,  1721,  1722,  1723,   332,
     332,   332,   332,   332,   374,   353,   376,   297,   298,   299,
     300,   374,   302,   376,   332,   332,   332,   332,   366,   367,
     368,   369,   370,   332,   332,   332,   332,  1849,   332,   377,
    1852,  1853,   380,   332,   332,   332,   374,   374,   332,   332,
     352,   332,   366,   332,  1866,  1867,  1868,   374,  1870,   376,
     362,  1873,  1874,   332,     0,     1,   250,   251,   252,   253,
     332,   374,   374,   376,   376,    11,   332,   332,   332,    15,
      16,    17,    18,    19,    20,    21,    22,   332,   374,   374,
     376,   376,   366,   332,   111,   112,   113,   374,   332,   376,
     111,   112,   113,    39,   352,    41,   332,    43,    44,    45,
      46,    47,   352,  1141,   362,  1143,   374,  1145,   376,  1147,
     332,   352,   362,    59,   332,   332,   374,   332,   376,   332,
    1716,   362,   332,  1719,   374,   332,   376,   332,  1853,   332,
     332,   332,   332,   374,   332,   376,   163,   164,   366,   332,
    1770,  1866,   163,   164,   332,  1870,   332,   332,  1873,  1874,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   332,   332,   332,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   332,   160,   161,   162,   332,   332,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   332,   366,   332,   332,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   375,   295,
     296,     1,   379,  1391,   375,   301,   332,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     332,   332,   332,   329,   330,   331,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   332,
     332,   332,   332,   366,   367,   368,   369,   370,   332,   367,
     332,   367,   332,    73,    74,    75,    76,   380,    78,   375,
      80,   378,    82,   332,   332,     1,   382,     3,     4,     5,
       6,     7,     8,     9,    10,   332,    12,    13,    14,    15,
     332,   332,   332,   332,   332,   332,   332,    23,    24,    25,
      26,    27,    28,    29,    30,   332,    32,    33,    34,    35,
      36,    37,    38,    39,    40,   332,    42,   332,    44,   332,
     332,   332,    48,   332,    50,    51,    52,    53,    54,    55,
      56,    57,   332,   332,    60,    61,    62,   332,   332,   332,
      66,    67,    68,    69,    70,    71,     1,   332,     3,     4,
       5,     6,     7,     8,     9,    10,   332,    12,    13,    14,
      15,   332,   332,   332,   332,   332,   332,   332,    23,    24,
      25,    26,    27,    28,    29,    30,   332,    32,    33,    34,
      35,    36,    37,    38,    39,    40,   332,    42,   332,    44,
     332,   332,   332,    48,   332,    50,    51,    52,    53,    54,
      55,    56,    57,   332,   332,    60,    61,    62,   332,   366,
     369,    66,    67,    68,    69,    70,    71,     1,   366,     3,
       4,     5,     6,     7,     8,     9,    10,   366,    12,    13,
      14,    15,   366,   366,   366,   366,   366,   332,   383,    23,
      24,    25,    26,    27,    28,    29,    30,   366,    32,    33,
      34,    35,    36,    37,    38,    39,    40,   366,    42,   369,
      44,   369,   369,   369,    48,   366,    50,    51,    52,    53,
      54,    55,    56,    57,   366,   366,    60,    61,    62,   366,
     366,   366,    66,    67,    68,    69,    70,    71,     1,   366,
       3,     4,     5,     6,     7,     8,     9,    10,   378,    12,
      13,    14,    15,   378,   378,   378,   366,   366,   380,   362,
      23,    24,    25,    26,    27,    28,    29,    30,   381,    32,
      33,    34,    35,    36,    37,    38,    39,    40,   370,    42,
     378,    44,   383,   383,   374,    48,   374,    50,    51,    52,
      53,    54,    55,    56,    57,   332,   332,    60,    61,    62,
     332,   332,   332,    66,    67,    68,    69,    70,    71,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   366,   367,   368,   369,   370,   366,   373,   332,
     381,   317,   381,   377,   366,   362,   380,   374,   376,   369,
     369,   369,   376,   369,   369,   381,   377,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     377,   377,   377,   377,   332,   377,   362,   377,   377,   377,
     377,   367,   377,   375,   375,   371,   372,   381,   374,   375,
     376,   377,   378,   381,   381,   378,   381,   383,   362,   383,
     112,   332,   317,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   332,   332,   332,   332,   376,   376,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   374,   374,   378,   369,   294,   362,   377,   377,   377,
     376,   378,   367,   376,   376,   376,   371,   372,   294,   374,
     375,   376,   377,   378,   376,   376,   376,   376,   383,   376,
     366,   377,   380,   317,   378,   378,   378,   369,   366,   376,
     367,   376,   376,   376,   332,   376,   376,   332,   374,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   332,   332,   376,   379,   376,   380,   376,   376,
     374,   376,    49,   367,   376,   376,   376,   371,   372,   376,
     374,   375,   376,   376,   378,   376,   376,   376,   376,   383,
     112,   376,   376,   376,   317,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   367,   369,   376,   376,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   374,   369,   367,   376,   376,     1,   371,   372,
     383,   374,   375,   376,   383,   378,   376,    11,   376,   376,
     383,    15,    16,    17,    18,    19,    20,    21,    22,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,    39,   376,    41,   376,    43,
      44,    45,    46,    47,   376,   381,   374,   332,   362,   383,
     383,   376,   383,   376,   376,    59,   376,   376,   366,   366,
     366,   366,   366,   366,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   366,   366,   366,
     366,   366,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   376,   366,   366,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   366,   160,   161,   162,   366,
     380,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   362,   376,   376,   354,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     376,   295,   296,   369,   369,   379,   383,   301,   366,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   369,   366,   376,   376,   376,   376,   376,
     383,   376,   376,   376,   112,   329,   330,   331,   376,   376,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   376,   376,   376,   376,   376,   376,   376,
     376,   376,     1,   367,     3,     4,     5,     6,     7,   376,
     376,   375,   381,   376,    13,    14,    15,   376,   382,   376,
     376,   376,   376,   376,    23,    24,    25,    26,    27,    28,
      29,    30,   383,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   383,    42,   376,    44,   376,   376,   376,   383,
     381,    50,    51,    52,    53,    54,    55,    56,   381,   383,
     225,   383,    61,    62,  1100,   993,   962,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,     1,  1358,     3,     4,     5,     6,     7,     8,     9,
      10,  1122,    12,    13,    14,    15,   964,  1300,   416,   608,
     417,  1360,  1360,    23,    24,    25,    26,    27,    28,    29,
      30,  1789,    32,    33,    34,    35,    36,    37,    38,    39,
      40,  1700,    42,  1492,    44,  1771,  1797,    -1,    48,    -1,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,
      -1,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   318,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,   358,
     359,   360,   361,   376,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,    -1,    -1,    -1,    -1,   377,   378,
      -1,   380,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,   317,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,   367,    -1,    -1,
      -1,   371,   372,    -1,    -1,   375,    -1,    -1,    -1,   379,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   376,    -1,    -1,    -1,    -1,    -1,   367,    -1,
      -1,    -1,   371,   372,    -1,    -1,   375,    -1,    -1,    -1,
     379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,    -1,   376,    -1,    -1,    -1,    -1,    -1,   367,
      -1,    -1,    -1,   371,   372,    -1,    -1,   375,    -1,    -1,
       1,   379,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,   317,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,   367,    -1,    -1,    -1,   371,   372,    -1,    -1,
     375,    -1,    -1,     1,   379,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    48,    -1,    50,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,   317,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,   367,    -1,    -1,    -1,
     371,   372,    -1,    -1,   375,    -1,    -1,    -1,   379,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   374,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,
      -1,   371,   372,    -1,    -1,   375,    -1,    -1,     1,   379,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,   317,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,   367,
      -1,    -1,    -1,   371,   372,    -1,    -1,   375,    -1,    -1,
      -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     367,    -1,    -1,    -1,   371,   372,    -1,    -1,   375,    -1,
      -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,    -1,    -1,    -1,
      -1,   367,    -1,    -1,    -1,   371,   372,    -1,    -1,   375,
      -1,    -1,     1,   379,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,
      -1,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,   317,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,   367,    -1,    -1,    -1,   371,   372,
      -1,    -1,   375,    -1,    -1,     1,   379,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,   317,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,   367,    -1,
      -1,    -1,   371,   372,    -1,    -1,   375,    -1,    -1,    -1,
     379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   367,
      -1,    -1,    -1,   371,   372,    -1,    -1,   375,    -1,    -1,
       1,   379,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,   317,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,   367,    -1,    -1,    -1,   371,   372,    -1,    -1,   375,
      -1,    -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   367,    -1,    -1,    -1,   371,   372,    -1,    -1,
     375,    -1,    -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   367,    -1,    -1,    -1,   371,   372,    -1,
      -1,   375,    -1,    -1,     1,   379,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    48,    -1,    50,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,   317,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,   367,    -1,    -1,    -1,
     371,   372,    -1,    -1,   375,    -1,    -1,     1,   379,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
     317,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     367,    -1,    -1,    -1,   371,   372,    -1,    -1,   375,    -1,
      -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   367,    -1,    -1,    -1,   371,   372,    -1,    -1,   375,
      -1,    -1,    -1,   379,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   317,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   367,    -1,    -1,    -1,   371,   372,    -1,
      -1,   375,    -1,    -1,    -1,   379,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,   353,    -1,
      -1,   356,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,    -1,   369,    -1,   371,   372,    -1,    -1,
      -1,    -1,   377,   378,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,   353,    -1,    -1,   356,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,
     377,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   317,   318,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     352,    -1,    -1,    -1,   356,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,    -1,    -1,    -1,   376,   377,   378,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,
      -1,    -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,    -1,   369,    -1,   371,   372,
      -1,    -1,    -1,   376,   377,   378,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,
      -1,   356,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,    -1,   369,    -1,   371,   372,    -1,    -1,
      -1,   376,   377,   378,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,   354,    -1,
     356,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,
      -1,   377,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,
     377,   378,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    52,    53,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,    -1,
     369,    -1,   371,   372,    -1,    -1,    -1,    -1,   377,   378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   318,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   352,    -1,    -1,    -1,   356,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,    -1,    -1,    -1,    -1,   377,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,   318,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   352,    -1,    -1,    -1,   356,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,    -1,   369,    -1,
     371,   372,    -1,    -1,    -1,    -1,   377,   378,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,
      -1,    -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,    -1,   369,    -1,   371,   372,
      -1,    -1,    -1,    -1,   377,   378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,
      -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,    -1,
      -1,    -1,    -1,   377,   378,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,
      -1,   356,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,    -1,   369,    -1,   371,   372,    -1,    -1,
      -1,    -1,   377,   378,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,
     377,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,
     318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,   377,
     378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,    -1,
     369,    -1,   371,   372,    -1,    -1,    -1,    -1,   377,   378,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,   318,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   352,    -1,    -1,    -1,   356,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,    -1,   369,    -1,
     371,   372,    -1,    -1,    -1,    -1,   377,   378,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   317,   318,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     352,    -1,    -1,    -1,   356,    -1,   358,   359,   360,   361,
      -1,   363,   364,   365,   366,   367,    -1,   369,    -1,   371,
     372,    -1,    -1,    -1,    -1,   377,   378,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,
      -1,    -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,    -1,   369,    -1,   371,   372,
      -1,    -1,    -1,    -1,   377,   378,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,
      -1,   356,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,    -1,   369,    -1,   371,   372,    -1,    -1,
      -1,    -1,   377,   378,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,
     356,    -1,   358,   359,   360,   361,    -1,   363,   364,   365,
     366,   367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,
      -1,   377,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,
     377,   378,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    52,    53,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,    -1,
     369,    -1,   371,   372,    -1,    -1,    -1,    -1,   377,   378,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   318,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   352,    -1,    -1,    -1,   356,    -1,   358,   359,
     360,   361,    -1,   363,   364,   365,   366,   367,    -1,   369,
      -1,   371,   372,    -1,    -1,    -1,    -1,   377,   378,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,   318,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   352,    -1,    -1,    -1,   356,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,    -1,   369,    -1,
     371,   372,    -1,    -1,    -1,    -1,   377,   378,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,
      -1,    -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,
     363,   364,   365,   366,   367,    -1,   369,    -1,   371,   372,
      -1,    -1,    -1,    -1,   377,   378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,
      -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,    -1,
      -1,    -1,    -1,   377,   378,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,
      -1,   356,    -1,   358,   359,   360,   361,    -1,   363,   364,
     365,   366,   367,    -1,   369,    -1,   371,   372,    -1,    -1,
      -1,    -1,   377,   378,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,
     377,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,
     318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,   377,
     378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,   318,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,   358,
     359,   360,   361,    -1,   363,   364,   365,   366,   367,    -1,
     369,    -1,   371,   372,    -1,    -1,    -1,    -1,   377,   378,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,   318,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   352,    -1,    -1,    -1,   356,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,    -1,   369,    -1,
     371,   372,    -1,    -1,    -1,    -1,   377,   378,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,
      -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,    -1,
      -1,    -1,    -1,   377,   378,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,   318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,
      -1,   358,   359,   360,   361,    -1,   363,   364,   365,   366,
     367,    -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,
     377,   378,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    48,    -1,    50,    51,    52,    53,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,   317,   318,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   352,    -1,    -1,    -1,   356,    -1,   358,   359,   360,
     361,    -1,   363,   364,   365,   366,   367,    -1,   369,    -1,
     371,   372,    -1,    -1,    -1,    -1,   377,   378,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   317,   318,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   352,    -1,
      -1,    -1,   356,    -1,   358,   359,   360,   361,    -1,   363,
     364,   365,   366,   367,    -1,   369,    -1,   371,   372,    -1,
      -1,    -1,    -1,   377,   378,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     317,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     367,    -1,    -1,    -1,   371,   372,    -1,    -1,   375,    -1,
      -1,   378,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   317,
     318,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   352,    -1,    -1,    -1,   356,    -1,
     358,   359,   360,   361,    -1,   363,   364,   365,   366,   367,
      -1,   369,    -1,   371,   372,    -1,    -1,    -1,    -1,   377,
     378,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,    -1,   371,
     372,    -1,    -1,   375,    -1,    -1,   378,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,    -1,
     371,   372,    -1,    -1,   375,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   317,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   367,    -1,    -1,    -1,   371,
     372,    -1,    -1,   375
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    11,    18,    19,    39,    41,    43,    44,    45,
      46,    47,    59,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   160,   161,   162,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   295,   296,   301,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   329,   330,
     331,   367,   375,   382,   385,   386,   387,   388,   389,   390,
     391,   392,   403,   407,   412,   414,   416,   417,   427,   428,
     437,   332,   332,     1,   380,     1,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,     1,   332,     1,   332,     1,   332,
       1,   332,     1,   332,     1,   332,     1,   332,     1,   332,
       1,   332,     1,   332,     1,   332,     1,   332,     1,   332,
       1,   332,     1,   332,     1,   332,     1,   332,     1,   332,
       1,   332,     1,   332,     1,   332,     1,   332,     1,   332,
       1,   332,     1,   332,     1,   332,     1,   332,     1,   332,
       1,   332,     1,   332,     1,   332,     1,   332,     1,   332,
       1,   332,     1,   332,     1,   332,     1,   332,   332,   332,
     332,   332,   413,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,     1,   369,   377,     1,   369,
     377,     1,   332,   369,     1,   377,     1,   377,     1,   332,
     369,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
       1,   332,     1,   332,     1,   332,     1,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,     1,   332,
     332,   332,   332,   332,   332,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   362,   332,   332,   332,   332,   332,
     332,   332,   332,   332,   332,   332,   332,   332,     1,   367,
     369,   404,   405,   406,     1,   406,   408,   409,     1,   369,
       1,   369,     1,   369,     0,     1,   387,    15,    16,   423,
     424,    17,   425,   426,    20,   431,   432,    21,   433,   434,
      22,   435,   436,   362,   380,   378,     1,   366,   366,   367,
     369,   422,     1,   366,     1,   366,     1,   366,     1,    90,
      91,    92,    93,   353,   396,     1,   352,   366,   402,     1,
     366,     1,   366,     1,   402,     1,   366,     1,   366,     1,
     366,     1,   366,     1,   367,     1,   369,     1,   366,     1,
     369,     1,   366,     1,   369,     1,   369,     1,   369,     1,
     369,     1,   366,   367,   368,   369,   370,   377,   380,   393,
     395,   396,   400,   401,   418,   419,   420,   421,   451,   452,
       1,   401,     1,   366,     1,   401,     1,   366,     1,   366,
       1,   366,   366,   366,   366,   402,   402,   402,   402,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   366,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   366,   369,
     366,   366,   366,   366,   366,   366,   366,   366,   366,     1,
     402,     1,   366,     1,   369,     1,   366,   332,     1,   366,
       1,   366,     1,   366,     1,   366,     1,   369,     1,   366,
       1,   366,     1,   402,     1,   402,     1,   402,     1,   402,
       1,   402,     1,   402,     1,   402,     1,   402,     1,   402,
       1,   402,     1,   366,     1,   366,     1,   369,     1,   369,
       1,   366,   369,   369,     1,   369,   369,   369,     1,   369,
       1,   366,     1,   366,     1,   366,     1,   366,     1,   366,
       1,   366,     1,   366,     1,   367,   369,     1,   367,   369,
       1,   367,   369,     1,   367,   369,     1,   367,   369,     1,
     366,     1,   366,     1,   366,     1,   366,     1,   366,     1,
     366,     1,   402,     1,   402,     1,   402,     1,   367,   369,
       1,   366,     1,   366,     1,   366,     1,   366,   419,     1,
     421,     1,   366,     1,   366,   366,   366,   366,   366,     1,
     366,     1,   366,     1,   366,     1,   366,     1,   366,     1,
     366,     1,   366,     1,   366,     1,   366,     1,   366,     1,
     366,     1,   366,     1,   366,     1,   366,     1,   366,     1,
     402,     1,   402,     1,   366,     1,   366,     1,   366,     1,
     366,     1,   250,   251,   252,   253,     1,   366,     1,   366,
       1,   366,     1,   366,     1,   369,     1,   369,     1,   369,
       1,   366,     1,   366,     1,   366,     1,   393,     1,   366,
       1,   366,     1,   366,     1,   366,     1,   366,     1,   366,
       1,   366,     1,   366,     1,   366,     1,   366,     1,   366,
       1,   366,     1,   366,     1,   366,     1,   366,     1,   367,
     369,     1,   366,   367,   366,     1,   366,     1,   366,     1,
     366,     1,   366,     1,   366,     1,   366,     1,   366,     1,
     369,     1,   366,     1,   366,     1,   366,     1,   366,     1,
     366,     1,   366,   297,   298,   299,   300,   302,     1,   402,
     366,   366,     1,   402,     1,   402,     1,   366,     1,   366,
       1,   366,     1,   366,     1,   366,     1,   366,     1,   369,
       1,   369,   374,   383,   374,     1,   380,     1,   378,     1,
     380,   378,     1,   380,   378,     1,   380,   378,     1,   380,
      59,   366,   367,   415,   366,   429,   381,   366,   362,   393,
     394,   420,   383,   383,   401,   111,   112,   113,   352,   362,
     378,   374,   376,   374,   376,   374,   374,   332,   332,   332,
     332,   332,   404,   366,   408,   422,     3,     4,     5,     6,
       7,     8,     9,    10,    12,    13,    14,    15,    23,    24,
      25,    26,    27,    28,    29,    30,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    42,    44,    48,    50,    51,
      52,    53,    54,    55,    56,    57,    60,    61,    62,    66,
      67,    68,    69,    70,    71,   317,   367,   371,   372,   375,
     453,   455,   456,   457,   461,   462,   470,   471,   473,   474,
     477,   478,   480,   484,   485,   486,   490,   422,   455,   422,
     455,   422,   455,   373,   332,   381,   455,     1,   430,   366,
     374,   376,   381,     1,   353,   366,   398,   395,   393,   369,
       1,   366,   451,     1,   451,   111,   112,   113,   163,   164,
     375,   410,   411,   369,   369,   369,   369,     1,   369,     1,
     369,     1,   369,     1,   369,     1,   369,   381,     1,   377,
       1,   377,     1,   377,     1,   377,     1,   377,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,   318,   352,   356,   358,
     359,   360,   361,   363,   364,   365,   369,   377,   378,   402,
     443,   444,   445,   446,   447,   448,   453,   465,   470,   471,
     472,   473,   475,   477,   478,   481,   482,   483,   377,   483,
     377,   483,     1,   377,     1,   377,     1,   377,   377,     1,
     377,     1,   377,     1,   377,     1,   377,     1,   377,     1,
     377,     1,   377,     1,   377,   377,     1,   377,     1,   377,
       1,   377,     1,   377,   377,   377,   377,   377,   377,   377,
     483,     1,   377,     1,   377,     1,   377,   377,   377,   377,
     377,     1,   483,   483,     1,   377,     1,   377,     1,   377,
       1,   377,     1,   377,     1,   487,     1,   375,     1,   379,
     456,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     367,   467,   468,   469,   332,   479,   375,     1,   377,   375,
     381,   379,   381,   379,   381,   379,   381,     1,   366,   369,
     362,   379,   378,   362,   394,   383,   112,   113,   383,   112,
     332,   332,   332,   332,   332,   379,   410,   376,   376,   374,
     374,   378,     1,    63,   367,   369,   376,   418,   450,     1,
      63,   369,   418,   450,     1,    63,   369,   418,   450,     1,
      63,   369,   418,   450,     1,    63,   369,   418,   450,     1,
     340,   341,   342,   345,   346,   438,   440,   438,   438,     1,
     438,   466,     1,   483,     1,   483,     1,   483,   377,   377,
     377,     1,   376,   471,   473,   477,   478,   483,   484,     1,
     455,     1,   440,     1,   347,   348,   349,   350,   438,   439,
       1,   440,   469,     1,   483,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   441,   442,
     376,   376,     1,   366,   369,     1,   369,     1,   367,   483,
     369,     1,   369,     1,   369,     1,   369,     1,   369,     1,
     366,     1,   366,   376,     1,   376,   402,   376,     1,   369,
       1,   369,     1,   369,     1,   369,   376,   376,   376,     1,
     366,   376,     1,   396,   378,   454,   456,     1,   393,     1,
     366,     1,   393,   396,   399,   376,   376,   376,   376,   378,
     454,     1,   369,     1,   369,   366,   406,   366,   406,   366,
     406,   377,   362,   380,   483,     1,   369,   470,   471,   476,
     478,   378,   378,   378,   378,   294,   294,   415,   455,   366,
     398,   369,   366,   393,     1,   366,     1,   369,     1,   393,
     396,     1,   366,   369,   402,   369,   371,   402,   455,   376,
     374,   376,   374,   376,   374,   376,   352,   362,   374,   376,
     376,   374,   376,   374,   376,   374,   376,   374,   376,   376,
     374,   376,   374,   376,   374,   376,   374,   376,   376,   374,
     376,   374,   376,   374,   376,   374,   376,   376,   374,   376,
     374,   376,   374,   376,   374,   376,     1,   367,   483,     1,
      90,    91,    92,    93,    94,    95,   353,   397,   483,     1,
     397,   483,     1,   443,   447,   367,   463,   464,     1,   483,
       1,   483,     1,   483,   376,   376,   376,   379,   379,     1,
      88,   483,     1,   483,     1,   483,     1,    88,   366,   367,
     418,   449,   450,   483,   380,     1,   483,     1,   483,     1,
     483,     1,   483,   483,   483,   483,     1,   483,     1,   483,
       1,   483,     1,   483,     1,   483,     1,   483,     1,   483,
     376,   374,   376,   376,   374,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   455,    49,   376,   376,   376,
     376,   376,   383,   383,   376,     1,    58,    59,   379,   459,
     460,   376,   374,   376,   376,   376,   376,   376,   376,   376,
     376,   483,   488,   489,   468,   381,   374,   376,   469,   374,
     455,   455,   455,   455,   369,   369,   332,   379,   362,   112,
     112,   113,   383,   383,   383,   376,   376,   376,   376,   376,
     379,    64,   366,   366,   366,     1,   367,     1,   367,   366,
      64,   366,   366,   366,   366,    64,   366,   366,   366,   366,
      64,   366,   366,   366,   366,    64,   366,   366,   366,   366,
     380,   362,   376,   376,   376,   376,   376,   374,   354,   402,
     369,   369,   379,   454,     1,   398,   393,   379,     1,   354,
     458,   483,   383,   379,   459,   366,   483,   374,   376,   406,
       1,   406,   379,   379,   379,   379,   366,   369,   366,   369,
     366,   398,   393,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   376,   376,
     376,   376,   376,   376,   376,   376,   376,   376,   369,   402,
     463,   483,     1,   366,   418,   381,   376,   376,   383,   383,
       1,   458,   383,   455,   376,   376,   489,   376,   376,   376,
     112,   383,   381,   381,   374,   398,   455,   383,   383,     1,
     455,   398,   483,   455,   455,   376
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   384,   385,   386,   386,   386,   387,   387,   387,   387,
     387,   388,   387,   389,   387,   387,   390,   387,   391,   387,
     392,   387,   387,   387,   393,   393,   393,   394,   394,   395,
     395,   396,   396,   396,   396,   396,   397,   397,   397,   397,
     397,   397,   397,   398,   398,   399,   399,   399,   399,   399,
     400,   400,   400,   400,   400,   401,   401,   402,   402,   403,
     403,   404,   404,   405,   405,   406,   406,   407,   407,   408,
     408,   409,   410,   410,   410,   410,   410,   410,   410,   410,
     410,   410,   410,   410,   410,   411,   411,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   413,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   412,   412,   412,
     412,   412,   412,   412,   412,   412,   412,   414,   414,   415,
     415,   415,   416,   416,   416,   416,   416,   416,   416,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   417,   417,   417,   417,   417,   417,   417,   417,
     417,   417,   418,   418,   419,   420,   421,   421,   422,   422,
     422,   423,   423,   424,   424,   424,   424,   425,   426,   426,
     426,   427,   427,   429,   428,   428,   428,   430,   428,   428,
     431,   432,   432,   432,   433,   434,   434,   434,   435,   436,
     436,   437,   437,   437,   437,   437,   437,   438,   438,   438,
     438,   439,   439,   439,   439,   440,   440,   441,   441,   441,
     441,   441,   441,   441,   442,   442,   442,   442,   443,   443,
     443,   444,   444,   444,   445,   445,   445,   445,   445,   446,
     446,   447,   447,   447,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   448,
     448,   448,   448,   449,   449,   449,   449,   450,   450,   450,
     450,   450,   451,   451,   451,   452,   452,   452,   452,   452,
     453,   454,   454,   455,   455,   455,   456,   456,   456,   456,
     456,   456,   456,   456,   457,   457,   458,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,   460,   460,
     461,   461,   461,   461,   462,   463,   463,   463,   464,   464,
     466,   465,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   468,   469,   469,   470,   471,   472,   473,   474,   474,
     475,   475,   475,   476,   476,   476,   477,   478,   479,   480,
     480,   480,   481,   481,   481,   481,   481,   481,   481,   481,
     481,   481,   481,   481,   482,   482,   482,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   484,   485,
     485,   485,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   486,   486,   486,
     486,   486,   486,   486,   486,   486,   486,   487,   486,   486,
     488,   488,   488,   489,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     7,     5,     5,     3,     3,     3,     3,     5,
       3,     3,     3,     3,     1,     2,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     0,     6,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     5,     6,     7,     8,     9,    10,
       5,     6,     7,     8,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     5,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     1,     2,     1,     1,     1,
       1,     1,     5,     5,     7,     7,     5,     8,     8,     2,
       4,     6,     2,     2,     4,     6,     2,     2,     2,     3,
       3,     8,     8,     2,     8,     8,     8,     2,     2,     2,
       3,     3,     1,     1,     7,     1,     1,     3,     1,     1,
       1,     1,     1,     4,     7,     2,     2,     1,     4,     7,
       2,     1,     1,     0,     5,     2,     2,     0,     8,     5,
       1,     4,     7,     2,     1,     4,     7,     2,     1,     7,
       2,     2,     2,     2,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     2,     3,     3,
       3,     2,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     3,
       3,     3,     2,     3,     3,     1,     3,     1,     3,     3,
       3,     3,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     1,     3,     2,     1,     2,     2,     1,     1,     1,
       2,     2,     1,     2,     3,     5,     1,     4,     5,     3,
       4,     3,     2,     4,     5,     3,     4,     4,     2,     1,
       5,     4,     2,     5,     3,     1,     4,     4,     3,     1,
       0,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     1,     2,     5,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     1,     1,     1,     1,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     2,     8,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     4,     4,     2,     3,     1,
       1,     1,     3,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     4,     4,
       6,     6,     6,     6,     6,     4,     2,     4,     4,     6,
       2,     4,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     6,     6,     6,     4,     2,     6,     2,     4,     4,
       4,     2,     4,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     4,     4,     2,     4,     3,     2,     4,     3,
       2,     4,     3,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     3,     1,     3,     1,     3,     1,     4,     3,     1,
       4,     4,     4,     4,     4,     2,     4,     4,     2,     4,
       4,     2,     3,     1,     3,     1,     3,     1,     3,     1,
       6,     6,     2,     4,     4,     2,     4,     0,     5,     2,
       0,     3,     1,     1,     3,     2,     1,     3,     2,     1,
       1,     3,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 665 "core/cfg.y"
                             {}
#line 5278 "core/cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 666 "core/cfg.y"
                    {}
#line 5284 "core/cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 667 "core/cfg.y"
                           { yyerror(""); YYABORT;}
#line 5290 "core/cfg.tab.c"
    break;

  case 11: /* $@1: %empty  */
#line 675 "core/cfg.y"
          {rt=REQUEST_ROUTE;}
#line 5296 "core/cfg.tab.c"
    break;

  case 13: /* $@2: %empty  */
#line 676 "core/cfg.y"
          {rt=FAILURE_ROUTE;}
#line 5302 "core/cfg.tab.c"
    break;

  case 16: /* $@3: %empty  */
#line 678 "core/cfg.y"
          {rt=BRANCH_ROUTE;}
#line 5308 "core/cfg.tab.c"
    break;

  case 18: /* $@4: %empty  */
#line 679 "core/cfg.y"
          {rt=ONSEND_ROUTE;}
#line 5314 "core/cfg.tab.c"
    break;

  case 20: /* $@5: %empty  */
#line 680 "core/cfg.y"
          {rt=EVENT_ROUTE;}
#line 5320 "core/cfg.tab.c"
    break;

  case 24: /* listen_id: ip  */
#line 685 "core/cfg.y"
           {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				i_tmp=strlen(tmp)+1;
				(yyval.strval)=pkg_malloc(i_tmp);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, i_tmp);
				}
			}
		}
	}
#line 5342 "core/cfg.tab.c"
    break;

  case 25: /* listen_id: STRING  */
#line 702 "core/cfg.y"
                 {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				i_tmp=strlen((yyvsp[0].strval))+1;
				strncpy((yyval.strval), (yyvsp[0].strval), i_tmp);
		}
	}
#line 5356 "core/cfg.tab.c"
    break;

  case 26: /* listen_id: host_or_if  */
#line 711 "core/cfg.y"
                     {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					i_tmp=strlen((yyvsp[0].strval))+1;
					strncpy((yyval.strval), (yyvsp[0].strval), i_tmp);
			}
		}
	}
#line 5372 "core/cfg.tab.c"
    break;

  case 27: /* listen_id_lst: listen_id  */
#line 726 "core/cfg.y"
                        { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5378 "core/cfg.tab.c"
    break;

  case 28: /* listen_id_lst: listen_id COMMA listen_id_lst  */
#line 727 "core/cfg.y"
                                        { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5386 "core/cfg.tab.c"
    break;

  case 29: /* listen_id2: LPAREN listen_id_lst RPAREN  */
#line 733 "core/cfg.y"
                                    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5392 "core/cfg.tab.c"
    break;

  case 30: /* listen_id2: listen_id  */
#line 734 "core/cfg.y"
                        { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5398 "core/cfg.tab.c"
    break;

  case 31: /* proto: UDP  */
#line 738 "core/cfg.y"
                { (yyval.intval)=PROTO_UDP; }
#line 5404 "core/cfg.tab.c"
    break;

  case 32: /* proto: TCP  */
#line 739 "core/cfg.y"
                { (yyval.intval)=PROTO_TCP; }
#line 5410 "core/cfg.tab.c"
    break;

  case 33: /* proto: TLS  */
#line 740 "core/cfg.y"
                { (yyval.intval)=PROTO_TLS; }
#line 5416 "core/cfg.tab.c"
    break;

  case 34: /* proto: SCTP  */
#line 741 "core/cfg.y"
                { (yyval.intval)=PROTO_SCTP; }
#line 5422 "core/cfg.tab.c"
    break;

  case 35: /* proto: STAR  */
#line 742 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5428 "core/cfg.tab.c"
    break;

  case 36: /* eqproto: UDP  */
#line 745 "core/cfg.y"
                { (yyval.intval)=PROTO_UDP; }
#line 5434 "core/cfg.tab.c"
    break;

  case 37: /* eqproto: TCP  */
#line 746 "core/cfg.y"
                { (yyval.intval)=PROTO_TCP; }
#line 5440 "core/cfg.tab.c"
    break;

  case 38: /* eqproto: TLS  */
#line 747 "core/cfg.y"
                { (yyval.intval)=PROTO_TLS; }
#line 5446 "core/cfg.tab.c"
    break;

  case 39: /* eqproto: SCTP  */
#line 748 "core/cfg.y"
                { (yyval.intval)=PROTO_SCTP; }
#line 5452 "core/cfg.tab.c"
    break;

  case 40: /* eqproto: WS  */
#line 749 "core/cfg.y"
                { (yyval.intval)=PROTO_WS; }
#line 5458 "core/cfg.tab.c"
    break;

  case 41: /* eqproto: WSS  */
#line 750 "core/cfg.y"
                { (yyval.intval)=PROTO_WSS; }
#line 5464 "core/cfg.tab.c"
    break;

  case 42: /* eqproto: STAR  */
#line 751 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5470 "core/cfg.tab.c"
    break;

  case 43: /* port: NUMBER  */
#line 754 "core/cfg.y"
                { (yyval.intval)=(yyvsp[0].intval); }
#line 5476 "core/cfg.tab.c"
    break;

  case 44: /* port: STAR  */
#line 755 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5482 "core/cfg.tab.c"
    break;

  case 45: /* phostport: listen_id  */
#line 758 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5488 "core/cfg.tab.c"
    break;

  case 46: /* phostport: listen_id COLON port  */
#line 759 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5494 "core/cfg.tab.c"
    break;

  case 47: /* phostport: proto COLON listen_id  */
#line 760 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5500 "core/cfg.tab.c"
    break;

  case 48: /* phostport: proto COLON listen_id COLON port  */
#line 761 "core/cfg.y"
                                                { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5506 "core/cfg.tab.c"
    break;

  case 49: /* phostport: listen_id COLON error  */
#line 762 "core/cfg.y"
                                { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5512 "core/cfg.tab.c"
    break;

  case 50: /* listen_phostport: listen_id2  */
#line 766 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5518 "core/cfg.tab.c"
    break;

  case 51: /* listen_phostport: listen_id2 COLON port  */
#line 767 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5524 "core/cfg.tab.c"
    break;

  case 52: /* listen_phostport: proto COLON listen_id2  */
#line 768 "core/cfg.y"
                                        { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5530 "core/cfg.tab.c"
    break;

  case 53: /* listen_phostport: proto COLON listen_id2 COLON port  */
#line 769 "core/cfg.y"
                                                { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5536 "core/cfg.tab.c"
    break;

  case 54: /* listen_phostport: listen_id2 COLON error  */
#line 770 "core/cfg.y"
                                 { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5542 "core/cfg.tab.c"
    break;

  case 55: /* id_lst: listen_phostport  */
#line 774 "core/cfg.y"
                                        {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5548 "core/cfg.tab.c"
    break;

  case 56: /* id_lst: listen_phostport id_lst  */
#line 775 "core/cfg.y"
                                        { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5554 "core/cfg.tab.c"
    break;

  case 58: /* intno: MINUS NUMBER  */
#line 779 "core/cfg.y"
                                    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5560 "core/cfg.tab.c"
    break;

  case 60: /* flags_decl: FLAGS_DECL error  */
#line 783 "core/cfg.y"
                                                 { yyerror("flag list expected\n"); }
#line 5566 "core/cfg.tab.c"
    break;

  case 63: /* flag_spec: flag_name  */
#line 789 "core/cfg.y"
                                        { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5574 "core/cfg.tab.c"
    break;

  case 64: /* flag_spec: flag_name COLON NUMBER  */
#line 792 "core/cfg.y"
                                                       {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5583 "core/cfg.tab.c"
    break;

  case 65: /* flag_name: STRING  */
#line 798 "core/cfg.y"
                                { (yyval.strval)=(yyvsp[0].strval); }
#line 5589 "core/cfg.tab.c"
    break;

  case 66: /* flag_name: ID  */
#line 799 "core/cfg.y"
                                                { (yyval.strval)=(yyvsp[0].strval); }
#line 5595 "core/cfg.tab.c"
    break;

  case 68: /* avpflags_decl: AVPFLAGS_DECL error  */
#line 804 "core/cfg.y"
                              { yyerror("avpflag list expected\n"); }
#line 5601 "core/cfg.tab.c"
    break;

  case 71: /* avpflag_spec: flag_name  */
#line 811 "core/cfg.y"
                  {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5610 "core/cfg.tab.c"
    break;

  case 72: /* socket_lattr: BIND EQUAL proto COLON listen_id COLON port  */
#line 817 "core/cfg.y"
                                                        {
			tmp_sa.bindproto = (yyvsp[-4].intval);
			tmp_sa.bindaddr.s = (yyvsp[-2].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
			tmp_sa.bindport = (yyvsp[0].intval);
		}
#line 5621 "core/cfg.tab.c"
    break;

  case 73: /* socket_lattr: BIND EQUAL listen_id COLON port  */
#line 823 "core/cfg.y"
                                                {
			tmp_sa.bindaddr.s = (yyvsp[-2].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
			tmp_sa.bindport = (yyvsp[0].intval);
		}
#line 5631 "core/cfg.tab.c"
    break;

  case 74: /* socket_lattr: BIND EQUAL proto COLON listen_id  */
#line 828 "core/cfg.y"
                                                {
			tmp_sa.bindproto = (yyvsp[-2].intval);
			tmp_sa.bindaddr.s = (yyvsp[0].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
		}
#line 5641 "core/cfg.tab.c"
    break;

  case 75: /* socket_lattr: BIND EQUAL listen_id  */
#line 833 "core/cfg.y"
                                {
			tmp_sa.bindaddr.s = (yyvsp[0].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
		}
#line 5650 "core/cfg.tab.c"
    break;

  case 76: /* socket_lattr: BIND EQUAL error  */
#line 837 "core/cfg.y"
                           { yyerror("string value expected"); }
#line 5656 "core/cfg.tab.c"
    break;

  case 77: /* socket_lattr: STRNAME EQUAL STRING  */
#line 838 "core/cfg.y"
                               {
			tmp_sa.sockname.s = (yyvsp[0].strval);
			tmp_sa.sockname.len = strlen(tmp_sa.sockname.s);
		}
#line 5665 "core/cfg.tab.c"
    break;

  case 78: /* socket_lattr: STRNAME EQUAL error  */
#line 842 "core/cfg.y"
                              { yyerror("string value expected"); }
#line 5671 "core/cfg.tab.c"
    break;

  case 79: /* socket_lattr: ADVERTISE EQUAL listen_id COLON NUMBER  */
#line 843 "core/cfg.y"
                                                 {
			tmp_sa.useaddr.s = (yyvsp[-2].strval);
			tmp_sa.useaddr.len = strlen(tmp_sa.useaddr.s);
			tmp_sa.useport = (yyvsp[0].intval);
		}
#line 5681 "core/cfg.tab.c"
    break;

  case 80: /* socket_lattr: WORKERS EQUAL NUMBER  */
#line 848 "core/cfg.y"
                               { tmp_sa.workers=(yyvsp[0].intval); }
#line 5687 "core/cfg.tab.c"
    break;

  case 81: /* socket_lattr: WORKERS EQUAL error  */
#line 849 "core/cfg.y"
                              { yyerror("number expected"); }
#line 5693 "core/cfg.tab.c"
    break;

  case 82: /* socket_lattr: VIRTUAL EQUAL NUMBER  */
#line 850 "core/cfg.y"
                               { if((yyvsp[0].intval)!=0) { tmp_sa.sflags |= SI_IS_VIRTUAL; } }
#line 5699 "core/cfg.tab.c"
    break;

  case 83: /* socket_lattr: VIRTUAL EQUAL error  */
#line 851 "core/cfg.y"
                              { yyerror("number expected"); }
#line 5705 "core/cfg.tab.c"
    break;

  case 84: /* socket_lattr: SEMICOLON  */
#line 852 "core/cfg.y"
                    {}
#line 5711 "core/cfg.tab.c"
    break;

  case 85: /* socket_lattrs: socket_lattrs socket_lattr  */
#line 855 "core/cfg.y"
                                   {}
#line 5717 "core/cfg.tab.c"
    break;

  case 86: /* socket_lattrs: socket_lattr  */
#line 856 "core/cfg.y"
                       {}
#line 5723 "core/cfg.tab.c"
    break;

  case 87: /* assign_stm: DEBUG_V EQUAL intno  */
#line 859 "core/cfg.y"
                            { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5729 "core/cfg.tab.c"
    break;

  case 88: /* assign_stm: DEBUG_V EQUAL error  */
#line 860 "core/cfg.y"
                               { yyerror("number  expected"); }
#line 5735 "core/cfg.tab.c"
    break;

  case 89: /* assign_stm: FORK EQUAL NUMBER  */
#line 861 "core/cfg.y"
                             { dont_fork= ! (yyvsp[0].intval); }
#line 5741 "core/cfg.tab.c"
    break;

  case 90: /* assign_stm: FORK EQUAL error  */
#line 862 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 5747 "core/cfg.tab.c"
    break;

  case 91: /* assign_stm: FORK_DELAY EQUAL NUMBER  */
#line 863 "core/cfg.y"
                                   { set_fork_delay((yyvsp[0].intval)); }
#line 5753 "core/cfg.tab.c"
    break;

  case 92: /* assign_stm: FORK_DELAY EQUAL error  */
#line 864 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 5759 "core/cfg.tab.c"
    break;

  case 93: /* assign_stm: MODINIT_DELAY EQUAL NUMBER  */
#line 865 "core/cfg.y"
                                      { set_modinit_delay((yyvsp[0].intval)); }
#line 5765 "core/cfg.tab.c"
    break;

  case 94: /* assign_stm: MODINIT_DELAY EQUAL error  */
#line 866 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 5771 "core/cfg.tab.c"
    break;

  case 95: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 867 "core/cfg.y"
                                   { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5779 "core/cfg.tab.c"
    break;

  case 96: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 870 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 5785 "core/cfg.tab.c"
    break;

  case 97: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 871 "core/cfg.y"
                               {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5796 "core/cfg.tab.c"
    break;

  case 98: /* assign_stm: LOGFACILITY EQUAL error  */
#line 877 "core/cfg.y"
                                  { yyerror("ID expected"); }
#line 5802 "core/cfg.tab.c"
    break;

  case 99: /* assign_stm: LOGNAME EQUAL STRING  */
#line 878 "core/cfg.y"
                               { log_name=(yyvsp[0].strval); }
#line 5808 "core/cfg.tab.c"
    break;

  case 100: /* assign_stm: LOGNAME EQUAL error  */
#line 879 "core/cfg.y"
                              { yyerror("string value expected"); }
#line 5814 "core/cfg.tab.c"
    break;

  case 101: /* assign_stm: LOGCOLOR EQUAL NUMBER  */
#line 880 "core/cfg.y"
                                { log_color=(yyvsp[0].intval); }
#line 5820 "core/cfg.tab.c"
    break;

  case 102: /* assign_stm: LOGCOLOR EQUAL error  */
#line 881 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 5826 "core/cfg.tab.c"
    break;

  case 103: /* assign_stm: LOGPREFIX EQUAL STRING  */
#line 882 "core/cfg.y"
                                 { log_prefix_fmt=(yyvsp[0].strval); }
#line 5832 "core/cfg.tab.c"
    break;

  case 104: /* assign_stm: LOGPREFIX EQUAL error  */
#line 883 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 5838 "core/cfg.tab.c"
    break;

  case 105: /* assign_stm: LOGPREFIXMODE EQUAL NUMBER  */
#line 884 "core/cfg.y"
                                     { log_prefix_mode=(yyvsp[0].intval); }
#line 5844 "core/cfg.tab.c"
    break;

  case 106: /* assign_stm: LOGPREFIXMODE EQUAL error  */
#line 885 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 5850 "core/cfg.tab.c"
    break;

  case 107: /* assign_stm: LOGENGINETYPE EQUAL STRING  */
#line 886 "core/cfg.y"
                                     { _km_log_engine_type=(yyvsp[0].strval); }
#line 5856 "core/cfg.tab.c"
    break;

  case 108: /* assign_stm: LOGENGINETYPE EQUAL error  */
#line 887 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5862 "core/cfg.tab.c"
    break;

  case 109: /* assign_stm: LOGENGINEDATA EQUAL STRING  */
#line 888 "core/cfg.y"
                                     { _km_log_engine_data=(yyvsp[0].strval); }
#line 5868 "core/cfg.tab.c"
    break;

  case 110: /* assign_stm: LOGENGINEDATA EQUAL error  */
#line 889 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5874 "core/cfg.tab.c"
    break;

  case 111: /* assign_stm: XAVPVIAPARAMS EQUAL STRING  */
#line 890 "core/cfg.y"
                                     { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5882 "core/cfg.tab.c"
    break;

  case 112: /* assign_stm: XAVPVIAPARAMS EQUAL error  */
#line 893 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5888 "core/cfg.tab.c"
    break;

  case 113: /* assign_stm: XAVPVIAFIELDS EQUAL STRING  */
#line 894 "core/cfg.y"
                                     { _ksr_xavp_via_fields.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5896 "core/cfg.tab.c"
    break;

  case 114: /* assign_stm: XAVPVIAFIELDS EQUAL error  */
#line 897 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5902 "core/cfg.tab.c"
    break;

  case 115: /* assign_stm: DNS EQUAL NUMBER  */
#line 898 "core/cfg.y"
                             { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5908 "core/cfg.tab.c"
    break;

  case 116: /* assign_stm: DNS EQUAL error  */
#line 899 "core/cfg.y"
                          { yyerror("boolean value expected"); }
#line 5914 "core/cfg.tab.c"
    break;

  case 117: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 900 "core/cfg.y"
                               { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5920 "core/cfg.tab.c"
    break;

  case 118: /* assign_stm: REV_DNS EQUAL error  */
#line 901 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 5926 "core/cfg.tab.c"
    break;

  case 119: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 902 "core/cfg.y"
                                      { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5932 "core/cfg.tab.c"
    break;

  case 120: /* assign_stm: DNS_TRY_IPV6 error  */
#line 903 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 5938 "core/cfg.tab.c"
    break;

  case 121: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 904 "core/cfg.y"
                                       { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5944 "core/cfg.tab.c"
    break;

  case 122: /* assign_stm: DNS_TRY_NAPTR error  */
#line 905 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 5950 "core/cfg.tab.c"
    break;

  case 123: /* assign_stm: DNS_SRV_LB EQUAL NUMBER  */
#line 906 "core/cfg.y"
                                    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5956 "core/cfg.tab.c"
    break;

  case 124: /* assign_stm: DNS_SRV_LB error  */
#line 907 "core/cfg.y"
                           { yyerror("boolean value expected"); }
#line 5962 "core/cfg.tab.c"
    break;

  case 125: /* assign_stm: DNS_UDP_PREF EQUAL intno  */
#line 908 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5968 "core/cfg.tab.c"
    break;

  case 126: /* assign_stm: DNS_UDP_PREF error  */
#line 909 "core/cfg.y"
                             { yyerror("number expected"); }
#line 5974 "core/cfg.tab.c"
    break;

  case 127: /* assign_stm: DNS_TCP_PREF EQUAL intno  */
#line 910 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5980 "core/cfg.tab.c"
    break;

  case 128: /* assign_stm: DNS_TCP_PREF error  */
#line 911 "core/cfg.y"
                             { yyerror("number expected"); }
#line 5986 "core/cfg.tab.c"
    break;

  case 129: /* assign_stm: DNS_TLS_PREF EQUAL intno  */
#line 912 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5992 "core/cfg.tab.c"
    break;

  case 130: /* assign_stm: DNS_TLS_PREF error  */
#line 913 "core/cfg.y"
                             { yyerror("number expected"); }
#line 5998 "core/cfg.tab.c"
    break;

  case 131: /* assign_stm: DNS_SCTP_PREF EQUAL intno  */
#line 914 "core/cfg.y"
                                    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 6005 "core/cfg.tab.c"
    break;

  case 132: /* assign_stm: DNS_SCTP_PREF error  */
#line 916 "core/cfg.y"
                              { yyerror("number expected"); }
#line 6011 "core/cfg.tab.c"
    break;

  case 133: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 917 "core/cfg.y"
                                       { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 6017 "core/cfg.tab.c"
    break;

  case 134: /* assign_stm: DNS_RETR_TIME error  */
#line 918 "core/cfg.y"
                              { yyerror("number expected"); }
#line 6023 "core/cfg.tab.c"
    break;

  case 135: /* assign_stm: DNS_SLOW_QUERY_MS EQUAL NUMBER  */
#line 919 "core/cfg.y"
                                           { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 6029 "core/cfg.tab.c"
    break;

  case 136: /* assign_stm: DNS_SLOW_QUERY_MS error  */
#line 920 "core/cfg.y"
                                  { yyerror("number expected"); }
#line 6035 "core/cfg.tab.c"
    break;

  case 137: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 921 "core/cfg.y"
                                     { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 6041 "core/cfg.tab.c"
    break;

  case 138: /* assign_stm: DNS_RETR_NO error  */
#line 922 "core/cfg.y"
                            { yyerror("number expected"); }
#line 6047 "core/cfg.tab.c"
    break;

  case 139: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 923 "core/cfg.y"
                                        { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 6053 "core/cfg.tab.c"
    break;

  case 140: /* assign_stm: DNS_SERVERS_NO error  */
#line 924 "core/cfg.y"
                               { yyerror("number expected"); }
#line 6059 "core/cfg.tab.c"
    break;

  case 141: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 925 "core/cfg.y"
                                        { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 6065 "core/cfg.tab.c"
    break;

  case 142: /* assign_stm: DNS_USE_SEARCH error  */
#line 926 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 6071 "core/cfg.tab.c"
    break;

  case 143: /* assign_stm: DNS_SEARCH_FMATCH EQUAL NUMBER  */
#line 927 "core/cfg.y"
                                           { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 6077 "core/cfg.tab.c"
    break;

  case 144: /* assign_stm: DNS_SEARCH_FMATCH error  */
#line 928 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6083 "core/cfg.tab.c"
    break;

  case 145: /* assign_stm: DNS_NAPTR_IGNORE_RFC EQUAL NUMBER  */
#line 929 "core/cfg.y"
                                              { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 6089 "core/cfg.tab.c"
    break;

  case 146: /* assign_stm: DNS_NAPTR_IGNORE_RFC error  */
#line 930 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6095 "core/cfg.tab.c"
    break;

  case 147: /* assign_stm: DNS_CACHE_INIT EQUAL NUMBER  */
#line 931 "core/cfg.y"
                                        { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 6101 "core/cfg.tab.c"
    break;

  case 148: /* assign_stm: DNS_CACHE_INIT error  */
#line 932 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 6107 "core/cfg.tab.c"
    break;

  case 149: /* assign_stm: DNS_USE_CACHE EQUAL NUMBER  */
#line 933 "core/cfg.y"
                                       { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 6113 "core/cfg.tab.c"
    break;

  case 150: /* assign_stm: DNS_USE_CACHE error  */
#line 934 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6119 "core/cfg.tab.c"
    break;

  case 151: /* assign_stm: DNS_USE_FAILOVER EQUAL NUMBER  */
#line 935 "core/cfg.y"
                                          { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 6125 "core/cfg.tab.c"
    break;

  case 152: /* assign_stm: DNS_USE_FAILOVER error  */
#line 936 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 6131 "core/cfg.tab.c"
    break;

  case 153: /* assign_stm: DNS_CACHE_FLAGS EQUAL NUMBER  */
#line 937 "core/cfg.y"
                                         { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 6137 "core/cfg.tab.c"
    break;

  case 154: /* assign_stm: DNS_CACHE_FLAGS error  */
#line 938 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6143 "core/cfg.tab.c"
    break;

  case 155: /* assign_stm: DNS_CACHE_NEG_TTL EQUAL NUMBER  */
#line 939 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 6149 "core/cfg.tab.c"
    break;

  case 156: /* assign_stm: DNS_CACHE_NEG_TTL error  */
#line 940 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6155 "core/cfg.tab.c"
    break;

  case 157: /* assign_stm: DNS_CACHE_MAX_TTL EQUAL NUMBER  */
#line 941 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 6161 "core/cfg.tab.c"
    break;

  case 158: /* assign_stm: DNS_CACHE_MAX_TTL error  */
#line 942 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6167 "core/cfg.tab.c"
    break;

  case 159: /* assign_stm: DNS_CACHE_MIN_TTL EQUAL NUMBER  */
#line 943 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 6173 "core/cfg.tab.c"
    break;

  case 160: /* assign_stm: DNS_CACHE_MIN_TTL error  */
#line 944 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6179 "core/cfg.tab.c"
    break;

  case 161: /* assign_stm: DNS_CACHE_MEM EQUAL NUMBER  */
#line 945 "core/cfg.y"
                                       { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 6185 "core/cfg.tab.c"
    break;

  case 162: /* assign_stm: DNS_CACHE_MEM error  */
#line 946 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6191 "core/cfg.tab.c"
    break;

  case 163: /* assign_stm: DNS_CACHE_GC_INT EQUAL NUMBER  */
#line 947 "core/cfg.y"
                                          { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 6197 "core/cfg.tab.c"
    break;

  case 164: /* assign_stm: DNS_CACHE_GC_INT error  */
#line 948 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 6203 "core/cfg.tab.c"
    break;

  case 165: /* assign_stm: DNS_CACHE_DEL_NONEXP EQUAL NUMBER  */
#line 949 "core/cfg.y"
                                              { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 6209 "core/cfg.tab.c"
    break;

  case 166: /* assign_stm: DNS_CACHE_DEL_NONEXP error  */
#line 950 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6215 "core/cfg.tab.c"
    break;

  case 167: /* assign_stm: DNS_CACHE_REC_PREF EQUAL NUMBER  */
#line 951 "core/cfg.y"
                                            { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 6221 "core/cfg.tab.c"
    break;

  case 168: /* assign_stm: DNS_CACHE_REC_PREF error  */
#line 952 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 6227 "core/cfg.tab.c"
    break;

  case 169: /* assign_stm: AUTO_BIND_IPV6 EQUAL NUMBER  */
#line 953 "core/cfg.y"
                                      {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 6233 "core/cfg.tab.c"
    break;

  case 170: /* assign_stm: AUTO_BIND_IPV6 error  */
#line 954 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 6239 "core/cfg.tab.c"
    break;

  case 171: /* assign_stm: IPV6_HEX_STYLE EQUAL STRING  */
#line 955 "core/cfg.y"
                                      {
		ksr_ipv6_hex_style.s = (yyvsp[0].strval);
		if(ksr_ipv6_hex_style.s[0]!='a' && ksr_ipv6_hex_style.s[0]!='A'
				&& ksr_ipv6_hex_style.s[0]!='c') {
			yyerror("expected \"a\", \"A\" or \"c\" value");
		}
		ksr_ipv6_hex_style.len = strlen(ksr_ipv6_hex_style.s);
	}
#line 6252 "core/cfg.tab.c"
    break;

  case 172: /* assign_stm: IPV6_HEX_STYLE error  */
#line 963 "core/cfg.y"
                               { yyerror("string value expected"); }
#line 6258 "core/cfg.tab.c"
    break;

  case 173: /* assign_stm: BIND_IPV6_LINK_LOCAL EQUAL NUMBER  */
#line 964 "core/cfg.y"
                                            {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 6264 "core/cfg.tab.c"
    break;

  case 174: /* assign_stm: BIND_IPV6_LINK_LOCAL error  */
#line 965 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6270 "core/cfg.tab.c"
    break;

  case 175: /* assign_stm: DST_BLST_INIT EQUAL NUMBER  */
#line 966 "core/cfg.y"
                                       { IF_DST_BLOCKLIST(dst_blocklist_init=(yyvsp[0].intval)); }
#line 6276 "core/cfg.tab.c"
    break;

  case 176: /* assign_stm: DST_BLST_INIT error  */
#line 967 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6282 "core/cfg.tab.c"
    break;

  case 177: /* assign_stm: USE_DST_BLST EQUAL NUMBER  */
#line 968 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.use_dst_blocklist=(yyvsp[0].intval));
	}
#line 6290 "core/cfg.tab.c"
    break;

  case 178: /* assign_stm: USE_DST_BLST error  */
#line 971 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6296 "core/cfg.tab.c"
    break;

  case 179: /* assign_stm: DST_BLST_MEM EQUAL NUMBER  */
#line 972 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 6304 "core/cfg.tab.c"
    break;

  case 180: /* assign_stm: DST_BLST_MEM error  */
#line 975 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6310 "core/cfg.tab.c"
    break;

  case 181: /* assign_stm: DST_BLST_TTL EQUAL NUMBER  */
#line 976 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 6318 "core/cfg.tab.c"
    break;

  case 182: /* assign_stm: DST_BLST_TTL error  */
#line 979 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6324 "core/cfg.tab.c"
    break;

  case 183: /* assign_stm: DST_BLST_GC_INT EQUAL NUMBER  */
#line 980 "core/cfg.y"
                                       { IF_DST_BLOCKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6330 "core/cfg.tab.c"
    break;

  case 184: /* assign_stm: DST_BLST_GC_INT error  */
#line 981 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6336 "core/cfg.tab.c"
    break;

  case 185: /* assign_stm: DST_BLST_UDP_IMASK EQUAL NUMBER  */
#line 982 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6344 "core/cfg.tab.c"
    break;

  case 186: /* assign_stm: DST_BLST_UDP_IMASK error  */
#line 985 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6350 "core/cfg.tab.c"
    break;

  case 187: /* assign_stm: DST_BLST_TCP_IMASK EQUAL NUMBER  */
#line 986 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6358 "core/cfg.tab.c"
    break;

  case 188: /* assign_stm: DST_BLST_TCP_IMASK error  */
#line 989 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6364 "core/cfg.tab.c"
    break;

  case 189: /* assign_stm: DST_BLST_TLS_IMASK EQUAL NUMBER  */
#line 990 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6372 "core/cfg.tab.c"
    break;

  case 190: /* assign_stm: DST_BLST_TLS_IMASK error  */
#line 993 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6378 "core/cfg.tab.c"
    break;

  case 191: /* assign_stm: DST_BLST_SCTP_IMASK EQUAL NUMBER  */
#line 994 "core/cfg.y"
                                           {
		IF_DST_BLOCKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6386 "core/cfg.tab.c"
    break;

  case 192: /* assign_stm: DST_BLST_SCTP_IMASK error  */
#line 997 "core/cfg.y"
                                    { yyerror("number(flags) expected"); }
#line 6392 "core/cfg.tab.c"
    break;

  case 193: /* assign_stm: IP_FREE_BIND EQUAL intno  */
#line 998 "core/cfg.y"
                                   { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6398 "core/cfg.tab.c"
    break;

  case 194: /* assign_stm: IP_FREE_BIND EQUAL error  */
#line 999 "core/cfg.y"
                                   { yyerror("int value expected"); }
#line 6404 "core/cfg.tab.c"
    break;

  case 195: /* assign_stm: PORT EQUAL NUMBER  */
#line 1000 "core/cfg.y"
                              { port_no=(yyvsp[0].intval); }
#line 6410 "core/cfg.tab.c"
    break;

  case 196: /* assign_stm: PORT EQUAL error  */
#line 1001 "core/cfg.y"
                              { yyerror("number expected"); }
#line 6416 "core/cfg.tab.c"
    break;

  case 197: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 1002 "core/cfg.y"
                                 { maxbuffer=(yyvsp[0].intval); }
#line 6422 "core/cfg.tab.c"
    break;

  case 198: /* assign_stm: MAXBUFFER EQUAL error  */
#line 1003 "core/cfg.y"
                                { yyerror("number expected"); }
#line 6428 "core/cfg.tab.c"
    break;

  case 199: /* assign_stm: SQL_BUFFER_SIZE EQUAL NUMBER  */
#line 1004 "core/cfg.y"
                                   { sql_buffer_size=(yyvsp[0].intval); }
#line 6434 "core/cfg.tab.c"
    break;

  case 200: /* assign_stm: SQL_BUFFER_SIZE EQUAL error  */
#line 1005 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 6440 "core/cfg.tab.c"
    break;

  case 201: /* assign_stm: MSG_RECV_MAX_SIZE EQUAL NUMBER  */
#line 1006 "core/cfg.y"
                                         { ksr_msg_recv_max_size=(yyvsp[0].intval); }
#line 6446 "core/cfg.tab.c"
    break;

  case 202: /* assign_stm: MSG_RECV_MAX_SIZE EQUAL error  */
#line 1007 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 6452 "core/cfg.tab.c"
    break;

  case 203: /* assign_stm: TCP_MSG_READ_TIMEOUT EQUAL NUMBER  */
#line 1008 "core/cfg.y"
                                            { ksr_tcp_msg_read_timeout=(yyvsp[0].intval); }
#line 6458 "core/cfg.tab.c"
    break;

  case 204: /* assign_stm: TCP_MSG_READ_TIMEOUT EQUAL error  */
#line 1009 "core/cfg.y"
                                           { yyerror("number expected"); }
#line 6464 "core/cfg.tab.c"
    break;

  case 205: /* assign_stm: TCP_MSG_DATA_TIMEOUT EQUAL NUMBER  */
#line 1010 "core/cfg.y"
                                            { ksr_tcp_msg_data_timeout=(yyvsp[0].intval); }
#line 6470 "core/cfg.tab.c"
    break;

  case 206: /* assign_stm: TCP_MSG_DATA_TIMEOUT EQUAL error  */
#line 1011 "core/cfg.y"
                                           { yyerror("number expected"); }
#line 6476 "core/cfg.tab.c"
    break;

  case 207: /* assign_stm: TCP_ACCEPT_IPLIMIT EQUAL NUMBER  */
#line 1012 "core/cfg.y"
                                          { ksr_tcp_accept_iplimit=(yyvsp[0].intval); }
#line 6482 "core/cfg.tab.c"
    break;

  case 208: /* assign_stm: TCP_ACCEPT_IPLIMIT EQUAL error  */
#line 1013 "core/cfg.y"
                                         { yyerror("number expected"); }
#line 6488 "core/cfg.tab.c"
    break;

  case 209: /* assign_stm: TCP_CHECK_TIMER EQUAL NUMBER  */
#line 1014 "core/cfg.y"
                                       { ksr_tcp_check_timer=(yyvsp[0].intval); }
#line 6494 "core/cfg.tab.c"
    break;

  case 210: /* assign_stm: TCP_CHECK_TIMER EQUAL error  */
#line 1015 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 6500 "core/cfg.tab.c"
    break;

  case 211: /* assign_stm: CHILDREN EQUAL NUMBER  */
#line 1016 "core/cfg.y"
                                { children_no=(yyvsp[0].intval); }
#line 6506 "core/cfg.tab.c"
    break;

  case 212: /* assign_stm: CHILDREN EQUAL error  */
#line 1017 "core/cfg.y"
                               { yyerror("number expected"); }
#line 6512 "core/cfg.tab.c"
    break;

  case 213: /* assign_stm: STATS_NAMESEP EQUAL STRING  */
#line 1018 "core/cfg.y"
                                     { ksr_stats_namesep=(yyvsp[0].strval); }
#line 6518 "core/cfg.tab.c"
    break;

  case 214: /* assign_stm: STATS_NAMESEP EQUAL error  */
#line 1019 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 6524 "core/cfg.tab.c"
    break;

  case 215: /* $@6: %empty  */
#line 1020 "core/cfg.y"
                 {
				memset(&tmp_sa, 0, sizeof(socket_attrs_t));
			}
#line 6532 "core/cfg.tab.c"
    break;

  case 216: /* assign_stm: SOCKET $@6 EQUAL LBRACE socket_lattrs RBRACE  */
#line 1022 "core/cfg.y"
                                                            {
				if(add_listen_socket(&tmp_sa)<0) {
					LM_ERR("failed to add listen socket\n");
					yyerror("failed to add listen socket");
					ksr_exit(-1);
				}
	}
#line 6544 "core/cfg.tab.c"
    break;

  case 217: /* assign_stm: SOCKET_WORKERS EQUAL NUMBER  */
#line 1029 "core/cfg.y"
                                      { socket_workers=(yyvsp[0].intval); }
#line 6550 "core/cfg.tab.c"
    break;

  case 218: /* assign_stm: SOCKET_WORKERS EQUAL error  */
#line 1030 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 6556 "core/cfg.tab.c"
    break;

  case 219: /* assign_stm: ASYNC_WORKERS EQUAL NUMBER  */
#line 1031 "core/cfg.y"
                                     { async_task_set_workers((yyvsp[0].intval)); }
#line 6562 "core/cfg.tab.c"
    break;

  case 220: /* assign_stm: ASYNC_WORKERS EQUAL error  */
#line 1032 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 6568 "core/cfg.tab.c"
    break;

  case 221: /* assign_stm: ASYNC_USLEEP EQUAL NUMBER  */
#line 1033 "core/cfg.y"
                                    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6574 "core/cfg.tab.c"
    break;

  case 222: /* assign_stm: ASYNC_USLEEP EQUAL error  */
#line 1034 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 6580 "core/cfg.tab.c"
    break;

  case 223: /* assign_stm: ASYNC_NONBLOCK EQUAL NUMBER  */
#line 1035 "core/cfg.y"
                                      { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6586 "core/cfg.tab.c"
    break;

  case 224: /* assign_stm: ASYNC_NONBLOCK EQUAL error  */
#line 1036 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 6592 "core/cfg.tab.c"
    break;

  case 225: /* assign_stm: ASYNC_WORKERS_GROUP EQUAL STRING  */
#line 1037 "core/cfg.y"
                                           { async_task_set_workers_group((yyvsp[0].strval)); }
#line 6598 "core/cfg.tab.c"
    break;

  case 226: /* assign_stm: ASYNC_WORKERS_GROUP EQUAL error  */
#line 1038 "core/cfg.y"
                                          { yyerror("string expected"); }
#line 6604 "core/cfg.tab.c"
    break;

  case 227: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 1039 "core/cfg.y"
                                 { check_via=(yyvsp[0].intval); }
#line 6610 "core/cfg.tab.c"
    break;

  case 228: /* assign_stm: CHECK_VIA EQUAL error  */
#line 1040 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6616 "core/cfg.tab.c"
    break;

  case 229: /* assign_stm: PHONE2TEL EQUAL NUMBER  */
#line 1041 "core/cfg.y"
                                 { phone2tel=(yyvsp[0].intval); }
#line 6622 "core/cfg.tab.c"
    break;

  case 230: /* assign_stm: PHONE2TEL EQUAL error  */
#line 1042 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6628 "core/cfg.tab.c"
    break;

  case 231: /* assign_stm: MEMLOG EQUAL intno  */
#line 1043 "core/cfg.y"
                             { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6634 "core/cfg.tab.c"
    break;

  case 232: /* assign_stm: MEMLOG EQUAL error  */
#line 1044 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6640 "core/cfg.tab.c"
    break;

  case 233: /* assign_stm: MEMDBG EQUAL intno  */
#line 1045 "core/cfg.y"
                             { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6646 "core/cfg.tab.c"
    break;

  case 234: /* assign_stm: MEMDBG EQUAL error  */
#line 1046 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6652 "core/cfg.tab.c"
    break;

  case 235: /* assign_stm: MEMSUM EQUAL intno  */
#line 1047 "core/cfg.y"
                             { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6658 "core/cfg.tab.c"
    break;

  case 236: /* assign_stm: MEMSUM EQUAL error  */
#line 1048 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6664 "core/cfg.tab.c"
    break;

  case 237: /* assign_stm: MEMSAFETY EQUAL intno  */
#line 1049 "core/cfg.y"
                                { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6670 "core/cfg.tab.c"
    break;

  case 238: /* assign_stm: MEMSAFETY EQUAL error  */
#line 1050 "core/cfg.y"
                                { yyerror("int value expected"); }
#line 6676 "core/cfg.tab.c"
    break;

  case 239: /* assign_stm: MEMJOIN EQUAL intno  */
#line 1051 "core/cfg.y"
                              { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6682 "core/cfg.tab.c"
    break;

  case 240: /* assign_stm: MEMJOIN EQUAL error  */
#line 1052 "core/cfg.y"
                              { yyerror("int value expected"); }
#line 6688 "core/cfg.tab.c"
    break;

  case 241: /* assign_stm: MEMSTATUSMODE EQUAL intno  */
#line 1053 "core/cfg.y"
                                    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6694 "core/cfg.tab.c"
    break;

  case 242: /* assign_stm: MEMSTATUSMODE EQUAL error  */
#line 1054 "core/cfg.y"
                                    { yyerror("int value expected"); }
#line 6700 "core/cfg.tab.c"
    break;

  case 243: /* assign_stm: SIP_PARSER_LOG_ONELINE EQUAL intno  */
#line 1055 "core/cfg.y"
                                             { default_core_cfg.sip_parser_log_oneline=(yyvsp[0].intval); }
#line 6706 "core/cfg.tab.c"
    break;

  case 244: /* assign_stm: SIP_PARSER_LOG_ONELINE EQUAL error  */
#line 1056 "core/cfg.y"
                                             { yyerror("int value expected"); }
#line 6712 "core/cfg.tab.c"
    break;

  case 245: /* assign_stm: SIP_PARSER_LOG EQUAL intno  */
#line 1057 "core/cfg.y"
                                     { default_core_cfg.sip_parser_log=(yyvsp[0].intval); }
#line 6718 "core/cfg.tab.c"
    break;

  case 246: /* assign_stm: SIP_PARSER_LOG EQUAL error  */
#line 1058 "core/cfg.y"
                                     { yyerror("int value expected"); }
#line 6724 "core/cfg.tab.c"
    break;

  case 247: /* assign_stm: SIP_PARSER_MODE EQUAL intno  */
#line 1059 "core/cfg.y"
                                      { ksr_sip_parser_mode=(yyvsp[0].intval); }
#line 6730 "core/cfg.tab.c"
    break;

  case 248: /* assign_stm: SIP_PARSER_MODE EQUAL error  */
#line 1060 "core/cfg.y"
                                      { yyerror("int value expected"); }
#line 6736 "core/cfg.tab.c"
    break;

  case 249: /* assign_stm: CORELOG EQUAL intno  */
#line 1061 "core/cfg.y"
                              { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6742 "core/cfg.tab.c"
    break;

  case 250: /* assign_stm: CORELOG EQUAL error  */
#line 1062 "core/cfg.y"
                              { yyerror("int value expected"); }
#line 6748 "core/cfg.tab.c"
    break;

  case 251: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 1063 "core/cfg.y"
                                   { sip_warning=(yyvsp[0].intval); }
#line 6754 "core/cfg.tab.c"
    break;

  case 252: /* assign_stm: SIP_WARNING EQUAL error  */
#line 1064 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6760 "core/cfg.tab.c"
    break;

  case 253: /* assign_stm: VERSION_TABLE_CFG EQUAL STRING  */
#line 1065 "core/cfg.y"
                                         { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6768 "core/cfg.tab.c"
    break;

  case 254: /* assign_stm: VERSION_TABLE_CFG EQUAL error  */
#line 1068 "core/cfg.y"
                                        { yyerror("string value expected"); }
#line 6774 "core/cfg.tab.c"
    break;

  case 255: /* assign_stm: USER EQUAL STRING  */
#line 1069 "core/cfg.y"
                                {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6786 "core/cfg.tab.c"
    break;

  case 256: /* assign_stm: USER EQUAL ID  */
#line 1076 "core/cfg.y"
                                {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6798 "core/cfg.tab.c"
    break;

  case 257: /* assign_stm: USER EQUAL error  */
#line 1083 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 6804 "core/cfg.tab.c"
    break;

  case 258: /* assign_stm: GROUP EQUAL STRING  */
#line 1084 "core/cfg.y"
                                 { group=(yyvsp[0].strval); }
#line 6810 "core/cfg.tab.c"
    break;

  case 259: /* assign_stm: GROUP EQUAL ID  */
#line 1085 "core/cfg.y"
                                 { group=(yyvsp[0].strval); }
#line 6816 "core/cfg.tab.c"
    break;

  case 260: /* assign_stm: GROUP EQUAL error  */
#line 1086 "core/cfg.y"
                                 { yyerror("string value expected"); }
#line 6822 "core/cfg.tab.c"
    break;

  case 261: /* assign_stm: CHROOT EQUAL STRING  */
#line 1087 "core/cfg.y"
                                  { chroot_dir=(yyvsp[0].strval); }
#line 6828 "core/cfg.tab.c"
    break;

  case 262: /* assign_stm: CHROOT EQUAL ID  */
#line 1088 "core/cfg.y"
                                  { chroot_dir=(yyvsp[0].strval); }
#line 6834 "core/cfg.tab.c"
    break;

  case 263: /* assign_stm: CHROOT EQUAL error  */
#line 1089 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 6840 "core/cfg.tab.c"
    break;

  case 264: /* assign_stm: WDIR EQUAL STRING  */
#line 1090 "core/cfg.y"
                                { working_dir=(yyvsp[0].strval); }
#line 6846 "core/cfg.tab.c"
    break;

  case 265: /* assign_stm: WDIR EQUAL ID  */
#line 1091 "core/cfg.y"
                                { working_dir=(yyvsp[0].strval); }
#line 6852 "core/cfg.tab.c"
    break;

  case 266: /* assign_stm: WDIR EQUAL error  */
#line 1092 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 6858 "core/cfg.tab.c"
    break;

  case 267: /* assign_stm: RUNDIR EQUAL STRING  */
#line 1093 "core/cfg.y"
                                  { runtime_dir=(yyvsp[0].strval); }
#line 6864 "core/cfg.tab.c"
    break;

  case 268: /* assign_stm: RUNDIR EQUAL ID  */
#line 1094 "core/cfg.y"
                                  { runtime_dir=(yyvsp[0].strval); }
#line 6870 "core/cfg.tab.c"
    break;

  case 269: /* assign_stm: RUNDIR EQUAL error  */
#line 1095 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 6876 "core/cfg.tab.c"
    break;

  case 270: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 1096 "core/cfg.y"
                              { mhomed=(yyvsp[0].intval); }
#line 6882 "core/cfg.tab.c"
    break;

  case 271: /* assign_stm: MHOMED EQUAL error  */
#line 1097 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6888 "core/cfg.tab.c"
    break;

  case 272: /* assign_stm: DISABLE_TCP EQUAL NUMBER  */
#line 1098 "core/cfg.y"
                                   {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6900 "core/cfg.tab.c"
    break;

  case 273: /* assign_stm: DISABLE_TCP EQUAL error  */
#line 1105 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6906 "core/cfg.tab.c"
    break;

  case 274: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 1106 "core/cfg.y"
                                          {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6918 "core/cfg.tab.c"
    break;

  case 275: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 1113 "core/cfg.y"
                                         { yyerror("boolean value expected"); }
#line 6924 "core/cfg.tab.c"
    break;

  case 276: /* assign_stm: TCP_ACCEPT_UNIQUE EQUAL NUMBER  */
#line 1114 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6936 "core/cfg.tab.c"
    break;

  case 277: /* assign_stm: TCP_ACCEPT_UNIQUE EQUAL error  */
#line 1121 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 6942 "core/cfg.tab.c"
    break;

  case 278: /* assign_stm: TCP_CONNECTION_MATCH EQUAL NUMBER  */
#line 1122 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6954 "core/cfg.tab.c"
    break;

  case 279: /* assign_stm: TCP_CONNECTION_MATCH EQUAL error  */
#line 1129 "core/cfg.y"
                                           { yyerror("number expected"); }
#line 6960 "core/cfg.tab.c"
    break;

  case 280: /* assign_stm: TCP_CHILDREN EQUAL NUMBER  */
#line 1130 "core/cfg.y"
                                    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6972 "core/cfg.tab.c"
    break;

  case 281: /* assign_stm: TCP_CHILDREN EQUAL error  */
#line 1137 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 6978 "core/cfg.tab.c"
    break;

  case 282: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL intno  */
#line 1138 "core/cfg.y"
                                          {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6990 "core/cfg.tab.c"
    break;

  case 283: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 1145 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 6996 "core/cfg.tab.c"
    break;

  case 284: /* assign_stm: TCP_SEND_TIMEOUT EQUAL intno  */
#line 1146 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7008 "core/cfg.tab.c"
    break;

  case 285: /* assign_stm: TCP_SEND_TIMEOUT EQUAL error  */
#line 1153 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7014 "core/cfg.tab.c"
    break;

  case 286: /* assign_stm: TCP_CON_LIFETIME EQUAL intno  */
#line 1154 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7029 "core/cfg.tab.c"
    break;

  case 287: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 1164 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7035 "core/cfg.tab.c"
    break;

  case 288: /* assign_stm: TCP_POLL_METHOD EQUAL ID  */
#line 1165 "core/cfg.y"
                                   {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7054 "core/cfg.tab.c"
    break;

  case 289: /* assign_stm: TCP_POLL_METHOD EQUAL STRING  */
#line 1179 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7073 "core/cfg.tab.c"
    break;

  case 290: /* assign_stm: TCP_POLL_METHOD EQUAL error  */
#line 1193 "core/cfg.y"
                                      { yyerror("poll method name expected"); }
#line 7079 "core/cfg.tab.c"
    break;

  case 291: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1194 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7091 "core/cfg.tab.c"
    break;

  case 292: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 1201 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 7097 "core/cfg.tab.c"
    break;

  case 293: /* assign_stm: TLS_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1202 "core/cfg.y"
                                           {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7109 "core/cfg.tab.c"
    break;

  case 294: /* assign_stm: TLS_MAX_CONNECTIONS EQUAL error  */
#line 1209 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 7115 "core/cfg.tab.c"
    break;

  case 295: /* assign_stm: TCP_NO_CONNECT EQUAL NUMBER  */
#line 1210 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7127 "core/cfg.tab.c"
    break;

  case 296: /* assign_stm: TCP_NO_CONNECT EQUAL error  */
#line 1217 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 7133 "core/cfg.tab.c"
    break;

  case 297: /* assign_stm: TCP_SOURCE_IPV4 EQUAL ipv4  */
#line 1218 "core/cfg.y"
                                     {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 7147 "core/cfg.tab.c"
    break;

  case 298: /* assign_stm: TCP_SOURCE_IPV4 EQUAL error  */
#line 1227 "core/cfg.y"
                                      { yyerror("IPv4 address expected"); }
#line 7153 "core/cfg.tab.c"
    break;

  case 299: /* assign_stm: TCP_SOURCE_IPV6 EQUAL ipv6  */
#line 1228 "core/cfg.y"
                                     {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 7167 "core/cfg.tab.c"
    break;

  case 300: /* assign_stm: TCP_SOURCE_IPV6 EQUAL error  */
#line 1237 "core/cfg.y"
                                      { yyerror("IPv6 address expected"); }
#line 7173 "core/cfg.tab.c"
    break;

  case 301: /* assign_stm: TCP_OPT_FD_CACHE EQUAL NUMBER  */
#line 1238 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7185 "core/cfg.tab.c"
    break;

  case 302: /* assign_stm: TCP_OPT_FD_CACHE EQUAL error  */
#line 1245 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 7191 "core/cfg.tab.c"
    break;

  case 303: /* assign_stm: TCP_OPT_BUF_WRITE EQUAL NUMBER  */
#line 1246 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7203 "core/cfg.tab.c"
    break;

  case 304: /* assign_stm: TCP_OPT_BUF_WRITE EQUAL error  */
#line 1253 "core/cfg.y"
                                        { yyerror("boolean value expected"); }
#line 7209 "core/cfg.tab.c"
    break;

  case 305: /* assign_stm: TCP_OPT_CONN_WQ_MAX EQUAL NUMBER  */
#line 1254 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7221 "core/cfg.tab.c"
    break;

  case 306: /* assign_stm: TCP_OPT_CONN_WQ_MAX error  */
#line 1261 "core/cfg.y"
                                    { yyerror("boolean value expected"); }
#line 7227 "core/cfg.tab.c"
    break;

  case 307: /* assign_stm: TCP_OPT_WQ_MAX EQUAL NUMBER  */
#line 1262 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7239 "core/cfg.tab.c"
    break;

  case 308: /* assign_stm: TCP_OPT_WQ_MAX error  */
#line 1269 "core/cfg.y"
                               { yyerror("number expected"); }
#line 7245 "core/cfg.tab.c"
    break;

  case 309: /* assign_stm: TCP_OPT_RD_BUF EQUAL NUMBER  */
#line 1270 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7257 "core/cfg.tab.c"
    break;

  case 310: /* assign_stm: TCP_OPT_RD_BUF error  */
#line 1277 "core/cfg.y"
                               { yyerror("number expected"); }
#line 7263 "core/cfg.tab.c"
    break;

  case 311: /* assign_stm: TCP_OPT_WQ_BLK EQUAL NUMBER  */
#line 1278 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7275 "core/cfg.tab.c"
    break;

  case 312: /* assign_stm: TCP_OPT_WQ_BLK error  */
#line 1285 "core/cfg.y"
                               { yyerror("number expected"); }
#line 7281 "core/cfg.tab.c"
    break;

  case 313: /* assign_stm: TCP_OPT_DEFER_ACCEPT EQUAL NUMBER  */
#line 1286 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7293 "core/cfg.tab.c"
    break;

  case 314: /* assign_stm: TCP_OPT_DEFER_ACCEPT EQUAL error  */
#line 1293 "core/cfg.y"
                                           { yyerror("boolean value expected"); }
#line 7299 "core/cfg.tab.c"
    break;

  case 315: /* assign_stm: TCP_OPT_DELAYED_ACK EQUAL NUMBER  */
#line 1294 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7311 "core/cfg.tab.c"
    break;

  case 316: /* assign_stm: TCP_OPT_DELAYED_ACK EQUAL error  */
#line 1301 "core/cfg.y"
                                          { yyerror("boolean value expected"); }
#line 7317 "core/cfg.tab.c"
    break;

  case 317: /* assign_stm: TCP_OPT_SYNCNT EQUAL NUMBER  */
#line 1302 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7329 "core/cfg.tab.c"
    break;

  case 318: /* assign_stm: TCP_OPT_SYNCNT EQUAL error  */
#line 1309 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 7335 "core/cfg.tab.c"
    break;

  case 319: /* assign_stm: TCP_OPT_LINGER2 EQUAL NUMBER  */
#line 1310 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7347 "core/cfg.tab.c"
    break;

  case 320: /* assign_stm: TCP_OPT_LINGER2 EQUAL error  */
#line 1317 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7353 "core/cfg.tab.c"
    break;

  case 321: /* assign_stm: TCP_OPT_KEEPALIVE EQUAL NUMBER  */
#line 1318 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7365 "core/cfg.tab.c"
    break;

  case 322: /* assign_stm: TCP_OPT_KEEPALIVE EQUAL error  */
#line 1325 "core/cfg.y"
                                        { yyerror("boolean value expected");}
#line 7371 "core/cfg.tab.c"
    break;

  case 323: /* assign_stm: TCP_OPT_KEEPIDLE EQUAL NUMBER  */
#line 1326 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7383 "core/cfg.tab.c"
    break;

  case 324: /* assign_stm: TCP_OPT_KEEPIDLE EQUAL error  */
#line 1333 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7389 "core/cfg.tab.c"
    break;

  case 325: /* assign_stm: TCP_OPT_KEEPINTVL EQUAL NUMBER  */
#line 1334 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7401 "core/cfg.tab.c"
    break;

  case 326: /* assign_stm: TCP_OPT_KEEPINTVL EQUAL error  */
#line 1341 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 7407 "core/cfg.tab.c"
    break;

  case 327: /* assign_stm: TCP_OPT_KEEPCNT EQUAL NUMBER  */
#line 1342 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7419 "core/cfg.tab.c"
    break;

  case 328: /* assign_stm: TCP_OPT_KEEPCNT EQUAL error  */
#line 1349 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7425 "core/cfg.tab.c"
    break;

  case 329: /* assign_stm: TCP_OPT_CRLF_PING EQUAL NUMBER  */
#line 1350 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7437 "core/cfg.tab.c"
    break;

  case 330: /* assign_stm: TCP_OPT_CRLF_PING EQUAL error  */
#line 1357 "core/cfg.y"
                                        { yyerror("boolean value expected"); }
#line 7443 "core/cfg.tab.c"
    break;

  case 331: /* assign_stm: TCP_OPT_ACCEPT_NO_CL EQUAL NUMBER  */
#line 1358 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7455 "core/cfg.tab.c"
    break;

  case 332: /* assign_stm: TCP_OPT_ACCEPT_NO_CL EQUAL error  */
#line 1365 "core/cfg.y"
                                           { yyerror("boolean value expected"); }
#line 7461 "core/cfg.tab.c"
    break;

  case 333: /* assign_stm: TCP_OPT_ACCEPT_HEP3 EQUAL NUMBER  */
#line 1366 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7473 "core/cfg.tab.c"
    break;

  case 334: /* assign_stm: TCP_OPT_ACCEPT_HEP3 EQUAL error  */
#line 1373 "core/cfg.y"
                                          { yyerror("boolean value expected"); }
#line 7479 "core/cfg.tab.c"
    break;

  case 335: /* assign_stm: TCP_OPT_ACCEPT_HAPROXY EQUAL NUMBER  */
#line 1374 "core/cfg.y"
                                              {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7491 "core/cfg.tab.c"
    break;

  case 336: /* assign_stm: TCP_OPT_ACCEPT_HAPROXY EQUAL error  */
#line 1381 "core/cfg.y"
                                             { yyerror("boolean value expected"); }
#line 7497 "core/cfg.tab.c"
    break;

  case 337: /* assign_stm: TCP_OPT_CLOSE_RST EQUAL NUMBER  */
#line 1382 "core/cfg.y"
                                         {
         #ifdef USE_TCP
             tcp_default_cfg.close_rst=(yyvsp[0].intval);
         #else
             warn("tcp support not compiled in");
         #endif
     }
#line 7509 "core/cfg.tab.c"
    break;

  case 338: /* assign_stm: TCP_OPT_CLOSE_RST EQUAL error  */
#line 1389 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 7515 "core/cfg.tab.c"
    break;

  case 339: /* assign_stm: TCP_CLONE_RCVBUF EQUAL NUMBER  */
#line 1391 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7527 "core/cfg.tab.c"
    break;

  case 340: /* assign_stm: TCP_CLONE_RCVBUF EQUAL error  */
#line 1398 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7533 "core/cfg.tab.c"
    break;

  case 341: /* assign_stm: TCP_REUSE_PORT EQUAL NUMBER  */
#line 1399 "core/cfg.y"
                                      {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7549 "core/cfg.tab.c"
    break;

  case 342: /* assign_stm: TCP_REUSE_PORT EQUAL error  */
#line 1410 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 7555 "core/cfg.tab.c"
    break;

  case 343: /* assign_stm: TCP_WAIT_DATA EQUAL intno  */
#line 1411 "core/cfg.y"
                                    {
		#ifdef USE_TCP
			tcp_default_cfg.wait_data_ms=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7567 "core/cfg.tab.c"
    break;

  case 344: /* assign_stm: TCP_WAIT_DATA EQUAL error  */
#line 1418 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 7573 "core/cfg.tab.c"
    break;

  case 345: /* assign_stm: TCP_SCRIPT_MODE EQUAL intno  */
#line 1419 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			ksr_tcp_script_mode=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7585 "core/cfg.tab.c"
    break;

  case 346: /* assign_stm: TCP_SCRIPT_MODE EQUAL error  */
#line 1426 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7591 "core/cfg.tab.c"
    break;

  case 347: /* assign_stm: DISABLE_TLS EQUAL NUMBER  */
#line 1427 "core/cfg.y"
                                   {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7603 "core/cfg.tab.c"
    break;

  case 348: /* assign_stm: DISABLE_TLS EQUAL error  */
#line 1434 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 7609 "core/cfg.tab.c"
    break;

  case 349: /* assign_stm: ENABLE_TLS EQUAL NUMBER  */
#line 1435 "core/cfg.y"
                                  {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7621 "core/cfg.tab.c"
    break;

  case 350: /* assign_stm: ENABLE_TLS EQUAL error  */
#line 1442 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 7627 "core/cfg.tab.c"
    break;

  case 351: /* assign_stm: TLSLOG EQUAL NUMBER  */
#line 1443 "core/cfg.y"
                              {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7639 "core/cfg.tab.c"
    break;

  case 352: /* assign_stm: TLSLOG EQUAL error  */
#line 1450 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 7645 "core/cfg.tab.c"
    break;

  case 353: /* assign_stm: TLS_PORT_NO EQUAL NUMBER  */
#line 1451 "core/cfg.y"
                                   {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7657 "core/cfg.tab.c"
    break;

  case 354: /* assign_stm: TLS_PORT_NO EQUAL error  */
#line 1458 "core/cfg.y"
                                  { yyerror("number expected"); }
#line 7663 "core/cfg.tab.c"
    break;

  case 355: /* assign_stm: TLS_METHOD EQUAL SSLv23  */
#line 1459 "core/cfg.y"
                                  {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7675 "core/cfg.tab.c"
    break;

  case 356: /* assign_stm: TLS_METHOD EQUAL SSLv2  */
#line 1466 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7687 "core/cfg.tab.c"
    break;

  case 357: /* assign_stm: TLS_METHOD EQUAL SSLv3  */
#line 1473 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7699 "core/cfg.tab.c"
    break;

  case 358: /* assign_stm: TLS_METHOD EQUAL TLSv1  */
#line 1480 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7711 "core/cfg.tab.c"
    break;

  case 359: /* assign_stm: TLS_METHOD EQUAL error  */
#line 1487 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7723 "core/cfg.tab.c"
    break;

  case 360: /* assign_stm: TLS_VERIFY EQUAL NUMBER  */
#line 1494 "core/cfg.y"
                                  {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7735 "core/cfg.tab.c"
    break;

  case 361: /* assign_stm: TLS_VERIFY EQUAL error  */
#line 1501 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 7741 "core/cfg.tab.c"
    break;

  case 362: /* assign_stm: TLS_REQUIRE_CERTIFICATE EQUAL NUMBER  */
#line 1502 "core/cfg.y"
                                               {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7753 "core/cfg.tab.c"
    break;

  case 363: /* assign_stm: TLS_REQUIRE_CERTIFICATE EQUAL error  */
#line 1509 "core/cfg.y"
                                              { yyerror("boolean value expected"); }
#line 7759 "core/cfg.tab.c"
    break;

  case 364: /* assign_stm: TLS_CERTIFICATE EQUAL STRING  */
#line 1510 "core/cfg.y"
                                       {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7771 "core/cfg.tab.c"
    break;

  case 365: /* assign_stm: TLS_CERTIFICATE EQUAL error  */
#line 1517 "core/cfg.y"
                                      { yyerror("string value expected"); }
#line 7777 "core/cfg.tab.c"
    break;

  case 366: /* assign_stm: TLS_PRIVATE_KEY EQUAL STRING  */
#line 1518 "core/cfg.y"
                                       {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7789 "core/cfg.tab.c"
    break;

  case 367: /* assign_stm: TLS_PRIVATE_KEY EQUAL error  */
#line 1525 "core/cfg.y"
                                      { yyerror("string value expected"); }
#line 7795 "core/cfg.tab.c"
    break;

  case 368: /* assign_stm: TLS_CA_LIST EQUAL STRING  */
#line 1526 "core/cfg.y"
                                   {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7807 "core/cfg.tab.c"
    break;

  case 369: /* assign_stm: TLS_CA_LIST EQUAL error  */
#line 1533 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 7813 "core/cfg.tab.c"
    break;

  case 370: /* assign_stm: TLS_HANDSHAKE_TIMEOUT EQUAL NUMBER  */
#line 1534 "core/cfg.y"
                                             {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7825 "core/cfg.tab.c"
    break;

  case 371: /* assign_stm: TLS_HANDSHAKE_TIMEOUT EQUAL error  */
#line 1541 "core/cfg.y"
                                            { yyerror("number expected"); }
#line 7831 "core/cfg.tab.c"
    break;

  case 372: /* assign_stm: TLS_SEND_TIMEOUT EQUAL NUMBER  */
#line 1542 "core/cfg.y"
                                        {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7843 "core/cfg.tab.c"
    break;

  case 373: /* assign_stm: TLS_SEND_TIMEOUT EQUAL error  */
#line 1549 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7849 "core/cfg.tab.c"
    break;

  case 374: /* assign_stm: DISABLE_SCTP EQUAL NUMBER  */
#line 1550 "core/cfg.y"
                                    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7861 "core/cfg.tab.c"
    break;

  case 375: /* assign_stm: DISABLE_SCTP EQUAL error  */
#line 1557 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 7867 "core/cfg.tab.c"
    break;

  case 376: /* assign_stm: ENABLE_SCTP EQUAL NUMBER  */
#line 1558 "core/cfg.y"
                                   {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7879 "core/cfg.tab.c"
    break;

  case 377: /* assign_stm: ENABLE_SCTP EQUAL error  */
#line 1565 "core/cfg.y"
                                  { yyerror("boolean or number expected"); }
#line 7885 "core/cfg.tab.c"
    break;

  case 378: /* assign_stm: SCTP_CHILDREN EQUAL NUMBER  */
#line 1566 "core/cfg.y"
                                     {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7897 "core/cfg.tab.c"
    break;

  case 379: /* assign_stm: SCTP_CHILDREN EQUAL error  */
#line 1573 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 7903 "core/cfg.tab.c"
    break;

  case 380: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1574 "core/cfg.y"
                                        { server_signature=(yyvsp[0].intval); }
#line 7909 "core/cfg.tab.c"
    break;

  case 381: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1575 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 7915 "core/cfg.tab.c"
    break;

  case 382: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1576 "core/cfg.y"
                                     { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7923 "core/cfg.tab.c"
    break;

  case 383: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1579 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 7929 "core/cfg.tab.c"
    break;

  case 384: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1580 "core/cfg.y"
                                         { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7937 "core/cfg.tab.c"
    break;

  case 385: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1583 "core/cfg.y"
                                        { yyerror("string value expected"); }
#line 7943 "core/cfg.tab.c"
    break;

  case 386: /* assign_stm: URI_HOST_EXTRA_CHARS EQUAL STRING  */
#line 1584 "core/cfg.y"
                                            { _sr_uri_host_extra_chars=(yyvsp[0].strval); }
#line 7949 "core/cfg.tab.c"
    break;

  case 387: /* assign_stm: URI_HOST_EXTRA_CHARS EQUAL error  */
#line 1585 "core/cfg.y"
                                           { yyerror("string value expected"); }
#line 7955 "core/cfg.tab.c"
    break;

  case 388: /* assign_stm: HDR_NAME_EXTRA_CHARS EQUAL STRING  */
#line 1586 "core/cfg.y"
                                            { _ksr_hname_extra_chars=(unsigned char*)(yyvsp[0].strval); }
#line 7961 "core/cfg.tab.c"
    break;

  case 389: /* assign_stm: HDR_NAME_EXTRA_CHARS EQUAL error  */
#line 1587 "core/cfg.y"
                                           { yyerror("string value expected"); }
#line 7967 "core/cfg.tab.c"
    break;

  case 390: /* assign_stm: REPLY_TO_VIA EQUAL NUMBER  */
#line 1588 "core/cfg.y"
                                    { reply_to_via=(yyvsp[0].intval); }
#line 7973 "core/cfg.tab.c"
    break;

  case 391: /* assign_stm: REPLY_TO_VIA EQUAL error  */
#line 1589 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 7979 "core/cfg.tab.c"
    break;

  case 392: /* assign_stm: LISTEN EQUAL id_lst  */
#line 1590 "core/cfg.y"
                              {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7996 "core/cfg.tab.c"
    break;

  case 393: /* assign_stm: LISTEN EQUAL id_lst VIRTUAL  */
#line 1602 "core/cfg.y"
                                      {
                for(lst_tmp=(yyvsp[-1].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface(   lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-1].sockid));
        }
#line 8014 "core/cfg.tab.c"
    break;

  case 394: /* assign_stm: LISTEN EQUAL id_lst STRNAME STRING  */
#line 1615 "core/cfg.y"
                                             {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 8031 "core/cfg.tab.c"
    break;

  case 395: /* assign_stm: LISTEN EQUAL id_lst STRNAME STRING VIRTUAL  */
#line 1627 "core/cfg.y"
                                                     {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
                        lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 8049 "core/cfg.tab.c"
    break;

  case 396: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER  */
#line 1640 "core/cfg.y"
                                                               {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 8067 "core/cfg.tab.c"
    break;

  case 397: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER VIRTUAL  */
#line 1653 "core/cfg.y"
                                                                       {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-3].strval), (yyvsp[-1].intval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 8086 "core/cfg.tab.c"
    break;

  case 398: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER STRNAME STRING  */
#line 1667 "core/cfg.y"
                                                                              {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 8104 "core/cfg.tab.c"
    break;

  case 399: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER STRNAME STRING VIRTUAL  */
#line 1680 "core/cfg.y"
                                                                                      {
                for(lst_tmp=(yyvsp[-7].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-5].strval), (yyvsp[-3].intval), (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-7].sockid));
        }
#line 8123 "core/cfg.tab.c"
    break;

  case 400: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id  */
#line 1694 "core/cfg.y"
                                                  {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 8141 "core/cfg.tab.c"
    break;

  case 401: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id VIRTUAL  */
#line 1707 "core/cfg.y"
                                                          {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-1].strval), 0,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 8160 "core/cfg.tab.c"
    break;

  case 402: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id STRNAME STRING  */
#line 1721 "core/cfg.y"
                                                                 {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 8178 "core/cfg.tab.c"
    break;

  case 403: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id STRNAME STRING VIRTUAL  */
#line 1734 "core/cfg.y"
                                                                         {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-3].strval), 0, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 8197 "core/cfg.tab.c"
    break;

  case 404: /* assign_stm: LISTEN EQUAL error  */
#line 1748 "core/cfg.y"
                              { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 8204 "core/cfg.tab.c"
    break;

  case 405: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1750 "core/cfg.y"
                              {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8220 "core/cfg.tab.c"
    break;

  case 406: /* assign_stm: ALIAS EQUAL error  */
#line 1761 "core/cfg.y"
                              { yyerror("hostname expected"); }
#line 8226 "core/cfg.tab.c"
    break;

  case 407: /* assign_stm: DOMAIN EQUAL id_lst  */
#line 1762 "core/cfg.y"
                               {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8242 "core/cfg.tab.c"
    break;

  case 408: /* assign_stm: DOMAIN EQUAL error  */
#line 1773 "core/cfg.y"
                               { yyerror("hostname expected"); }
#line 8248 "core/cfg.tab.c"
    break;

  case 409: /* assign_stm: SR_AUTO_ALIASES EQUAL NUMBER  */
#line 1774 "core/cfg.y"
                                       { sr_auto_aliases=(yyvsp[0].intval); }
#line 8254 "core/cfg.tab.c"
    break;

  case 410: /* assign_stm: SR_AUTO_ALIASES EQUAL error  */
#line 1775 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8260 "core/cfg.tab.c"
    break;

  case 411: /* assign_stm: SR_AUTO_DOMAINS EQUAL NUMBER  */
#line 1776 "core/cfg.y"
                                       { sr_auto_aliases=(yyvsp[0].intval); }
#line 8266 "core/cfg.tab.c"
    break;

  case 412: /* assign_stm: SR_AUTO_DOMAINS EQUAL error  */
#line 1777 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8272 "core/cfg.tab.c"
    break;

  case 413: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1778 "core/cfg.y"
                                             {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 8283 "core/cfg.tab.c"
    break;

  case 414: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1784 "core/cfg.y"
                                         {yyerror("ip address or hostname expected"); }
#line 8289 "core/cfg.tab.c"
    break;

  case 415: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1785 "core/cfg.y"
                                       {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 8304 "core/cfg.tab.c"
    break;

  case 416: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1795 "core/cfg.y"
                                     {yyerror("ip address or hostname expected"); }
#line 8310 "core/cfg.tab.c"
    break;

  case 417: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1796 "core/cfg.y"
                                    { disable_core_dump=(yyvsp[0].intval); }
#line 8316 "core/cfg.tab.c"
    break;

  case 418: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1797 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 8322 "core/cfg.tab.c"
    break;

  case 419: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1798 "core/cfg.y"
                                     { open_files_limit=(yyvsp[0].intval); }
#line 8328 "core/cfg.tab.c"
    break;

  case 420: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1799 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 8334 "core/cfg.tab.c"
    break;

  case 421: /* assign_stm: SHM_MEM_SZ EQUAL NUMBER  */
#line 1800 "core/cfg.y"
                                  {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 8346 "core/cfg.tab.c"
    break;

  case 422: /* assign_stm: SHM_MEM_SZ EQUAL error  */
#line 1807 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8352 "core/cfg.tab.c"
    break;

  case 423: /* assign_stm: SHM_FORCE_ALLOC EQUAL NUMBER  */
#line 1808 "core/cfg.y"
                                       {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 8364 "core/cfg.tab.c"
    break;

  case 424: /* assign_stm: SHM_FORCE_ALLOC EQUAL error  */
#line 1815 "core/cfg.y"
                                      { yyerror("boolean value expected"); }
#line 8370 "core/cfg.tab.c"
    break;

  case 425: /* assign_stm: MLOCK_PAGES EQUAL NUMBER  */
#line 1816 "core/cfg.y"
                                   { mlock_pages=(yyvsp[0].intval); }
#line 8376 "core/cfg.tab.c"
    break;

  case 426: /* assign_stm: MLOCK_PAGES EQUAL error  */
#line 1817 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 8382 "core/cfg.tab.c"
    break;

  case 427: /* assign_stm: REAL_TIME EQUAL NUMBER  */
#line 1818 "core/cfg.y"
                                 { real_time=(yyvsp[0].intval); }
#line 8388 "core/cfg.tab.c"
    break;

  case 428: /* assign_stm: REAL_TIME EQUAL error  */
#line 1819 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 8394 "core/cfg.tab.c"
    break;

  case 429: /* assign_stm: RT_PRIO EQUAL NUMBER  */
#line 1820 "core/cfg.y"
                               { rt_prio=(yyvsp[0].intval); }
#line 8400 "core/cfg.tab.c"
    break;

  case 430: /* assign_stm: RT_PRIO EQUAL error  */
#line 1821 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 8406 "core/cfg.tab.c"
    break;

  case 431: /* assign_stm: RT_POLICY EQUAL NUMBER  */
#line 1822 "core/cfg.y"
                                 { rt_policy=(yyvsp[0].intval); }
#line 8412 "core/cfg.tab.c"
    break;

  case 432: /* assign_stm: RT_POLICY EQUAL error  */
#line 1823 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 8418 "core/cfg.tab.c"
    break;

  case 433: /* assign_stm: RT_TIMER1_PRIO EQUAL NUMBER  */
#line 1824 "core/cfg.y"
                                      { rt_timer1_prio=(yyvsp[0].intval); }
#line 8424 "core/cfg.tab.c"
    break;

  case 434: /* assign_stm: RT_TIMER1_PRIO EQUAL error  */
#line 1825 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8430 "core/cfg.tab.c"
    break;

  case 435: /* assign_stm: RT_TIMER1_POLICY EQUAL NUMBER  */
#line 1826 "core/cfg.y"
                                        { rt_timer1_policy=(yyvsp[0].intval); }
#line 8436 "core/cfg.tab.c"
    break;

  case 436: /* assign_stm: RT_TIMER1_POLICY EQUAL error  */
#line 1827 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8442 "core/cfg.tab.c"
    break;

  case 437: /* assign_stm: RT_TIMER2_PRIO EQUAL NUMBER  */
#line 1828 "core/cfg.y"
                                      { rt_timer2_prio=(yyvsp[0].intval); }
#line 8448 "core/cfg.tab.c"
    break;

  case 438: /* assign_stm: RT_TIMER2_PRIO EQUAL error  */
#line 1829 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8454 "core/cfg.tab.c"
    break;

  case 439: /* assign_stm: RT_TIMER2_POLICY EQUAL NUMBER  */
#line 1830 "core/cfg.y"
                                        { rt_timer2_policy=(yyvsp[0].intval); }
#line 8460 "core/cfg.tab.c"
    break;

  case 440: /* assign_stm: RT_TIMER2_POLICY EQUAL error  */
#line 1831 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8466 "core/cfg.tab.c"
    break;

  case 441: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1832 "core/cfg.y"
                                      {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8478 "core/cfg.tab.c"
    break;

  case 442: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1839 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8484 "core/cfg.tab.c"
    break;

  case 443: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1840 "core/cfg.y"
                                 {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8496 "core/cfg.tab.c"
    break;

  case 444: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1847 "core/cfg.y"
                                { yyerror("number expected"); }
#line 8502 "core/cfg.tab.c"
    break;

  case 445: /* assign_stm: MCAST EQUAL ID  */
#line 1848 "core/cfg.y"
                         {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8514 "core/cfg.tab.c"
    break;

  case 446: /* assign_stm: MCAST EQUAL STRING  */
#line 1855 "core/cfg.y"
                             {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8526 "core/cfg.tab.c"
    break;

  case 447: /* assign_stm: MCAST EQUAL error  */
#line 1862 "core/cfg.y"
                            { yyerror("string expected"); }
#line 8532 "core/cfg.tab.c"
    break;

  case 448: /* assign_stm: TOS EQUAL NUMBER  */
#line 1863 "core/cfg.y"
                           { tos=(yyvsp[0].intval); }
#line 8538 "core/cfg.tab.c"
    break;

  case 449: /* assign_stm: TOS EQUAL ID  */
#line 1864 "core/cfg.y"
                       { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 8570 "core/cfg.tab.c"
    break;

  case 450: /* assign_stm: TOS EQUAL error  */
#line 1891 "core/cfg.y"
                          { yyerror("number expected"); }
#line 8576 "core/cfg.tab.c"
    break;

  case 451: /* assign_stm: PMTU_DISCOVERY EQUAL NUMBER  */
#line 1892 "core/cfg.y"
                                      { pmtu_discovery=(yyvsp[0].intval); }
#line 8582 "core/cfg.tab.c"
    break;

  case 452: /* assign_stm: PMTU_DISCOVERY error  */
#line 1893 "core/cfg.y"
                               { yyerror("number expected"); }
#line 8588 "core/cfg.tab.c"
    break;

  case 453: /* assign_stm: KILL_TIMEOUT EQUAL NUMBER  */
#line 1894 "core/cfg.y"
                                    { ser_kill_timeout=(yyvsp[0].intval); }
#line 8594 "core/cfg.tab.c"
    break;

  case 454: /* assign_stm: KILL_TIMEOUT EQUAL error  */
#line 1895 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8600 "core/cfg.tab.c"
    break;

  case 455: /* assign_stm: MAX_WLOOPS EQUAL NUMBER  */
#line 1896 "core/cfg.y"
                                  { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 8606 "core/cfg.tab.c"
    break;

  case 456: /* assign_stm: MAX_WLOOPS EQUAL error  */
#line 1897 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8612 "core/cfg.tab.c"
    break;

  case 457: /* assign_stm: PVBUFSIZE EQUAL NUMBER  */
#line 1898 "core/cfg.y"
                                 { pv_set_buffer_size((yyvsp[0].intval)); }
#line 8618 "core/cfg.tab.c"
    break;

  case 458: /* assign_stm: PVBUFSIZE EQUAL error  */
#line 1899 "core/cfg.y"
                                { yyerror("number expected"); }
#line 8624 "core/cfg.tab.c"
    break;

  case 459: /* assign_stm: PVBUFSLOTS EQUAL NUMBER  */
#line 1900 "core/cfg.y"
                                  { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 8630 "core/cfg.tab.c"
    break;

  case 460: /* assign_stm: PVBUFSLOTS EQUAL error  */
#line 1901 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8636 "core/cfg.tab.c"
    break;

  case 461: /* assign_stm: PVCACHELIMIT EQUAL NUMBER  */
#line 1902 "core/cfg.y"
                                    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 8642 "core/cfg.tab.c"
    break;

  case 462: /* assign_stm: PVCACHELIMIT EQUAL error  */
#line 1903 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8648 "core/cfg.tab.c"
    break;

  case 463: /* assign_stm: PVCACHEACTION EQUAL NUMBER  */
#line 1904 "core/cfg.y"
                                     { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 8654 "core/cfg.tab.c"
    break;

  case 464: /* assign_stm: PVCACHEACTION EQUAL error  */
#line 1905 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 8660 "core/cfg.tab.c"
    break;

  case 465: /* assign_stm: HTTP_REPLY_PARSE EQUAL NUMBER  */
#line 1906 "core/cfg.y"
                                        { http_reply_parse=(yyvsp[0].intval); }
#line 8666 "core/cfg.tab.c"
    break;

  case 466: /* assign_stm: HTTP_REPLY_PARSE EQUAL error  */
#line 1907 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8672 "core/cfg.tab.c"
    break;

  case 467: /* assign_stm: VERBOSE_STARTUP EQUAL NUMBER  */
#line 1908 "core/cfg.y"
                                       { ksr_verbose_startup=(yyvsp[0].intval); }
#line 8678 "core/cfg.tab.c"
    break;

  case 468: /* assign_stm: VERBOSE_STARTUP EQUAL error  */
#line 1909 "core/cfg.y"
                                      { yyerror("boolean value expected"); }
#line 8684 "core/cfg.tab.c"
    break;

  case 469: /* assign_stm: ROUTE_LOCKS_SIZE EQUAL NUMBER  */
#line 1910 "core/cfg.y"
                                        { ksr_route_locks_size=(yyvsp[0].intval); }
#line 8690 "core/cfg.tab.c"
    break;

  case 470: /* assign_stm: ROUTE_LOCKS_SIZE EQUAL error  */
#line 1911 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 8696 "core/cfg.tab.c"
    break;

  case 471: /* assign_stm: WAIT_WORKER1_MODE EQUAL NUMBER  */
#line 1912 "core/cfg.y"
                                         { ksr_wait_worker1_mode=(yyvsp[0].intval); }
#line 8702 "core/cfg.tab.c"
    break;

  case 472: /* assign_stm: WAIT_WORKER1_MODE EQUAL error  */
#line 1913 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 8708 "core/cfg.tab.c"
    break;

  case 473: /* assign_stm: WAIT_WORKER1_TIME EQUAL NUMBER  */
#line 1914 "core/cfg.y"
                                         { ksr_wait_worker1_time=(yyvsp[0].intval); }
#line 8714 "core/cfg.tab.c"
    break;

  case 474: /* assign_stm: WAIT_WORKER1_TIME EQUAL error  */
#line 1915 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 8720 "core/cfg.tab.c"
    break;

  case 475: /* assign_stm: WAIT_WORKER1_USLEEP EQUAL NUMBER  */
#line 1916 "core/cfg.y"
                                           { ksr_wait_worker1_usleep=(yyvsp[0].intval); }
#line 8726 "core/cfg.tab.c"
    break;

  case 476: /* assign_stm: WAIT_WORKER1_USLEEP EQUAL error  */
#line 1917 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 8732 "core/cfg.tab.c"
    break;

  case 477: /* assign_stm: SERVER_ID EQUAL NUMBER  */
#line 1918 "core/cfg.y"
                             { server_id=(yyvsp[0].intval); }
#line 8738 "core/cfg.tab.c"
    break;

  case 478: /* assign_stm: SERVER_ID EQUAL error  */
#line 1919 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8744 "core/cfg.tab.c"
    break;

  case 479: /* assign_stm: RETURN_MODE EQUAL NUMBER  */
#line 1920 "core/cfg.y"
                               { ksr_return_mode=(yyvsp[0].intval); }
#line 8750 "core/cfg.tab.c"
    break;

  case 480: /* assign_stm: RETURN_MODE EQUAL error  */
#line 1921 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8756 "core/cfg.tab.c"
    break;

  case 481: /* assign_stm: KEMI DOT ONSEND_ROUTE_CALLBACK EQUAL STRING  */
#line 1922 "core/cfg.y"
                                                      {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 8770 "core/cfg.tab.c"
    break;

  case 482: /* assign_stm: KEMI DOT ONSEND_ROUTE_CALLBACK EQUAL error  */
#line 1931 "core/cfg.y"
                                                     { yyerror("string expected"); }
#line 8776 "core/cfg.tab.c"
    break;

  case 483: /* assign_stm: KEMI DOT REPLY_ROUTE_CALLBACK EQUAL STRING  */
#line 1932 "core/cfg.y"
                                                     {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 8790 "core/cfg.tab.c"
    break;

  case 484: /* assign_stm: KEMI DOT REPLY_ROUTE_CALLBACK EQUAL error  */
#line 1941 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 8796 "core/cfg.tab.c"
    break;

  case 485: /* assign_stm: KEMI DOT EVENT_ROUTE_CALLBACK EQUAL STRING  */
#line 1942 "core/cfg.y"
                                                     {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 8810 "core/cfg.tab.c"
    break;

  case 486: /* assign_stm: KEMI DOT EVENT_ROUTE_CALLBACK EQUAL error  */
#line 1951 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 8816 "core/cfg.tab.c"
    break;

  case 487: /* assign_stm: KEMI DOT RECEIVED_ROUTE_CALLBACK EQUAL STRING  */
#line 1952 "core/cfg.y"
                                                        {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 8830 "core/cfg.tab.c"
    break;

  case 488: /* assign_stm: KEMI DOT RECEIVED_ROUTE_CALLBACK EQUAL error  */
#line 1961 "core/cfg.y"
                                                       { yyerror("string expected"); }
#line 8836 "core/cfg.tab.c"
    break;

  case 489: /* assign_stm: KEMI DOT PRE_ROUTING_CALLBACK EQUAL STRING  */
#line 1962 "core/cfg.y"
                                                     {
			kemi_pre_routing_callback.s = (yyvsp[0].strval);
			kemi_pre_routing_callback.len = strlen((yyvsp[0].strval));
			if(kemi_pre_routing_callback.len==4
					&& strcasecmp(kemi_pre_routing_callback.s, "none")==0) {
				kemi_pre_routing_callback.s = "";
				kemi_pre_routing_callback.len = 0;
			}
		}
#line 8850 "core/cfg.tab.c"
    break;

  case 490: /* assign_stm: KEMI DOT PRE_ROUTING_CALLBACK EQUAL error  */
#line 1971 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 8856 "core/cfg.tab.c"
    break;

  case 491: /* assign_stm: RECEIVED_ROUTE_MODE EQUAL intno  */
#line 1972 "core/cfg.y"
                                      { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 8862 "core/cfg.tab.c"
    break;

  case 492: /* assign_stm: RECEIVED_ROUTE_MODE EQUAL error  */
#line 1973 "core/cfg.y"
                                           { yyerror("number  expected"); }
#line 8868 "core/cfg.tab.c"
    break;

  case 493: /* assign_stm: MAX_RECURSIVE_LEVEL EQUAL NUMBER  */
#line 1974 "core/cfg.y"
                                       { set_max_recursive_level((yyvsp[0].intval)); }
#line 8874 "core/cfg.tab.c"
    break;

  case 494: /* assign_stm: MAX_BRANCHES_PARAM EQUAL NUMBER  */
#line 1975 "core/cfg.y"
                                      { sr_dst_max_branches = (yyvsp[0].intval); }
#line 8880 "core/cfg.tab.c"
    break;

  case 495: /* assign_stm: LATENCY_LOG EQUAL intno  */
#line 1976 "core/cfg.y"
                              { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 8886 "core/cfg.tab.c"
    break;

  case 496: /* assign_stm: LATENCY_LOG EQUAL error  */
#line 1977 "core/cfg.y"
                                   { yyerror("number  expected"); }
#line 8892 "core/cfg.tab.c"
    break;

  case 497: /* assign_stm: LATENCY_CFG_LOG EQUAL intno  */
#line 1978 "core/cfg.y"
                                  { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 8898 "core/cfg.tab.c"
    break;

  case 498: /* assign_stm: LATENCY_CFG_LOG EQUAL error  */
#line 1979 "core/cfg.y"
                                       { yyerror("number  expected"); }
#line 8904 "core/cfg.tab.c"
    break;

  case 499: /* assign_stm: LATENCY_LIMIT_DB EQUAL NUMBER  */
#line 1980 "core/cfg.y"
                                    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 8910 "core/cfg.tab.c"
    break;

  case 500: /* assign_stm: LATENCY_LIMIT_DB EQUAL error  */
#line 1981 "core/cfg.y"
                                        { yyerror("number  expected"); }
#line 8916 "core/cfg.tab.c"
    break;

  case 501: /* assign_stm: LATENCY_LIMIT_ACTION EQUAL NUMBER  */
#line 1982 "core/cfg.y"
                                        { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 8922 "core/cfg.tab.c"
    break;

  case 502: /* assign_stm: LATENCY_LIMIT_ACTION EQUAL error  */
#line 1983 "core/cfg.y"
                                            { yyerror("number  expected"); }
#line 8928 "core/cfg.tab.c"
    break;

  case 503: /* assign_stm: LATENCY_LIMIT_CFG EQUAL NUMBER  */
#line 1984 "core/cfg.y"
                                     { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 8934 "core/cfg.tab.c"
    break;

  case 504: /* assign_stm: LATENCY_LIMIT_CFG EQUAL error  */
#line 1985 "core/cfg.y"
                                         { yyerror("number  expected"); }
#line 8940 "core/cfg.tab.c"
    break;

  case 505: /* assign_stm: RPC_EXEC_DELTA_CFG EQUAL NUMBER  */
#line 1986 "core/cfg.y"
                                      { ksr_rpc_exec_delta=(yyvsp[0].intval); }
#line 8946 "core/cfg.tab.c"
    break;

  case 506: /* assign_stm: RPC_EXEC_DELTA_CFG EQUAL error  */
#line 1987 "core/cfg.y"
                                          { yyerror("number  expected"); }
#line 8952 "core/cfg.tab.c"
    break;

  case 507: /* assign_stm: MSG_TIME EQUAL NUMBER  */
#line 1988 "core/cfg.y"
                            { sr_msg_time=(yyvsp[0].intval); }
#line 8958 "core/cfg.tab.c"
    break;

  case 508: /* assign_stm: MSG_TIME EQUAL error  */
#line 1989 "core/cfg.y"
                                { yyerror("number  expected"); }
#line 8964 "core/cfg.tab.c"
    break;

  case 509: /* assign_stm: ONSEND_RT_REPLY EQUAL NUMBER  */
#line 1990 "core/cfg.y"
                                       { onsend_route_reply=(yyvsp[0].intval); }
#line 8970 "core/cfg.tab.c"
    break;

  case 510: /* assign_stm: ONSEND_RT_REPLY EQUAL error  */
#line 1991 "core/cfg.y"
                                      { yyerror("int value expected"); }
#line 8976 "core/cfg.tab.c"
    break;

  case 511: /* assign_stm: UDP_MTU EQUAL NUMBER  */
#line 1992 "core/cfg.y"
                               { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 8982 "core/cfg.tab.c"
    break;

  case 512: /* assign_stm: UDP_MTU EQUAL error  */
#line 1993 "core/cfg.y"
                              { yyerror("number expected"); }
#line 8988 "core/cfg.tab.c"
    break;

  case 513: /* assign_stm: FORCE_RPORT EQUAL NUMBER  */
#line 1995 "core/cfg.y"
                { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8994 "core/cfg.tab.c"
    break;

  case 514: /* assign_stm: FORCE_RPORT EQUAL error  */
#line 1996 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 9000 "core/cfg.tab.c"
    break;

  case 515: /* assign_stm: LOCAL_RPORT EQUAL NUMBER  */
#line 1997 "core/cfg.y"
                                   { ksr_local_rport=(yyvsp[0].intval); }
#line 9006 "core/cfg.tab.c"
    break;

  case 516: /* assign_stm: LOCAL_RPORT EQUAL error  */
#line 1998 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 9012 "core/cfg.tab.c"
    break;

  case 517: /* assign_stm: UDP_MTU_TRY_PROTO EQUAL proto  */
#line 2000 "core/cfg.y"
                { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 9018 "core/cfg.tab.c"
    break;

  case 518: /* assign_stm: UDP_MTU_TRY_PROTO EQUAL error  */
#line 2002 "core/cfg.y"
                { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 9024 "core/cfg.tab.c"
    break;

  case 519: /* assign_stm: UDP4_RAW EQUAL intno  */
#line 2003 "core/cfg.y"
                               { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 9030 "core/cfg.tab.c"
    break;

  case 520: /* assign_stm: UDP4_RAW EQUAL error  */
#line 2004 "core/cfg.y"
                               { yyerror("number expected"); }
#line 9036 "core/cfg.tab.c"
    break;

  case 521: /* assign_stm: UDP4_RAW_MTU EQUAL NUMBER  */
#line 2005 "core/cfg.y"
                                    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 9044 "core/cfg.tab.c"
    break;

  case 522: /* assign_stm: UDP4_RAW_MTU EQUAL error  */
#line 2008 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 9050 "core/cfg.tab.c"
    break;

  case 523: /* assign_stm: UDP4_RAW_TTL EQUAL NUMBER  */
#line 2009 "core/cfg.y"
                                    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 9058 "core/cfg.tab.c"
    break;

  case 524: /* assign_stm: UDP4_RAW_TTL EQUAL error  */
#line 2012 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 9064 "core/cfg.tab.c"
    break;

  case 526: /* assign_stm: error EQUAL  */
#line 2014 "core/cfg.y"
                      { yyerror("unknown config variable"); }
#line 9070 "core/cfg.tab.c"
    break;

  case 528: /* cfg_var_id: DEFAULT  */
#line 2018 "core/cfg.y"
                  { (yyval.strval)="default" ; }
#line 9076 "core/cfg.tab.c"
    break;

  case 530: /* cfg_var_idn: DEFAULT  */
#line 2022 "core/cfg.y"
                  { (yyval.strval)="default" ; }
#line 9082 "core/cfg.tab.c"
    break;

  case 531: /* cfg_var_idn: NUMBER  */
#line 2023 "core/cfg.y"
                 {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 9092 "core/cfg.tab.c"
    break;

  case 532: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL NUMBER  */
#line 2031 "core/cfg.y"
                                                {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 9102 "core/cfg.tab.c"
    break;

  case 533: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL STRING  */
#line 2036 "core/cfg.y"
                                                  {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 9112 "core/cfg.tab.c"
    break;

  case 534: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL NUMBER CFG_DESCRIPTION STRING  */
#line 2041 "core/cfg.y"
                                                                         {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 9122 "core/cfg.tab.c"
    break;

  case 535: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL STRING CFG_DESCRIPTION STRING  */
#line 2046 "core/cfg.y"
                                                                         {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 9132 "core/cfg.tab.c"
    break;

  case 536: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL error  */
#line 2051 "core/cfg.y"
                                                 {
		yyerror("number or string expected");
	}
#line 9140 "core/cfg.tab.c"
    break;

  case 537: /* cfg_var: cfg_var_id LBRACK NUMBER RBRACK DOT cfg_var_idn EQUAL NUMBER  */
#line 2054 "core/cfg.y"
                                                                       {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 9150 "core/cfg.tab.c"
    break;

  case 538: /* cfg_var: cfg_var_id LBRACK NUMBER RBRACK DOT cfg_var_idn EQUAL STRING  */
#line 2059 "core/cfg.y"
                                                                       {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 9160 "core/cfg.tab.c"
    break;

  case 539: /* module_stm: LOADMODULE STRING  */
#line 2067 "core/cfg.y"
                          {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (ksr_load_module((yyvsp[0].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9171 "core/cfg.tab.c"
    break;

  case 540: /* module_stm: LOADMODULE LPAREN STRING RPAREN  */
#line 2073 "core/cfg.y"
                                          {
		LM_DBG("loading module %s\n", (yyvsp[-1].strval));
			if (ksr_load_module((yyvsp[-1].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9182 "core/cfg.tab.c"
    break;

  case 541: /* module_stm: LOADMODULE LPAREN STRING COMMA STRING RPAREN  */
#line 2079 "core/cfg.y"
                                                       {
		LM_DBG("loading module %s opts %s\n", (yyvsp[-3].strval), (yyvsp[-1].strval));
			if (ksr_load_module((yyvsp[-3].strval), (yyvsp[-1].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 9193 "core/cfg.tab.c"
    break;

  case 542: /* module_stm: LOADMODULE error  */
#line 2085 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9199 "core/cfg.tab.c"
    break;

  case 543: /* module_stm: LOADMODULEX STRING  */
#line 2086 "core/cfg.y"
                             {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (ksr_load_modulex((yyvsp[0].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9210 "core/cfg.tab.c"
    break;

  case 544: /* module_stm: LOADMODULEX LPAREN STRING RPAREN  */
#line 2092 "core/cfg.y"
                                           {
		LM_DBG("loading module %s\n", (yyvsp[-1].strval));
			if (ksr_load_modulex((yyvsp[-1].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9221 "core/cfg.tab.c"
    break;

  case 545: /* module_stm: LOADMODULEX LPAREN STRING COMMA STRING RPAREN  */
#line 2098 "core/cfg.y"
                                                        {
		LM_DBG("loading module %s opts %s\n", (yyvsp[-3].strval), (yyvsp[-1].strval));
			if (ksr_load_modulex((yyvsp[-3].strval), (yyvsp[-1].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 9232 "core/cfg.tab.c"
    break;

  case 546: /* module_stm: LOADMODULEX error  */
#line 2104 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9238 "core/cfg.tab.c"
    break;

  case 547: /* module_stm: LOADPATH STRING  */
#line 2105 "core/cfg.y"
                          {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 9253 "core/cfg.tab.c"
    break;

  case 548: /* module_stm: LOADPATH error  */
#line 2115 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9259 "core/cfg.tab.c"
    break;

  case 549: /* module_stm: LOADPATH EQUAL STRING  */
#line 2116 "core/cfg.y"
                                {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 9274 "core/cfg.tab.c"
    break;

  case 550: /* module_stm: LOADPATH EQUAL error  */
#line 2126 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9280 "core/cfg.tab.c"
    break;

  case 551: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 2127 "core/cfg.y"
                                                                  {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9294 "core/cfg.tab.c"
    break;

  case 552: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA intno RPAREN  */
#line 2136 "core/cfg.y"
                                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9308 "core/cfg.tab.c"
    break;

  case 553: /* module_stm: MODPARAM error  */
#line 2145 "core/cfg.y"
                         { yyerror("Invalid arguments"); }
#line 9314 "core/cfg.tab.c"
    break;

  case 554: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 2146 "core/cfg.y"
                                                                   {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9328 "core/cfg.tab.c"
    break;

  case 555: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA intno RPAREN  */
#line 2155 "core/cfg.y"
                                                                  {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9342 "core/cfg.tab.c"
    break;

  case 556: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA PVAR RPAREN  */
#line 2164 "core/cfg.y"
                                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_VAR, (void*)(yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9356 "core/cfg.tab.c"
    break;

  case 557: /* module_stm: MODPARAMX error  */
#line 2173 "core/cfg.y"
                          { yyerror("Invalid arguments"); }
#line 9362 "core/cfg.tab.c"
    break;

  case 558: /* module_stm: CFGENGINE STRING  */
#line 2174 "core/cfg.y"
                           {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9373 "core/cfg.tab.c"
    break;

  case 559: /* module_stm: CFGENGINE error  */
#line 2180 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9379 "core/cfg.tab.c"
    break;

  case 560: /* module_stm: CFGENGINE EQUAL STRING  */
#line 2181 "core/cfg.y"
                                 {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9390 "core/cfg.tab.c"
    break;

  case 561: /* module_stm: CFGENGINE EQUAL error  */
#line 2187 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9396 "core/cfg.tab.c"
    break;

  case 562: /* ip: ipv4  */
#line 2191 "core/cfg.y"
              { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9402 "core/cfg.tab.c"
    break;

  case 563: /* ip: ipv6  */
#line 2192 "core/cfg.y"
                { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9408 "core/cfg.tab.c"
    break;

  case 564: /* ipv4: NUMBER DOT NUMBER DOT NUMBER DOT NUMBER  */
#line 2195 "core/cfg.y"
                                                {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 9440 "core/cfg.tab.c"
    break;

  case 565: /* ipv6addr: IPV6ADDR  */
#line 2224 "core/cfg.y"
                 {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 9458 "core/cfg.tab.c"
    break;

  case 566: /* ipv6: ipv6addr  */
#line 2239 "core/cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9464 "core/cfg.tab.c"
    break;

  case 567: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 2240 "core/cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 9470 "core/cfg.tab.c"
    break;

  case 568: /* route_name: NUMBER  */
#line 2244 "core/cfg.y"
                                {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 9486 "core/cfg.tab.c"
    break;

  case 569: /* route_name: ID  */
#line 2255 "core/cfg.y"
                                                { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9492 "core/cfg.tab.c"
    break;

  case 570: /* route_name: STRING  */
#line 2256 "core/cfg.y"
                                        { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9498 "core/cfg.tab.c"
    break;

  case 571: /* route_main: ROUTE  */
#line 2260 "core/cfg.y"
                      { routename=NULL; }
#line 9504 "core/cfg.tab.c"
    break;

  case 572: /* route_main: ROUTE_REQUEST  */
#line 2261 "core/cfg.y"
                                  { routename=NULL; }
#line 9510 "core/cfg.tab.c"
    break;

  case 573: /* route_stm: route_main LBRACE actions RBRACE  */
#line 2265 "core/cfg.y"
                                         {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 9522 "core/cfg.tab.c"
    break;

  case 574: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2272 "core/cfg.y"
                                                               {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 9543 "core/cfg.tab.c"
    break;

  case 575: /* route_stm: ROUTE error  */
#line 2288 "core/cfg.y"
                      { yyerror("invalid  route  statement"); }
#line 9549 "core/cfg.tab.c"
    break;

  case 576: /* route_stm: ROUTE_REQUEST error  */
#line 2289 "core/cfg.y"
                              { yyerror("invalid  request_route  statement"); }
#line 9555 "core/cfg.tab.c"
    break;

  case 577: /* failure_route_main: ROUTE_FAILURE  */
#line 2292 "core/cfg.y"
                                  { routename=NULL; }
#line 9561 "core/cfg.tab.c"
    break;

  case 578: /* failure_route_stm: failure_route_main LBRACE actions RBRACE  */
#line 2295 "core/cfg.y"
                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 9573 "core/cfg.tab.c"
    break;

  case 579: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2302 "core/cfg.y"
                                                                       {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 9594 "core/cfg.tab.c"
    break;

  case 580: /* failure_route_stm: ROUTE_FAILURE error  */
#line 2318 "core/cfg.y"
                              { yyerror("invalid failure_route statement"); }
#line 9600 "core/cfg.tab.c"
    break;

  case 581: /* route_reply_main: ROUTE_ONREPLY  */
#line 2322 "core/cfg.y"
                                      { routename=NULL; }
#line 9606 "core/cfg.tab.c"
    break;

  case 582: /* route_reply_main: ROUTE_REPLY  */
#line 2323 "core/cfg.y"
                                { routename=NULL; }
#line 9612 "core/cfg.tab.c"
    break;

  case 583: /* $@7: %empty  */
#line 2328 "core/cfg.y"
                                {rt=CORE_ONREPLY_ROUTE;}
#line 9618 "core/cfg.tab.c"
    break;

  case 584: /* onreply_route_stm: route_reply_main LBRACE $@7 actions RBRACE  */
#line 2328 "core/cfg.y"
                                                                        {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 9630 "core/cfg.tab.c"
    break;

  case 585: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 2335 "core/cfg.y"
                              { yyerror("invalid onreply_route statement"); }
#line 9636 "core/cfg.tab.c"
    break;

  case 586: /* onreply_route_stm: ROUTE_REPLY error  */
#line 2336 "core/cfg.y"
                            { yyerror("invalid onreply_route statement"); }
#line 9642 "core/cfg.tab.c"
    break;

  case 587: /* $@8: %empty  */
#line 2338 "core/cfg.y"
                {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 9648 "core/cfg.tab.c"
    break;

  case 588: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK $@8 LBRACE actions RBRACE  */
#line 2339 "core/cfg.y"
                                      {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 9674 "core/cfg.tab.c"
    break;

  case 589: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK error  */
#line 2360 "core/cfg.y"
                                                       {
		yyerror("invalid onreply_route statement");
	}
#line 9682 "core/cfg.tab.c"
    break;

  case 590: /* branch_route_main: ROUTE_BRANCH  */
#line 2365 "core/cfg.y"
                                { routename=NULL; }
#line 9688 "core/cfg.tab.c"
    break;

  case 591: /* branch_route_stm: branch_route_main LBRACE actions RBRACE  */
#line 2368 "core/cfg.y"
                                                {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 9700 "core/cfg.tab.c"
    break;

  case 592: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2375 "core/cfg.y"
                                                                      {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 9721 "core/cfg.tab.c"
    break;

  case 593: /* branch_route_stm: ROUTE_BRANCH error  */
#line 2391 "core/cfg.y"
                             { yyerror("invalid branch_route statement"); }
#line 9727 "core/cfg.tab.c"
    break;

  case 594: /* send_route_main: ROUTE_SEND  */
#line 2394 "core/cfg.y"
                            { routename=NULL; }
#line 9733 "core/cfg.tab.c"
    break;

  case 595: /* send_route_stm: send_route_main LBRACE actions RBRACE  */
#line 2397 "core/cfg.y"
                                              {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 9745 "core/cfg.tab.c"
    break;

  case 596: /* send_route_stm: ROUTE_SEND LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2404 "core/cfg.y"
                                                                    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 9766 "core/cfg.tab.c"
    break;

  case 597: /* send_route_stm: ROUTE_SEND error  */
#line 2420 "core/cfg.y"
                           { yyerror("invalid onsend_route statement"); }
#line 9772 "core/cfg.tab.c"
    break;

  case 598: /* event_route_main: ROUTE_EVENT  */
#line 2423 "core/cfg.y"
                              { routename=NULL; }
#line 9778 "core/cfg.tab.c"
    break;

  case 599: /* event_route_stm: event_route_main LBRACK EVENT_RT_NAME RBRACK LBRACE actions RBRACE  */
#line 2426 "core/cfg.y"
                                                                           {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 9799 "core/cfg.tab.c"
    break;

  case 600: /* event_route_stm: ROUTE_EVENT error  */
#line 2443 "core/cfg.y"
                            { yyerror("invalid event_route statement"); }
#line 9805 "core/cfg.tab.c"
    break;

  case 601: /* preprocess_stm: SUBST STRING  */
#line 2446 "core/cfg.y"
                     { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 9811 "core/cfg.tab.c"
    break;

  case 602: /* preprocess_stm: SUBST error  */
#line 2447 "core/cfg.y"
                      { yyerror("invalid subst preprocess statement"); }
#line 9817 "core/cfg.tab.c"
    break;

  case 603: /* preprocess_stm: SUBSTDEF STRING  */
#line 2448 "core/cfg.y"
                          { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_NORMAL)<0) YYERROR; }
#line 9823 "core/cfg.tab.c"
    break;

  case 604: /* preprocess_stm: SUBSTDEF error  */
#line 2449 "core/cfg.y"
                         { yyerror("invalid substdef preprocess statement"); }
#line 9829 "core/cfg.tab.c"
    break;

  case 605: /* preprocess_stm: SUBSTDEFS STRING  */
#line 2450 "core/cfg.y"
                           { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_QUOTED)<0) YYERROR; }
#line 9835 "core/cfg.tab.c"
    break;

  case 606: /* preprocess_stm: SUBSTDEFS error  */
#line 2451 "core/cfg.y"
                          { yyerror("invalid substdefs preprocess statement"); }
#line 9841 "core/cfg.tab.c"
    break;

  case 607: /* equalop: EQUAL_T  */
#line 2473 "core/cfg.y"
                {(yyval.intval)=EQUAL_OP; }
#line 9847 "core/cfg.tab.c"
    break;

  case 608: /* equalop: DIFF  */
#line 2474 "core/cfg.y"
                {(yyval.intval)=DIFF_OP; }
#line 9853 "core/cfg.tab.c"
    break;

  case 609: /* equalop: STREQ  */
#line 2475 "core/cfg.y"
                {(yyval.intval)=EQUAL_OP; }
#line 9859 "core/cfg.tab.c"
    break;

  case 610: /* equalop: STRDIFF  */
#line 2476 "core/cfg.y"
                  {(yyval.intval)=DIFF_OP; }
#line 9865 "core/cfg.tab.c"
    break;

  case 611: /* cmpop: GT  */
#line 2479 "core/cfg.y"
                {(yyval.intval)=GT_OP; }
#line 9871 "core/cfg.tab.c"
    break;

  case 612: /* cmpop: LT  */
#line 2480 "core/cfg.y"
                {(yyval.intval)=LT_OP; }
#line 9877 "core/cfg.tab.c"
    break;

  case 613: /* cmpop: GTE  */
#line 2481 "core/cfg.y"
                {(yyval.intval)=GTE_OP; }
#line 9883 "core/cfg.tab.c"
    break;

  case 614: /* cmpop: LTE  */
#line 2482 "core/cfg.y"
                {(yyval.intval)=LTE_OP; }
#line 9889 "core/cfg.tab.c"
    break;

  case 615: /* strop: equalop  */
#line 2485 "core/cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 9895 "core/cfg.tab.c"
    break;

  case 616: /* strop: MATCH  */
#line 2486 "core/cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 9901 "core/cfg.tab.c"
    break;

  case 617: /* rve_equalop: EQUAL_T  */
#line 2492 "core/cfg.y"
                {(yyval.intval)=RVE_EQ_OP; }
#line 9907 "core/cfg.tab.c"
    break;

  case 618: /* rve_equalop: DIFF  */
#line 2493 "core/cfg.y"
                {(yyval.intval)=RVE_DIFF_OP; }
#line 9913 "core/cfg.tab.c"
    break;

  case 619: /* rve_equalop: INTEQ  */
#line 2494 "core/cfg.y"
                {(yyval.intval)=RVE_IEQ_OP; }
#line 9919 "core/cfg.tab.c"
    break;

  case 620: /* rve_equalop: INTDIFF  */
#line 2495 "core/cfg.y"
                  {(yyval.intval)=RVE_IDIFF_OP; }
#line 9925 "core/cfg.tab.c"
    break;

  case 621: /* rve_equalop: STREQ  */
#line 2496 "core/cfg.y"
                {(yyval.intval)=RVE_STREQ_OP; }
#line 9931 "core/cfg.tab.c"
    break;

  case 622: /* rve_equalop: STRDIFF  */
#line 2497 "core/cfg.y"
                  {(yyval.intval)=RVE_STRDIFF_OP; }
#line 9937 "core/cfg.tab.c"
    break;

  case 623: /* rve_equalop: MATCH  */
#line 2498 "core/cfg.y"
                {(yyval.intval)=RVE_MATCH_OP; }
#line 9943 "core/cfg.tab.c"
    break;

  case 624: /* rve_cmpop: GT  */
#line 2501 "core/cfg.y"
                {(yyval.intval)=RVE_GT_OP; }
#line 9949 "core/cfg.tab.c"
    break;

  case 625: /* rve_cmpop: LT  */
#line 2502 "core/cfg.y"
                {(yyval.intval)=RVE_LT_OP; }
#line 9955 "core/cfg.tab.c"
    break;

  case 626: /* rve_cmpop: GTE  */
#line 2503 "core/cfg.y"
                {(yyval.intval)=RVE_GTE_OP; }
#line 9961 "core/cfg.tab.c"
    break;

  case 627: /* rve_cmpop: LTE  */
#line 2504 "core/cfg.y"
                {(yyval.intval)=RVE_LTE_OP; }
#line 9967 "core/cfg.tab.c"
    break;

  case 628: /* uri_type: URI  */
#line 2511 "core/cfg.y"
                        {(yyval.intval)=URI_O;}
#line 9973 "core/cfg.tab.c"
    break;

  case 629: /* uri_type: FROM_URI  */
#line 2512 "core/cfg.y"
                        {(yyval.intval)=FROM_URI_O;}
#line 9979 "core/cfg.tab.c"
    break;

  case 630: /* uri_type: TO_URI  */
#line 2513 "core/cfg.y"
                        {(yyval.intval)=TO_URI_O;}
#line 9985 "core/cfg.tab.c"
    break;

  case 631: /* eint_op_onsend: SNDPORT  */
#line 2520 "core/cfg.y"
                                        { (yyval.intval)=SNDPORT_O; }
#line 9991 "core/cfg.tab.c"
    break;

  case 632: /* eint_op_onsend: TOPORT  */
#line 2521 "core/cfg.y"
                                        { (yyval.intval)=TOPORT_O; }
#line 9997 "core/cfg.tab.c"
    break;

  case 633: /* eint_op_onsend: SNDAF  */
#line 2522 "core/cfg.y"
                                        { (yyval.intval)=SNDAF_O; }
#line 10003 "core/cfg.tab.c"
    break;

  case 634: /* eint_op: SRCPORT  */
#line 2526 "core/cfg.y"
                                { (yyval.intval)=SRCPORT_O; }
#line 10009 "core/cfg.tab.c"
    break;

  case 635: /* eint_op: DSTPORT  */
#line 2527 "core/cfg.y"
                                        { (yyval.intval)=DSTPORT_O; }
#line 10015 "core/cfg.tab.c"
    break;

  case 636: /* eint_op: AF  */
#line 2528 "core/cfg.y"
                                                { (yyval.intval)=AF_O; }
#line 10021 "core/cfg.tab.c"
    break;

  case 637: /* eint_op: MSGLEN  */
#line 2529 "core/cfg.y"
                                        { (yyval.intval)=MSGLEN_O; }
#line 10027 "core/cfg.tab.c"
    break;

  case 639: /* eip_op_onsend: SNDIP  */
#line 2535 "core/cfg.y"
                                        { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 10033 "core/cfg.tab.c"
    break;

  case 640: /* eip_op_onsend: TOIP  */
#line 2536 "core/cfg.y"
                                        { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 10039 "core/cfg.tab.c"
    break;

  case 641: /* eip_op: SRCIP  */
#line 2539 "core/cfg.y"
                                { (yyval.intval)=SRCIP_O; }
#line 10045 "core/cfg.tab.c"
    break;

  case 642: /* eip_op: DSTIP  */
#line 2540 "core/cfg.y"
                                        { (yyval.intval)=DSTIP_O; }
#line 10051 "core/cfg.tab.c"
    break;

  case 644: /* exp_elem: METHOD strop rval_expr  */
#line 2548 "core/cfg.y"
                {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 10057 "core/cfg.tab.c"
    break;

  case 645: /* exp_elem: METHOD strop ID  */
#line 2550 "core/cfg.y"
                {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 10063 "core/cfg.tab.c"
    break;

  case 646: /* exp_elem: METHOD strop error  */
#line 2551 "core/cfg.y"
                             { (yyval.expr)=0; yyerror("string expected"); }
#line 10069 "core/cfg.tab.c"
    break;

  case 647: /* exp_elem: METHOD error  */
#line 2553 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 10075 "core/cfg.tab.c"
    break;

  case 648: /* exp_elem: uri_type strop rval_expr  */
#line 2555 "core/cfg.y"
                {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 10081 "core/cfg.tab.c"
    break;

  case 649: /* exp_elem: uri_type strop MYSELF  */
#line 2557 "core/cfg.y"
                {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 10087 "core/cfg.tab.c"
    break;

  case 650: /* exp_elem: uri_type strop error  */
#line 2559 "core/cfg.y"
                { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 10093 "core/cfg.tab.c"
    break;

  case 651: /* exp_elem: uri_type error  */
#line 2561 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 10099 "core/cfg.tab.c"
    break;

  case 652: /* exp_elem: eint_op cmpop rval_expr  */
#line 2562 "core/cfg.y"
                                           { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10105 "core/cfg.tab.c"
    break;

  case 653: /* exp_elem: eint_op equalop rval_expr  */
#line 2564 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10111 "core/cfg.tab.c"
    break;

  case 654: /* exp_elem: eint_op cmpop error  */
#line 2565 "core/cfg.y"
                                { (yyval.expr)=0; yyerror("number expected"); }
#line 10117 "core/cfg.tab.c"
    break;

  case 655: /* exp_elem: eint_op equalop error  */
#line 2566 "core/cfg.y"
                                { (yyval.expr)=0; yyerror("number expected"); }
#line 10123 "core/cfg.tab.c"
    break;

  case 656: /* exp_elem: eint_op error  */
#line 2567 "core/cfg.y"
                        { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 10129 "core/cfg.tab.c"
    break;

  case 657: /* exp_elem: PROTO equalop eqproto  */
#line 2569 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 10135 "core/cfg.tab.c"
    break;

  case 658: /* exp_elem: PROTO equalop rval_expr  */
#line 2571 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10141 "core/cfg.tab.c"
    break;

  case 659: /* exp_elem: PROTO equalop error  */
#line 2573 "core/cfg.y"
                { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 10147 "core/cfg.tab.c"
    break;

  case 660: /* exp_elem: SNDPROTO equalop eqproto  */
#line 2575 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 10153 "core/cfg.tab.c"
    break;

  case 661: /* exp_elem: SNDPROTO equalop rval_expr  */
#line 2577 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10159 "core/cfg.tab.c"
    break;

  case 662: /* exp_elem: SNDPROTO equalop error  */
#line 2579 "core/cfg.y"
                { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 10165 "core/cfg.tab.c"
    break;

  case 663: /* exp_elem: eip_op strop ipnet  */
#line 2580 "core/cfg.y"
                                           { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 10171 "core/cfg.tab.c"
    break;

  case 664: /* exp_elem: eip_op strop rval_expr  */
#line 2581 "core/cfg.y"
                                               {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_LONG)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 10212 "core/cfg.tab.c"
    break;

  case 665: /* exp_elem: eip_op strop host  */
#line 2618 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 10218 "core/cfg.tab.c"
    break;

  case 666: /* exp_elem: eip_op strop MYSELF  */
#line 2620 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 10224 "core/cfg.tab.c"
    break;

  case 667: /* exp_elem: eip_op strop error  */
#line 2622 "core/cfg.y"
                { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 10230 "core/cfg.tab.c"
    break;

  case 668: /* exp_elem: eip_op error  */
#line 2624 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 10236 "core/cfg.tab.c"
    break;

  case 669: /* exp_elem: MYSELF equalop uri_type  */
#line 2627 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 10242 "core/cfg.tab.c"
    break;

  case 670: /* exp_elem: MYSELF equalop eip_op  */
#line 2629 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 10248 "core/cfg.tab.c"
    break;

  case 671: /* exp_elem: MYSELF equalop error  */
#line 2631 "core/cfg.y"
                { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 10254 "core/cfg.tab.c"
    break;

  case 672: /* exp_elem: MYSELF error  */
#line 2632 "core/cfg.y"
                        { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 10260 "core/cfg.tab.c"
    break;

  case 673: /* ipnet: ip SLASH ip  */
#line 2636 "core/cfg.y"
                        { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 10266 "core/cfg.tab.c"
    break;

  case 674: /* ipnet: ip SLASH NUMBER  */
#line 2637 "core/cfg.y"
                          {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 10282 "core/cfg.tab.c"
    break;

  case 675: /* ipnet: ip  */
#line 2648 "core/cfg.y"
                { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 10288 "core/cfg.tab.c"
    break;

  case 676: /* ipnet: ip SLASH error  */
#line 2649 "core/cfg.y"
                         { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 10294 "core/cfg.tab.c"
    break;

  case 677: /* host: ID  */
#line 2653 "core/cfg.y"
           { (yyval.strval)=(yyvsp[0].strval); }
#line 10300 "core/cfg.tab.c"
    break;

  case 678: /* host: host DOT ID  */
#line 2654 "core/cfg.y"
                      {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10320 "core/cfg.tab.c"
    break;

  case 679: /* host: host MINUS ID  */
#line 2669 "core/cfg.y"
                        {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10340 "core/cfg.tab.c"
    break;

  case 680: /* host: host DOT error  */
#line 2684 "core/cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10346 "core/cfg.tab.c"
    break;

  case 681: /* host: host MINUS error  */
#line 2685 "core/cfg.y"
                           { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10352 "core/cfg.tab.c"
    break;

  case 684: /* host_if_id: NUMBER  */
#line 2690 "core/cfg.y"
                         {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				strcpy((yyval.strval), yy_number_str);
			}
		}
#line 10366 "core/cfg.tab.c"
    break;

  case 685: /* host_or_if: host_if_id  */
#line 2702 "core/cfg.y"
                   { (yyval.strval)=(yyvsp[0].strval); }
#line 10372 "core/cfg.tab.c"
    break;

  case 686: /* host_or_if: host_or_if DOT host_if_id  */
#line 2703 "core/cfg.y"
                                    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10392 "core/cfg.tab.c"
    break;

  case 687: /* host_or_if: host_or_if MINUS host_if_id  */
#line 2718 "core/cfg.y"
                                      {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10412 "core/cfg.tab.c"
    break;

  case 688: /* host_or_if: host_or_if DOT error  */
#line 2733 "core/cfg.y"
                               { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10419 "core/cfg.tab.c"
    break;

  case 689: /* host_or_if: host_or_if MINUS error  */
#line 2735 "core/cfg.y"
                                 { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10426 "core/cfg.tab.c"
    break;

  case 690: /* fcmd: cmd  */
#line 2742 "core/cfg.y"
            {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 10463 "core/cfg.tab.c"
    break;

  case 691: /* stm: action  */
#line 2784 "core/cfg.y"
                { (yyval.action)=(yyvsp[0].action); }
#line 10469 "core/cfg.tab.c"
    break;

  case 692: /* stm: LBRACE actions RBRACE  */
#line 2785 "core/cfg.y"
                                { (yyval.action)=(yyvsp[-1].action); }
#line 10475 "core/cfg.tab.c"
    break;

  case 693: /* actions: actions action  */
#line 2788 "core/cfg.y"
                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 10481 "core/cfg.tab.c"
    break;

  case 694: /* actions: action  */
#line 2789 "core/cfg.y"
                        {(yyval.action)=(yyvsp[0].action);}
#line 10487 "core/cfg.tab.c"
    break;

  case 695: /* actions: actions error  */
#line 2790 "core/cfg.y"
                        { (yyval.action)=0; yyerror("bad command"); }
#line 10493 "core/cfg.tab.c"
    break;

  case 696: /* action: fcmd SEMICOLON  */
#line 2793 "core/cfg.y"
                       {(yyval.action)=(yyvsp[-1].action);}
#line 10499 "core/cfg.tab.c"
    break;

  case 697: /* action: if_cmd  */
#line 2794 "core/cfg.y"
                 {(yyval.action)=(yyvsp[0].action);}
#line 10505 "core/cfg.tab.c"
    break;

  case 698: /* action: switch_cmd  */
#line 2795 "core/cfg.y"
                     {(yyval.action)=(yyvsp[0].action);}
#line 10511 "core/cfg.tab.c"
    break;

  case 699: /* action: while_cmd  */
#line 2796 "core/cfg.y"
                    { (yyval.action)=(yyvsp[0].action); }
#line 10517 "core/cfg.tab.c"
    break;

  case 700: /* action: ret_cmd SEMICOLON  */
#line 2797 "core/cfg.y"
                            { (yyval.action)=(yyvsp[-1].action); }
#line 10523 "core/cfg.tab.c"
    break;

  case 701: /* action: assign_action SEMICOLON  */
#line 2798 "core/cfg.y"
                                  {(yyval.action)=(yyvsp[-1].action);}
#line 10529 "core/cfg.tab.c"
    break;

  case 702: /* action: SEMICOLON  */
#line 2799 "core/cfg.y"
                                      {(yyval.action)=0;}
#line 10535 "core/cfg.tab.c"
    break;

  case 703: /* action: fcmd error  */
#line 2800 "core/cfg.y"
                     { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 10541 "core/cfg.tab.c"
    break;

  case 704: /* if_cmd: IF rval_expr stm  */
#line 2803 "core/cfg.y"
                                {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10554 "core/cfg.tab.c"
    break;

  case 705: /* if_cmd: IF rval_expr stm ELSE stm  */
#line 2811 "core/cfg.y"
                                        {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10567 "core/cfg.tab.c"
    break;

  case 706: /* ct_rval: rval_expr  */
#line 2821 "core/cfg.y"
                   {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_LONG){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 10587 "core/cfg.tab.c"
    break;

  case 707: /* single_case: CASE ct_rval COLON actions  */
#line 2838 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10599 "core/cfg.tab.c"
    break;

  case 708: /* single_case: CASE SLASH ct_rval COLON actions  */
#line 2845 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10611 "core/cfg.tab.c"
    break;

  case 709: /* single_case: CASE ct_rval COLON  */
#line 2852 "core/cfg.y"
                             {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10623 "core/cfg.tab.c"
    break;

  case 710: /* single_case: CASE SLASH ct_rval COLON  */
#line 2859 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10635 "core/cfg.tab.c"
    break;

  case 711: /* single_case: DEFAULT COLON actions  */
#line 2866 "core/cfg.y"
                                {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10645 "core/cfg.tab.c"
    break;

  case 712: /* single_case: DEFAULT COLON  */
#line 2871 "core/cfg.y"
                        {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10655 "core/cfg.tab.c"
    break;

  case 713: /* single_case: CASE error COLON actions  */
#line 2876 "core/cfg.y"
                                   { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10661 "core/cfg.tab.c"
    break;

  case 714: /* single_case: CASE SLASH error COLON actions  */
#line 2877 "core/cfg.y"
                                         { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10667 "core/cfg.tab.c"
    break;

  case 715: /* single_case: CASE error COLON  */
#line 2878 "core/cfg.y"
                           { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10673 "core/cfg.tab.c"
    break;

  case 716: /* single_case: CASE SLASH error COLON  */
#line 2879 "core/cfg.y"
                                 { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10679 "core/cfg.tab.c"
    break;

  case 717: /* single_case: CASE ct_rval COLON error  */
#line 2880 "core/cfg.y"
                                   { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 10685 "core/cfg.tab.c"
    break;

  case 718: /* case_stms: case_stms single_case  */
#line 2883 "core/cfg.y"
                              {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 10699 "core/cfg.tab.c"
    break;

  case 719: /* case_stms: single_case  */
#line 2892 "core/cfg.y"
                      {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 10709 "core/cfg.tab.c"
    break;

  case 720: /* switch_cmd: SWITCH rval_expr LBRACE case_stms RBRACE  */
#line 2899 "core/cfg.y"
                                                   {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10739 "core/cfg.tab.c"
    break;

  case 721: /* switch_cmd: SWITCH rval_expr LBRACE RBRACE  */
#line 2924 "core/cfg.y"
                                         {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10760 "core/cfg.tab.c"
    break;

  case 722: /* switch_cmd: SWITCH error  */
#line 2940 "core/cfg.y"
                       { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 10766 "core/cfg.tab.c"
    break;

  case 723: /* switch_cmd: SWITCH rval_expr LBRACE error RBRACE  */
#line 2942 "core/cfg.y"
                {(yyval.action)=0; yyerror ("bad switch body"); }
#line 10772 "core/cfg.tab.c"
    break;

  case 724: /* while_cmd: WHILE rval_expr stm  */
#line 2946 "core/cfg.y"
                            {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 10787 "core/cfg.tab.c"
    break;

  case 725: /* select_param: ID  */
#line 2965 "core/cfg.y"
           {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 10801 "core/cfg.tab.c"
    break;

  case 726: /* select_param: ID LBRACK intno RBRACK  */
#line 2974 "core/cfg.y"
                                 {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 10818 "core/cfg.tab.c"
    break;

  case 727: /* select_param: ID LBRACK STRING RBRACK  */
#line 2986 "core/cfg.y"
                                  {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 10836 "core/cfg.tab.c"
    break;

  case 730: /* $@9: %empty  */
#line 3005 "core/cfg.y"
                    { sel.n = 0; sel.f[0] = 0; }
#line 10842 "core/cfg.tab.c"
    break;

  case 731: /* select_id: SELECT_MARK $@9 select_params  */
#line 3005 "core/cfg.y"
                                                               {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 10855 "core/cfg.tab.c"
    break;

  case 732: /* attr_class_spec: ATTR_FROM  */
#line 3015 "core/cfg.y"
                  { s_attr->type |= AVP_TRACK_FROM; }
#line 10861 "core/cfg.tab.c"
    break;

  case 733: /* attr_class_spec: ATTR_TO  */
#line 3016 "core/cfg.y"
                  { s_attr->type |= AVP_TRACK_TO; }
#line 10867 "core/cfg.tab.c"
    break;

  case 734: /* attr_class_spec: ATTR_FROMURI  */
#line 3017 "core/cfg.y"
                       { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 10873 "core/cfg.tab.c"
    break;

  case 735: /* attr_class_spec: ATTR_TOURI  */
#line 3018 "core/cfg.y"
                     { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 10879 "core/cfg.tab.c"
    break;

  case 736: /* attr_class_spec: ATTR_FROMUSER  */
#line 3019 "core/cfg.y"
                        { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 10885 "core/cfg.tab.c"
    break;

  case 737: /* attr_class_spec: ATTR_TOUSER  */
#line 3020 "core/cfg.y"
                      { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 10891 "core/cfg.tab.c"
    break;

  case 738: /* attr_class_spec: ATTR_FROMDOMAIN  */
#line 3021 "core/cfg.y"
                          { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 10897 "core/cfg.tab.c"
    break;

  case 739: /* attr_class_spec: ATTR_TODOMAIN  */
#line 3022 "core/cfg.y"
                        { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 10903 "core/cfg.tab.c"
    break;

  case 740: /* attr_class_spec: ATTR_GLOBAL  */
#line 3023 "core/cfg.y"
                      { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 10909 "core/cfg.tab.c"
    break;

  case 741: /* attr_name_spec: ID  */
#line 3026 "core/cfg.y"
           { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 10915 "core/cfg.tab.c"
    break;

  case 744: /* attr_mark: ATTR_MARK  */
#line 3033 "core/cfg.y"
                  {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else { memset(s_attr, 0, (sizeof(struct avp_spec))); }
	}
#line 10925 "core/cfg.tab.c"
    break;

  case 745: /* attr_id: attr_mark attr_spec  */
#line 3040 "core/cfg.y"
                            { (yyval.attr) = s_attr; }
#line 10931 "core/cfg.tab.c"
    break;

  case 746: /* attr_id_num_idx: attr_mark attr_spec LBRACK intno RBRACK  */
#line 3043 "core/cfg.y"
                                                {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 10941 "core/cfg.tab.c"
    break;

  case 747: /* attr_id_no_idx: attr_mark attr_spec LBRACK RBRACK  */
#line 3050 "core/cfg.y"
                                          {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 10950 "core/cfg.tab.c"
    break;

  case 754: /* attr_id_any_str: avp_pvar  */
#line 3072 "core/cfg.y"
                   {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 10967 "core/cfg.tab.c"
    break;

  case 755: /* attr_id_any_str: STRING  */
#line 3084 "core/cfg.y"
                 {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 10994 "core/cfg.tab.c"
    break;

  case 756: /* pvar: PVAR  */
#line 3108 "core/cfg.y"
             {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 11008 "core/cfg.tab.c"
    break;

  case 757: /* avp_pvar: AVP_OR_PVAR  */
#line 3119 "core/cfg.y"
                            {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 11034 "core/cfg.tab.c"
    break;

  case 758: /* assign_op: EQUAL  */
#line 3150 "core/cfg.y"
              { (yyval.intval) = ASSIGN_T; }
#line 11040 "core/cfg.tab.c"
    break;

  case 759: /* lval: attr_id_ass  */
#line 3154 "core/cfg.y"
                  {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 11055 "core/cfg.tab.c"
    break;

  case 760: /* lval: pvar  */
#line 3164 "core/cfg.y"
                      {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 11074 "core/cfg.tab.c"
    break;

  case 761: /* lval: avp_pvar  */
#line 3178 "core/cfg.y"
                      {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 11089 "core/cfg.tab.c"
    break;

  case 762: /* rval: intno  */
#line 3190 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_LONG, (void*)(yyvsp[0].intval)); }
#line 11095 "core/cfg.tab.c"
    break;

  case 763: /* rval: STRING  */
#line 3191 "core/cfg.y"
                                        {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 11102 "core/cfg.tab.c"
    break;

  case 764: /* rval: attr_id_any  */
#line 3193 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 11108 "core/cfg.tab.c"
    break;

  case 765: /* rval: pvar  */
#line 3194 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 11114 "core/cfg.tab.c"
    break;

  case 766: /* rval: avp_pvar  */
#line 3195 "core/cfg.y"
                                        {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 11133 "core/cfg.tab.c"
    break;

  case 767: /* rval: select_id  */
#line 3209 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 11139 "core/cfg.tab.c"
    break;

  case 768: /* rval: fcmd  */
#line 3210 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 11145 "core/cfg.tab.c"
    break;

  case 769: /* rval: exp_elem  */
#line 3211 "core/cfg.y"
                   { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 11151 "core/cfg.tab.c"
    break;

  case 770: /* rval: LBRACE actions RBRACE  */
#line 3212 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 11157 "core/cfg.tab.c"
    break;

  case 771: /* rval: LBRACE error RBRACE  */
#line 3213 "core/cfg.y"
                                { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 11163 "core/cfg.tab.c"
    break;

  case 772: /* rval: LPAREN assign_action RPAREN  */
#line 3214 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 11169 "core/cfg.tab.c"
    break;

  case 773: /* rval: LPAREN error RPAREN  */
#line 3215 "core/cfg.y"
                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11175 "core/cfg.tab.c"
    break;

  case 774: /* rve_un_op: NOT  */
#line 3219 "core/cfg.y"
                { (yyval.intval)=RVE_LNOT_OP; }
#line 11181 "core/cfg.tab.c"
    break;

  case 775: /* rve_un_op: BIN_NOT  */
#line 3220 "core/cfg.y"
                                { (yyval.intval)=RVE_BNOT_OP; }
#line 11187 "core/cfg.tab.c"
    break;

  case 776: /* rve_un_op: MINUS  */
#line 3221 "core/cfg.y"
                                        { (yyval.intval)=RVE_UMINUS_OP; }
#line 11193 "core/cfg.tab.c"
    break;

  case 777: /* rval_expr: rval  */
#line 3234 "core/cfg.y"
                                                        { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 11204 "core/cfg.tab.c"
    break;

  case 778: /* rval_expr: rve_un_op rval_expr  */
#line 3240 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 11210 "core/cfg.tab.c"
    break;

  case 779: /* rval_expr: INTCAST rval_expr  */
#line 3241 "core/cfg.y"
                                                                {(yyval.rv_expr)=mk_rve1(RVE_LONG_OP, (yyvsp[0].rv_expr)); }
#line 11216 "core/cfg.tab.c"
    break;

  case 780: /* rval_expr: STRCAST rval_expr  */
#line 3242 "core/cfg.y"
                                                                {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 11222 "core/cfg.tab.c"
    break;

  case 781: /* rval_expr: rval_expr PLUS rval_expr  */
#line 3243 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11228 "core/cfg.tab.c"
    break;

  case 782: /* rval_expr: rval_expr MINUS rval_expr  */
#line 3244 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11234 "core/cfg.tab.c"
    break;

  case 783: /* rval_expr: rval_expr STAR rval_expr  */
#line 3245 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11240 "core/cfg.tab.c"
    break;

  case 784: /* rval_expr: rval_expr SLASH rval_expr  */
#line 3246 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11246 "core/cfg.tab.c"
    break;

  case 785: /* rval_expr: rval_expr MODULO rval_expr  */
#line 3247 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11252 "core/cfg.tab.c"
    break;

  case 786: /* rval_expr: rval_expr BIN_OR rval_expr  */
#line 3248 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 11258 "core/cfg.tab.c"
    break;

  case 787: /* rval_expr: rval_expr BIN_AND rval_expr  */
#line 3249 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11264 "core/cfg.tab.c"
    break;

  case 788: /* rval_expr: rval_expr BIN_XOR rval_expr  */
#line 3250 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11270 "core/cfg.tab.c"
    break;

  case 789: /* rval_expr: rval_expr BIN_LSHIFT rval_expr  */
#line 3251 "core/cfg.y"
                                                 {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11276 "core/cfg.tab.c"
    break;

  case 790: /* rval_expr: rval_expr BIN_RSHIFT rval_expr  */
#line 3252 "core/cfg.y"
                                                 {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11282 "core/cfg.tab.c"
    break;

  case 791: /* rval_expr: rval_expr rve_cmpop rval_expr  */
#line 3253 "core/cfg.y"
                                                         { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11288 "core/cfg.tab.c"
    break;

  case 792: /* rval_expr: rval_expr rve_equalop rval_expr  */
#line 3254 "core/cfg.y"
                                                                {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 11311 "core/cfg.tab.c"
    break;

  case 793: /* rval_expr: rval_expr LOG_AND rval_expr  */
#line 3272 "core/cfg.y"
                                                { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11317 "core/cfg.tab.c"
    break;

  case 794: /* rval_expr: rval_expr LOG_OR rval_expr  */
#line 3273 "core/cfg.y"
                                                { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11323 "core/cfg.tab.c"
    break;

  case 795: /* rval_expr: LPAREN rval_expr RPAREN  */
#line 3274 "core/cfg.y"
                                                        { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 11329 "core/cfg.tab.c"
    break;

  case 796: /* rval_expr: STRLEN LPAREN rval_expr RPAREN  */
#line 3275 "core/cfg.y"
                                                 { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 11335 "core/cfg.tab.c"
    break;

  case 797: /* rval_expr: STREMPTY LPAREN rval_expr RPAREN  */
#line 3276 "core/cfg.y"
                                                   {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 11341 "core/cfg.tab.c"
    break;

  case 798: /* rval_expr: DEFINED rval_expr  */
#line 3277 "core/cfg.y"
                                                                { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 11347 "core/cfg.tab.c"
    break;

  case 799: /* rval_expr: SELVAL LPAREN rval_expr COMMA rval_expr COMMA rval_expr RPAREN  */
#line 3278 "core/cfg.y"
                                                                                 {
				rve_tmp=mk_rve2(RVE_SELVALOPT_OP, (yyvsp[-3].rv_expr), (yyvsp[-1].rv_expr));
				if(rve_tmp == NULL) {
					(yyval.rv_expr)=0;
					yyerror("failed to create tenary target expression");
				}
				(yyval.rv_expr)=mk_rve2(RVE_SELVALEXP_OP, (yyvsp[-5].rv_expr), rve_tmp);
		}
#line 11360 "core/cfg.tab.c"
    break;

  case 800: /* rval_expr: rve_un_op error  */
#line 3286 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11366 "core/cfg.tab.c"
    break;

  case 801: /* rval_expr: INTCAST error  */
#line 3287 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11372 "core/cfg.tab.c"
    break;

  case 802: /* rval_expr: STRCAST error  */
#line 3288 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11378 "core/cfg.tab.c"
    break;

  case 803: /* rval_expr: rval_expr PLUS error  */
#line 3289 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11384 "core/cfg.tab.c"
    break;

  case 804: /* rval_expr: rval_expr MINUS error  */
#line 3290 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11390 "core/cfg.tab.c"
    break;

  case 805: /* rval_expr: rval_expr STAR error  */
#line 3291 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11396 "core/cfg.tab.c"
    break;

  case 806: /* rval_expr: rval_expr SLASH error  */
#line 3292 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11402 "core/cfg.tab.c"
    break;

  case 807: /* rval_expr: rval_expr MODULO error  */
#line 3293 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11408 "core/cfg.tab.c"
    break;

  case 808: /* rval_expr: rval_expr BIN_OR error  */
#line 3294 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11414 "core/cfg.tab.c"
    break;

  case 809: /* rval_expr: rval_expr BIN_AND error  */
#line 3295 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11420 "core/cfg.tab.c"
    break;

  case 810: /* rval_expr: rval_expr rve_cmpop error  */
#line 3297 "core/cfg.y"
                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11426 "core/cfg.tab.c"
    break;

  case 811: /* rval_expr: rval_expr rve_equalop error  */
#line 3299 "core/cfg.y"
                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11432 "core/cfg.tab.c"
    break;

  case 812: /* rval_expr: rval_expr LOG_AND error  */
#line 3300 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11438 "core/cfg.tab.c"
    break;

  case 813: /* rval_expr: rval_expr LOG_OR error  */
#line 3301 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11444 "core/cfg.tab.c"
    break;

  case 814: /* rval_expr: STRLEN LPAREN error RPAREN  */
#line 3302 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11450 "core/cfg.tab.c"
    break;

  case 815: /* rval_expr: STREMPTY LPAREN error RPAREN  */
#line 3303 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11456 "core/cfg.tab.c"
    break;

  case 816: /* rval_expr: SELVAL LPAREN error RPAREN  */
#line 3304 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11462 "core/cfg.tab.c"
    break;

  case 817: /* rval_expr: DEFINED error  */
#line 3305 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11468 "core/cfg.tab.c"
    break;

  case 818: /* assign_action: lval assign_op rval_expr  */
#line 3308 "core/cfg.y"
                                                { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 11477 "core/cfg.tab.c"
    break;

  case 819: /* avpflag_oper: SETAVPFLAG  */
#line 3326 "core/cfg.y"
                   { (yyval.intval) = 1; }
#line 11483 "core/cfg.tab.c"
    break;

  case 820: /* avpflag_oper: RESETAVPFLAG  */
#line 3327 "core/cfg.y"
                       { (yyval.intval) = 0; }
#line 11489 "core/cfg.tab.c"
    break;

  case 821: /* avpflag_oper: ISAVPFLAGSET  */
#line 3328 "core/cfg.y"
                       { (yyval.intval) = -1; }
#line 11495 "core/cfg.tab.c"
    break;

  case 822: /* cmd: FORWARD LPAREN RPAREN  */
#line 3331 "core/cfg.y"
                              { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11501 "core/cfg.tab.c"
    break;

  case 823: /* cmd: FORWARD LPAREN host RPAREN  */
#line 3332 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11507 "core/cfg.tab.c"
    break;

  case 824: /* cmd: FORWARD LPAREN STRING RPAREN  */
#line 3333 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11513 "core/cfg.tab.c"
    break;

  case 825: /* cmd: FORWARD LPAREN ip RPAREN  */
#line 3334 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11519 "core/cfg.tab.c"
    break;

  case 826: /* cmd: FORWARD LPAREN host COMMA NUMBER RPAREN  */
#line 3335 "core/cfg.y"
                                                  { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11525 "core/cfg.tab.c"
    break;

  case 827: /* cmd: FORWARD LPAREN STRING COMMA NUMBER RPAREN  */
#line 3336 "core/cfg.y"
                                                    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11531 "core/cfg.tab.c"
    break;

  case 828: /* cmd: FORWARD LPAREN ip COMMA NUMBER RPAREN  */
#line 3337 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11537 "core/cfg.tab.c"
    break;

  case 829: /* cmd: FORWARD LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3338 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11543 "core/cfg.tab.c"
    break;

  case 830: /* cmd: FORWARD LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3339 "core/cfg.y"
                                                     {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11549 "core/cfg.tab.c"
    break;

  case 831: /* cmd: FORWARD LPAREN URIHOST RPAREN  */
#line 3340 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11555 "core/cfg.tab.c"
    break;

  case 832: /* cmd: FORWARD error  */
#line 3341 "core/cfg.y"
                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11561 "core/cfg.tab.c"
    break;

  case 833: /* cmd: FORWARD LPAREN error RPAREN  */
#line 3342 "core/cfg.y"
                                      { (yyval.action)=0; yyerror("bad forward argument"); }
#line 11567 "core/cfg.tab.c"
    break;

  case 834: /* cmd: FORWARD_UDP LPAREN host RPAREN  */
#line 3343 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11573 "core/cfg.tab.c"
    break;

  case 835: /* cmd: FORWARD_UDP LPAREN STRING RPAREN  */
#line 3344 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11579 "core/cfg.tab.c"
    break;

  case 836: /* cmd: FORWARD_UDP LPAREN ip RPAREN  */
#line 3345 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11585 "core/cfg.tab.c"
    break;

  case 837: /* cmd: FORWARD_UDP LPAREN host COMMA NUMBER RPAREN  */
#line 3346 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11591 "core/cfg.tab.c"
    break;

  case 838: /* cmd: FORWARD_UDP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3347 "core/cfg.y"
                                                        {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11597 "core/cfg.tab.c"
    break;

  case 839: /* cmd: FORWARD_UDP LPAREN ip COMMA NUMBER RPAREN  */
#line 3348 "core/cfg.y"
                                                    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11603 "core/cfg.tab.c"
    break;

  case 840: /* cmd: FORWARD_UDP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3349 "core/cfg.y"
                                                          {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11609 "core/cfg.tab.c"
    break;

  case 841: /* cmd: FORWARD_UDP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3350 "core/cfg.y"
                                                         { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11615 "core/cfg.tab.c"
    break;

  case 842: /* cmd: FORWARD_UDP LPAREN URIHOST RPAREN  */
#line 3351 "core/cfg.y"
                                            { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11621 "core/cfg.tab.c"
    break;

  case 843: /* cmd: FORWARD_UDP error  */
#line 3352 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11627 "core/cfg.tab.c"
    break;

  case 844: /* cmd: FORWARD_UDP LPAREN error RPAREN  */
#line 3353 "core/cfg.y"
                                          { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 11633 "core/cfg.tab.c"
    break;

  case 845: /* cmd: FORWARD_TCP LPAREN host RPAREN  */
#line 3354 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11639 "core/cfg.tab.c"
    break;

  case 846: /* cmd: FORWARD_TCP LPAREN STRING RPAREN  */
#line 3355 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11645 "core/cfg.tab.c"
    break;

  case 847: /* cmd: FORWARD_TCP LPAREN ip RPAREN  */
#line 3356 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11651 "core/cfg.tab.c"
    break;

  case 848: /* cmd: FORWARD_TCP LPAREN host COMMA NUMBER RPAREN  */
#line 3357 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11657 "core/cfg.tab.c"
    break;

  case 849: /* cmd: FORWARD_TCP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3358 "core/cfg.y"
                                                        {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11663 "core/cfg.tab.c"
    break;

  case 850: /* cmd: FORWARD_TCP LPAREN ip COMMA NUMBER RPAREN  */
#line 3359 "core/cfg.y"
                                                    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11669 "core/cfg.tab.c"
    break;

  case 851: /* cmd: FORWARD_TCP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3360 "core/cfg.y"
                                                          {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11675 "core/cfg.tab.c"
    break;

  case 852: /* cmd: FORWARD_TCP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3361 "core/cfg.y"
                                                         { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11681 "core/cfg.tab.c"
    break;

  case 853: /* cmd: FORWARD_TCP LPAREN URIHOST RPAREN  */
#line 3362 "core/cfg.y"
                                            { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11687 "core/cfg.tab.c"
    break;

  case 854: /* cmd: FORWARD_TCP error  */
#line 3363 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11693 "core/cfg.tab.c"
    break;

  case 855: /* cmd: FORWARD_TCP LPAREN error RPAREN  */
#line 3364 "core/cfg.y"
                                          { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 11699 "core/cfg.tab.c"
    break;

  case 856: /* cmd: FORWARD_TLS LPAREN host RPAREN  */
#line 3365 "core/cfg.y"
                                         {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11712 "core/cfg.tab.c"
    break;

  case 857: /* cmd: FORWARD_TLS LPAREN STRING RPAREN  */
#line 3373 "core/cfg.y"
                                           {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11725 "core/cfg.tab.c"
    break;

  case 858: /* cmd: FORWARD_TLS LPAREN ip RPAREN  */
#line 3381 "core/cfg.y"
                                        {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11738 "core/cfg.tab.c"
    break;

  case 859: /* cmd: FORWARD_TLS LPAREN host COMMA NUMBER RPAREN  */
#line 3389 "core/cfg.y"
                                                      {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11751 "core/cfg.tab.c"
    break;

  case 860: /* cmd: FORWARD_TLS LPAREN STRING COMMA NUMBER RPAREN  */
#line 3397 "core/cfg.y"
                                                        {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11764 "core/cfg.tab.c"
    break;

  case 861: /* cmd: FORWARD_TLS LPAREN ip COMMA NUMBER RPAREN  */
#line 3405 "core/cfg.y"
                                                    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 11777 "core/cfg.tab.c"
    break;

  case 862: /* cmd: FORWARD_TLS LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3413 "core/cfg.y"
                                                          {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11790 "core/cfg.tab.c"
    break;

  case 863: /* cmd: FORWARD_TLS LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3421 "core/cfg.y"
                                                         {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11803 "core/cfg.tab.c"
    break;

  case 864: /* cmd: FORWARD_TLS LPAREN URIHOST RPAREN  */
#line 3429 "core/cfg.y"
                                            {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11816 "core/cfg.tab.c"
    break;

  case 865: /* cmd: FORWARD_TLS error  */
#line 3437 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11822 "core/cfg.tab.c"
    break;

  case 866: /* cmd: FORWARD_TLS LPAREN error RPAREN  */
#line 3438 "core/cfg.y"
                                          { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 11829 "core/cfg.tab.c"
    break;

  case 867: /* cmd: FORWARD_SCTP LPAREN host RPAREN  */
#line 3440 "core/cfg.y"
                                          {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11842 "core/cfg.tab.c"
    break;

  case 868: /* cmd: FORWARD_SCTP LPAREN STRING RPAREN  */
#line 3448 "core/cfg.y"
                                            {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11855 "core/cfg.tab.c"
    break;

  case 869: /* cmd: FORWARD_SCTP LPAREN ip RPAREN  */
#line 3456 "core/cfg.y"
                                        {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11868 "core/cfg.tab.c"
    break;

  case 870: /* cmd: FORWARD_SCTP LPAREN host COMMA NUMBER RPAREN  */
#line 3464 "core/cfg.y"
                                                       {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11882 "core/cfg.tab.c"
    break;

  case 871: /* cmd: FORWARD_SCTP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3473 "core/cfg.y"
                                                         {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11896 "core/cfg.tab.c"
    break;

  case 872: /* cmd: FORWARD_SCTP LPAREN ip COMMA NUMBER RPAREN  */
#line 3482 "core/cfg.y"
                                                     {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 11910 "core/cfg.tab.c"
    break;

  case 873: /* cmd: FORWARD_SCTP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3491 "core/cfg.y"
                                                           {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11923 "core/cfg.tab.c"
    break;

  case 874: /* cmd: FORWARD_SCTP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3499 "core/cfg.y"
                                                          {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11937 "core/cfg.tab.c"
    break;

  case 875: /* cmd: FORWARD_SCTP LPAREN URIHOST RPAREN  */
#line 3508 "core/cfg.y"
                                             {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11950 "core/cfg.tab.c"
    break;

  case 876: /* cmd: FORWARD_SCTP error  */
#line 3516 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11956 "core/cfg.tab.c"
    break;

  case 877: /* cmd: FORWARD_SCTP LPAREN error RPAREN  */
#line 3517 "core/cfg.y"
                                           { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 11963 "core/cfg.tab.c"
    break;

  case 878: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 3519 "core/cfg.y"
                                        {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 11971 "core/cfg.tab.c"
    break;

  case 879: /* cmd: LOG_TOK LPAREN NUMBER COMMA STRING RPAREN  */
#line 3522 "core/cfg.y"
                                                        {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11977 "core/cfg.tab.c"
    break;

  case 880: /* cmd: LOG_TOK error  */
#line 3523 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11983 "core/cfg.tab.c"
    break;

  case 881: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 3524 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("bad log argument"); }
#line 11989 "core/cfg.tab.c"
    break;

  case 882: /* cmd: SETFLAG LPAREN NUMBER RPAREN  */
#line 3525 "core/cfg.y"
                                        {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12001 "core/cfg.tab.c"
    break;

  case 883: /* cmd: SETFLAG LPAREN flag_name RPAREN  */
#line 3532 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12013 "core/cfg.tab.c"
    break;

  case 884: /* cmd: SETFLAG error  */
#line 3539 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12019 "core/cfg.tab.c"
    break;

  case 885: /* cmd: RESETFLAG LPAREN NUMBER RPAREN  */
#line 3540 "core/cfg.y"
                                         {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12030 "core/cfg.tab.c"
    break;

  case 886: /* cmd: RESETFLAG LPAREN flag_name RPAREN  */
#line 3546 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12042 "core/cfg.tab.c"
    break;

  case 887: /* cmd: RESETFLAG error  */
#line 3553 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12048 "core/cfg.tab.c"
    break;

  case 888: /* cmd: ISFLAGSET LPAREN NUMBER RPAREN  */
#line 3554 "core/cfg.y"
                                         {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12059 "core/cfg.tab.c"
    break;

  case 889: /* cmd: ISFLAGSET LPAREN flag_name RPAREN  */
#line 3560 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12071 "core/cfg.tab.c"
    break;

  case 890: /* cmd: ISFLAGSET error  */
#line 3567 "core/cfg.y"
                          { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12077 "core/cfg.tab.c"
    break;

  case 891: /* cmd: avpflag_oper LPAREN attr_id_any_str COMMA flag_name RPAREN  */
#line 3568 "core/cfg.y"
                                                                     {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 12088 "core/cfg.tab.c"
    break;

  case 892: /* cmd: avpflag_oper LPAREN attr_id_any_str COMMA error RPAREN  */
#line 3574 "core/cfg.y"
                                                                 {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 12096 "core/cfg.tab.c"
    break;

  case 893: /* cmd: avpflag_oper LPAREN error COMMA flag_name RPAREN  */
#line 3577 "core/cfg.y"
                                                           {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 12104 "core/cfg.tab.c"
    break;

  case 894: /* cmd: avpflag_oper LPAREN error RPAREN  */
#line 3580 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad parameters"); }
#line 12110 "core/cfg.tab.c"
    break;

  case 895: /* cmd: avpflag_oper error  */
#line 3581 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12116 "core/cfg.tab.c"
    break;

  case 896: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 3582 "core/cfg.y"
                                                  {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 12124 "core/cfg.tab.c"
    break;

  case 897: /* cmd: ERROR error  */
#line 3585 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12130 "core/cfg.tab.c"
    break;

  case 898: /* cmd: ERROR LPAREN error RPAREN  */
#line 3586 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad error argument"); }
#line 12136 "core/cfg.tab.c"
    break;

  case 899: /* cmd: ROUTE LPAREN rval_expr RPAREN  */
#line 3587 "core/cfg.y"
                                        {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 12150 "core/cfg.tab.c"
    break;

  case 900: /* cmd: ROUTE LPAREN ID RPAREN  */
#line 3596 "core/cfg.y"
                                        {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 12164 "core/cfg.tab.c"
    break;

  case 901: /* cmd: ROUTE error  */
#line 3605 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12170 "core/cfg.tab.c"
    break;

  case 902: /* cmd: ROUTE LPAREN error RPAREN  */
#line 3606 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad route argument"); }
#line 12176 "core/cfg.tab.c"
    break;

  case 903: /* cmd: EXEC LPAREN STRING RPAREN  */
#line 3607 "core/cfg.y"
                                        { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12182 "core/cfg.tab.c"
    break;

  case 904: /* cmd: SET_HOST LPAREN STRING RPAREN  */
#line 3608 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12188 "core/cfg.tab.c"
    break;

  case 905: /* cmd: SET_HOST error  */
#line 3609 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12194 "core/cfg.tab.c"
    break;

  case 906: /* cmd: SET_HOST LPAREN error RPAREN  */
#line 3610 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12200 "core/cfg.tab.c"
    break;

  case 907: /* cmd: PREFIX LPAREN STRING RPAREN  */
#line 3611 "core/cfg.y"
                                      { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12206 "core/cfg.tab.c"
    break;

  case 908: /* cmd: PREFIX error  */
#line 3612 "core/cfg.y"
                       { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12212 "core/cfg.tab.c"
    break;

  case 909: /* cmd: PREFIX LPAREN error RPAREN  */
#line 3613 "core/cfg.y"
                                     { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12218 "core/cfg.tab.c"
    break;

  case 910: /* cmd: STRIP_TAIL LPAREN NUMBER RPAREN  */
#line 3614 "core/cfg.y"
                                          { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12224 "core/cfg.tab.c"
    break;

  case 911: /* cmd: STRIP_TAIL error  */
#line 3615 "core/cfg.y"
                           { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12230 "core/cfg.tab.c"
    break;

  case 912: /* cmd: STRIP_TAIL LPAREN error RPAREN  */
#line 3616 "core/cfg.y"
                                         { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12236 "core/cfg.tab.c"
    break;

  case 913: /* cmd: STRIP LPAREN NUMBER RPAREN  */
#line 3617 "core/cfg.y"
                                     { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12242 "core/cfg.tab.c"
    break;

  case 914: /* cmd: STRIP error  */
#line 3618 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12248 "core/cfg.tab.c"
    break;

  case 915: /* cmd: STRIP LPAREN error RPAREN  */
#line 3619 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12254 "core/cfg.tab.c"
    break;

  case 916: /* cmd: SET_USERPHONE LPAREN RPAREN  */
#line 3620 "core/cfg.y"
                                      { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 12260 "core/cfg.tab.c"
    break;

  case 917: /* cmd: SET_USERPHONE error  */
#line 3621 "core/cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12266 "core/cfg.tab.c"
    break;

  case 918: /* cmd: REMOVE_BRANCH LPAREN intno RPAREN  */
#line 3622 "core/cfg.y"
                                            {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 12275 "core/cfg.tab.c"
    break;

  case 919: /* cmd: REMOVE_BRANCH LPAREN RPAREN  */
#line 3626 "core/cfg.y"
                                      {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 12284 "core/cfg.tab.c"
    break;

  case 920: /* cmd: REMOVE_BRANCH error  */
#line 3630 "core/cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12290 "core/cfg.tab.c"
    break;

  case 921: /* cmd: REMOVE_BRANCH LPAREN error RPAREN  */
#line 3631 "core/cfg.y"
                                            { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12296 "core/cfg.tab.c"
    break;

  case 922: /* cmd: CLEAR_BRANCHES LPAREN RPAREN  */
#line 3632 "core/cfg.y"
                                       { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 12302 "core/cfg.tab.c"
    break;

  case 923: /* cmd: SET_HOSTPORT LPAREN STRING RPAREN  */
#line 3633 "core/cfg.y"
                                            { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12308 "core/cfg.tab.c"
    break;

  case 924: /* cmd: SET_HOSTPORT error  */
#line 3634 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12314 "core/cfg.tab.c"
    break;

  case 925: /* cmd: SET_HOSTPORT LPAREN error RPAREN  */
#line 3635 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12320 "core/cfg.tab.c"
    break;

  case 926: /* cmd: SET_HOSTPORTTRANS LPAREN STRING RPAREN  */
#line 3636 "core/cfg.y"
                                                 { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12326 "core/cfg.tab.c"
    break;

  case 927: /* cmd: SET_HOSTPORTTRANS error  */
#line 3637 "core/cfg.y"
                                  { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12332 "core/cfg.tab.c"
    break;

  case 928: /* cmd: SET_HOSTPORTTRANS LPAREN error RPAREN  */
#line 3638 "core/cfg.y"
                                                { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12338 "core/cfg.tab.c"
    break;

  case 929: /* cmd: SET_PORT LPAREN STRING RPAREN  */
#line 3639 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12344 "core/cfg.tab.c"
    break;

  case 930: /* cmd: SET_PORT error  */
#line 3640 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12350 "core/cfg.tab.c"
    break;

  case 931: /* cmd: SET_PORT LPAREN error RPAREN  */
#line 3641 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12356 "core/cfg.tab.c"
    break;

  case 932: /* cmd: SET_USER LPAREN STRING RPAREN  */
#line 3642 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12362 "core/cfg.tab.c"
    break;

  case 933: /* cmd: SET_USER error  */
#line 3643 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12368 "core/cfg.tab.c"
    break;

  case 934: /* cmd: SET_USER LPAREN error RPAREN  */
#line 3644 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12374 "core/cfg.tab.c"
    break;

  case 935: /* cmd: SET_USERPASS LPAREN STRING RPAREN  */
#line 3645 "core/cfg.y"
                                            { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12380 "core/cfg.tab.c"
    break;

  case 936: /* cmd: SET_USERPASS error  */
#line 3646 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12386 "core/cfg.tab.c"
    break;

  case 937: /* cmd: SET_USERPASS LPAREN error RPAREN  */
#line 3647 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12392 "core/cfg.tab.c"
    break;

  case 938: /* cmd: SET_URI LPAREN STRING RPAREN  */
#line 3648 "core/cfg.y"
                                       { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12398 "core/cfg.tab.c"
    break;

  case 939: /* cmd: SET_URI error  */
#line 3649 "core/cfg.y"
                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12404 "core/cfg.tab.c"
    break;

  case 940: /* cmd: SET_URI LPAREN error RPAREN  */
#line 3650 "core/cfg.y"
                                      { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12410 "core/cfg.tab.c"
    break;

  case 941: /* cmd: REVERT_URI LPAREN RPAREN  */
#line 3651 "core/cfg.y"
                                   { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12416 "core/cfg.tab.c"
    break;

  case 942: /* cmd: REVERT_URI  */
#line 3652 "core/cfg.y"
                     { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12422 "core/cfg.tab.c"
    break;

  case 943: /* cmd: FORCE_RPORT LPAREN RPAREN  */
#line 3653 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12428 "core/cfg.tab.c"
    break;

  case 944: /* cmd: FORCE_RPORT  */
#line 3654 "core/cfg.y"
                        {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12434 "core/cfg.tab.c"
    break;

  case 945: /* cmd: ADD_LOCAL_RPORT LPAREN RPAREN  */
#line 3655 "core/cfg.y"
                                        { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12440 "core/cfg.tab.c"
    break;

  case 946: /* cmd: ADD_LOCAL_RPORT  */
#line 3656 "core/cfg.y"
                                {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12446 "core/cfg.tab.c"
    break;

  case 947: /* cmd: FORCE_TCP_ALIAS LPAREN NUMBER RPAREN  */
#line 3657 "core/cfg.y"
                                                {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12459 "core/cfg.tab.c"
    break;

  case 948: /* cmd: FORCE_TCP_ALIAS LPAREN RPAREN  */
#line 3665 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12472 "core/cfg.tab.c"
    break;

  case 949: /* cmd: FORCE_TCP_ALIAS  */
#line 3673 "core/cfg.y"
                                                        {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12485 "core/cfg.tab.c"
    break;

  case 950: /* cmd: FORCE_TCP_ALIAS LPAREN error RPAREN  */
#line 3681 "core/cfg.y"
                                                {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12491 "core/cfg.tab.c"
    break;

  case 951: /* cmd: UDP_MTU_TRY_PROTO LPAREN proto RPAREN  */
#line 3683 "core/cfg.y"
                { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12497 "core/cfg.tab.c"
    break;

  case 952: /* cmd: UDP_MTU_TRY_PROTO LPAREN error RPAREN  */
#line 3685 "core/cfg.y"
                { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 12503 "core/cfg.tab.c"
    break;

  case 953: /* cmd: SET_ADV_ADDRESS LPAREN listen_id RPAREN  */
#line 3686 "core/cfg.y"
                                                  {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 12519 "core/cfg.tab.c"
    break;

  case 954: /* cmd: SET_ADV_ADDRESS LPAREN error RPAREN  */
#line 3697 "core/cfg.y"
                                              { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12525 "core/cfg.tab.c"
    break;

  case 955: /* cmd: SET_ADV_ADDRESS error  */
#line 3698 "core/cfg.y"
                                {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12531 "core/cfg.tab.c"
    break;

  case 956: /* cmd: SET_ADV_PORT LPAREN NUMBER RPAREN  */
#line 3699 "core/cfg.y"
                                            {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 12552 "core/cfg.tab.c"
    break;

  case 957: /* cmd: SET_ADV_PORT LPAREN error RPAREN  */
#line 3715 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12558 "core/cfg.tab.c"
    break;

  case 958: /* cmd: SET_ADV_PORT error  */
#line 3716 "core/cfg.y"
                              {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12564 "core/cfg.tab.c"
    break;

  case 959: /* cmd: FORCE_SEND_SOCKET LPAREN phostport RPAREN  */
#line 3717 "core/cfg.y"
                                                    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 12573 "core/cfg.tab.c"
    break;

  case 960: /* cmd: FORCE_SEND_SOCKET LPAREN error RPAREN  */
#line 3721 "core/cfg.y"
                                                {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 12581 "core/cfg.tab.c"
    break;

  case 961: /* cmd: FORCE_SEND_SOCKET error  */
#line 3724 "core/cfg.y"
                                  {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12587 "core/cfg.tab.c"
    break;

  case 962: /* cmd: SET_FWD_NO_CONNECT LPAREN RPAREN  */
#line 3725 "core/cfg.y"
                                                {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12595 "core/cfg.tab.c"
    break;

  case 963: /* cmd: SET_FWD_NO_CONNECT  */
#line 3728 "core/cfg.y"
                                {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12603 "core/cfg.tab.c"
    break;

  case 964: /* cmd: SET_RPL_NO_CONNECT LPAREN RPAREN  */
#line 3731 "core/cfg.y"
                                                {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12611 "core/cfg.tab.c"
    break;

  case 965: /* cmd: SET_RPL_NO_CONNECT  */
#line 3734 "core/cfg.y"
                                {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12619 "core/cfg.tab.c"
    break;

  case 966: /* cmd: SET_FWD_CLOSE LPAREN RPAREN  */
#line 3737 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12627 "core/cfg.tab.c"
    break;

  case 967: /* cmd: SET_FWD_CLOSE  */
#line 3740 "core/cfg.y"
                        {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12635 "core/cfg.tab.c"
    break;

  case 968: /* cmd: SET_RPL_CLOSE LPAREN RPAREN  */
#line 3743 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12643 "core/cfg.tab.c"
    break;

  case 969: /* cmd: SET_RPL_CLOSE  */
#line 3746 "core/cfg.y"
                        {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12651 "core/cfg.tab.c"
    break;

  case 970: /* cmd: CFG_SELECT LPAREN STRING COMMA NUMBER RPAREN  */
#line 3749 "core/cfg.y"
                                                       {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 12659 "core/cfg.tab.c"
    break;

  case 971: /* cmd: CFG_SELECT LPAREN STRING COMMA rval_expr RPAREN  */
#line 3752 "core/cfg.y"
                                                          {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 12667 "core/cfg.tab.c"
    break;

  case 972: /* cmd: CFG_SELECT error  */
#line 3755 "core/cfg.y"
                           { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12673 "core/cfg.tab.c"
    break;

  case 973: /* cmd: CFG_SELECT LPAREN error RPAREN  */
#line 3756 "core/cfg.y"
                                         { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 12679 "core/cfg.tab.c"
    break;

  case 974: /* cmd: CFG_RESET LPAREN STRING RPAREN  */
#line 3757 "core/cfg.y"
                                         {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 12687 "core/cfg.tab.c"
    break;

  case 975: /* cmd: CFG_RESET error  */
#line 3760 "core/cfg.y"
                          { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12693 "core/cfg.tab.c"
    break;

  case 976: /* cmd: CFG_RESET LPAREN error RPAREN  */
#line 3761 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 12699 "core/cfg.tab.c"
    break;

  case 977: /* $@10: %empty  */
#line 3762 "core/cfg.y"
             {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			ksr_exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 12712 "core/cfg.tab.c"
    break;

  case 978: /* cmd: ID $@10 LPAREN func_params RPAREN  */
#line 3769 "core/cfg.y"
                                                {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				/* free_mod_func_action(mod_func_action); */
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 12743 "core/cfg.tab.c"
    break;

  case 979: /* cmd: ID error  */
#line 3795 "core/cfg.y"
                                                        { yyerror("'('')' expected (function call)");}
#line 12749 "core/cfg.tab.c"
    break;

  case 981: /* func_params: func_params COMMA func_param  */
#line 3799 "core/cfg.y"
                                       { }
#line 12755 "core/cfg.tab.c"
    break;

  case 982: /* func_params: func_param  */
#line 3800 "core/cfg.y"
                     {}
#line 12761 "core/cfg.tab.c"
    break;

  case 983: /* func_param: rval_expr  */
#line 3803 "core/cfg.y"
                  {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 12780 "core/cfg.tab.c"
    break;

  case 984: /* ret_cmd: DROP LPAREN RPAREN  */
#line 3820 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12789 "core/cfg.tab.c"
    break;

  case 985: /* ret_cmd: DROP rval_expr  */
#line 3824 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12798 "core/cfg.tab.c"
    break;

  case 986: /* ret_cmd: DROP  */
#line 3828 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12807 "core/cfg.tab.c"
    break;

  case 987: /* ret_cmd: EXIT LPAREN RPAREN  */
#line 3832 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12817 "core/cfg.tab.c"
    break;

  case 988: /* ret_cmd: EXIT rval_expr  */
#line 3837 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12826 "core/cfg.tab.c"
    break;

  case 989: /* ret_cmd: EXIT  */
#line 3841 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12836 "core/cfg.tab.c"
    break;

  case 990: /* ret_cmd: RETURN  */
#line 3846 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 12845 "core/cfg.tab.c"
    break;

  case 991: /* ret_cmd: RETURN LPAREN RPAREN  */
#line 3850 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 12854 "core/cfg.tab.c"
    break;

  case 992: /* ret_cmd: RETURN rval_expr  */
#line 3854 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12863 "core/cfg.tab.c"
    break;

  case 993: /* ret_cmd: BREAK  */
#line 3858 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12872 "core/cfg.tab.c"
    break;


#line 12876 "core/cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 3864 "core/cfg.y"


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
	if(ksr_all_errors==0) {
		ksr_exit(-1);
	}
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_LONG && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct name_lst));
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no corresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
